*****************************************************
* GEN 4-DIGIT OCCUPATION SHARES AT THE NATIONAL LEVEL 
*****************************************************

clear all 
set more off 
cap log close 

global tipo first 
global c    1
global t    1
global geo  fuaX

use ${dta}/IV_hh_index_contratto_${tipo}_${geo}_tipo${c}_tenure${t}.dta, clear 
* drop markets with missing occupation or geographical area 
drop if mi(contratto_ID_occ_${tipo}_c) | mi(${geo})

ren year anno 
* gen number of new hirest at the occupation-by-year level
collapse (sum) tot_new_hire, by(anno contratto_ID_occ_${tipo}_c)
bys anno: egen tot = total(tot_new_hire) // gen number of new hires at the year level
gen double shocc = tot_new_hire/tot // gen occupation shares among new hires in each year
keep anno contratto_ID_occ_${tipo}_c shocc 


save ${dta}/sh_occupation_${tipo}_${geo}_tipo${c}_tenure${t}.dta, replace 


   
