*THIS CODE:

*[1] OPENS THE YEAR-SPECIFIC FILES idanupd.X.dta (WHERE X IS THE YEAR) GENERATED IN THE PREVIOUS STEPS;
*[2] IMPOSES SOME DATA RESTRICTIONS DETAILED IN THE ARTCILE;
*[3] GENERATES THE LABOUR MARKET CONCENTRATION INDEX, FIRST FOR 4-DIGIT ISCO CODES, THEN FOR 2-DIGIT AND 3-DIGIT ISCO CODES ("D"ISCO IN DENMARK).

local aggregateL cvr komcvr 
local zoneL fuaX dep fua1

*DISCO 4

foreach m of numlist 1 {
foreach x of numlist 2 {
	disp `x'
	foreach zone of loc zoneL {
		foreach aggregate of loc aggregateL {
			clear
		
			gen year = ""
			save HHI\HHI`x'_HP_`aggregate'`zone'_pcs4`m', replace
					
			foreach year in 10 11 12 13 14 15 16 17 18 {
					
				disp "`aggregate'"
				disp "`year'"
				
				local year_1 = `year' - 1
				di `year_1'
				
				use idanupd`year_1', clear
				drop if type_2008 == "E"
				keep cvr pnr kom
				rename kom kom_prev_
				duplicates drop pnr cvr kom, force
				by pnr cvr, sort: gen counter = _n
				reshape wide kom_prev_, i(pnr cvr) j(counter)
				sort pnr cvr
				tempfile prev_year
				save `prev_year', replace				
				
				*PART I*
			
				use idanupd`year', clear
				
				*drop non employees
				*DROP THE SELF-EMPLOYED
				drop if type_2008 == "S"

				*keep industries & nbhours>0
				*DROP AGRICULTURAL, PUBLIC SECTOR, AND HOUSEHOLD WORKERS WITH SOME EXCEPTIONS (e.g., RECREATIONAL ACTIVITIES)
				drop if arb_hoved_bra_db07 < 51000
				drop if (arb_hoved_bra_db07 >= 840000 & arb_hoved_bra_db07 < 900000) | (arb_hoved_bra_db07 >= 910000 & arb_hoved_bra_db07 < 920000) | arb_hoved_bra_db07 >= 970000
								
				drop if loentimer == 0

				*PEOPLE WHO MOVED WITHIN THE SAME COMPANY
					
				if "`aggregate'" == "cvr" {
				
				gen not_new_hire = (ansxtilb == "T1" | ansxtilb == "T2")
				drop if ansxtilb == "U" & ansaar == `year' /*INCONSISTENCY BETWEEN ANSAAR AND ANSXTILB*/				
				
				}
				
				if "`aggregate'" == "komcvr" {
				
				preserve
				keep if ansxtilb == "T1" | ansxtilb == "T2"
				sort pnr cvr
				merge pnr cvr using `prev_year'
				tab _m
				drop if _m == 2
				drop _m
				gen transf_within_munic = (kom == kom_prev_1)
				capture replace transf_within_munic = 1 if (kom == kom_prev_2) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_3) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_4) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_5) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_6) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_7) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_8) 
				tab transf_within_munic
				
				tempfile transfers
				save `transfers', replace
				restore

				count
				drop if ansxtilb == "T1" | ansxtilb == "T2"
				count
				append using `transfers'
				count
												
				gen not_new_hire = (ansxtilb == "T1" | ansxtilb == "T2") & transf_within_munic == 1

				drop transf_within_munic
				count				
				drop if ansxtilb == "U" & ansaar == `year' /*INCONSISTENCY BETWEEN ANSAAR AND ANSXTILB*/
				
				}
				
				
				*headcount 		
				gen headcount = 1
				
				**** define new hires
				**** case 0: no filtering
				
				if `m' == 0 {
				
				if `x' == 2 {
				*construction of the indicators for presence in November of the current year and absence in November of the previous year
				*(in Denmark this can be done by checking whether the variable "year of first employment", ansaar, takes value equal to the current year)

				gen P0 = 1
				gen Hire = (ansaar == `year') & not_new_hire != 1
				sum Hire
							
				disp `x' " 2"
				}
				}

				if `m' == 1 {
				
				if `x' == 2 {
				*construction of the indicators for presence in November of the current year and absence in November of the previous year
				*(in Denmark this can be done by checking whether the variable "year of first employment", ansaar, takes value equal to the current year)

				gen P0 = 1
				gen Hire = (ansaar == `year') & not_new_hire != 1
				replace Hire = . if ansdage_2008 < 30
							
				disp `x' " 2"
				}
				}
				
				*cleanup occupational data
				tostring disco_kode, replace
				replace disco_kode=upper(disco_kode)
				replace disco_kode = substr(disco_kode, 1, 4)
					
				gen pcs = disco_kode
				drop if mi(pcs)
								
				*collapsing at the local labour market level
				collapse (sum) Z_E = Hire headcount Z_P0 = P0, by(`zone' pcs)
			
				sort `zone' pcs
				save idanupd_P_pcs4, replace
				
				*PART II*
			
				use idanupd`year', clear

				*drop non employees
				*DROP THE SELF-EMPLOYED
				drop if type_2008 == "S"

				*keep industries & nbhours>0
				*DROP AGRICULTURAL, PUBLIC SECTOR, AND HOUSEHOLD WORKERS WITH SOME EXCEPTIONS (e.g., RECREATIONAL ACTIVITIES)
				drop if arb_hoved_bra_db07 < 51000
				drop if (arb_hoved_bra_db07 >= 840000 & arb_hoved_bra_db07 < 900000) | (arb_hoved_bra_db07 >= 910000 & arb_hoved_bra_db07 < 920000) | arb_hoved_bra_db07 >= 970000
				
				drop if loentimer == 0
				
				*PEOPLE WHO MOVED WITHIN THE SAME COMPANY

				if "`aggregate'" == "cvr" {
				
				gen not_new_hire = (ansxtilb == "T1" | ansxtilb == "T2")
				drop if ansxtilb == "U" & ansaar == `year' /*INCONSISTENCY BETWEEN ANSAAR AND ANSXTILB*/				
				
				}

				if "`aggregate'" == "komcvr" {
				
				preserve
				keep if ansxtilb == "T1" | ansxtilb == "T2"
				sort pnr cvr
				merge pnr cvr using `prev_year'
				tab _m
				drop if _m == 2
				drop _m
				gen transf_within_munic = (kom == kom_prev_1)
				capture replace transf_within_munic = 1 if (kom == kom_prev_2) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_3) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_4) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_5) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_6) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_7) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_8) 
				tab transf_within_munic
				
				tempfile transfers
				save `transfers', replace
				restore

				count
				drop if ansxtilb == "T1" | ansxtilb == "T2"
				count
				append using `transfers'
				count
								
				gen not_new_hire = (ansxtilb == "T1" | ansxtilb == "T2") & transf_within_munic == 1
				drop transf_within_munic
				count				
				drop if ansxtilb == "U" & ansaar == `year' /*INCONSISTENCY BETWEEN ANSAAR AND ANSXTILB*/

				}
				
				if `m' == 0 {
				
				if `x' == 2 {
				*construction of the indicators for presence in November of the current year and absence in November of the previous year
				*(in Denmark this can be done by checking whether the variable "year of first employment", ansaar, takes value equal to the current year)

				gen P0 = 1
				gen Hire = (ansaar == `year')  & not_new_hire != 1
				sum Hire
							
				disp `x' " 3"
				}
				}
				
				if `m' == 1 {
				
				if `x' == 2 {
				*construction of the indicators for presence in November of the current year and absence in November of the previous year
				*(in Denmark this can be done by checking whether the variable "year of first employment", ansaar, takes value equal to the current year)

				gen P0 = 1
				gen Hire = (ansaar == `year') & not_new_hire != 1
				replace Hire = . if ansdage_2008 < 30
											
				disp `x' " 3"
				}
				}			
			
				*cleanup occupational data
				tostring disco_kode, replace
				replace disco_kode = upper(disco_kode)
				replace disco_kode = substr(disco_kode, 1, 4)
			
				gen pcs = disco_kode
				drop if mi(pcs)
				
				*collapsing at the firm level
				collapse (sum) Hire P0, by(`aggregate' `zone' pcs)
				
				*merge with local labour market aggregates
				merge m:1 `zone' pcs using idanupd_P_pcs4

				*squared shares of new hires
				gen Share_E=(Hire/Z_E)^2
				
				*squared shares of employment
				gen EmpH = (P0/Z_P0)^2
				
				*drop further errors in the occupation and geographical are variables, if any
				drop if pcs=="."
				drop if `zone'==""
			
				*set a counter of the number of hiring firms
				gen nb_Dm=1 if Hire!=.&Hire!=0
				
				*set a counter for employing firms
				gen nb_E=1 if P0!=.&P0!=0
			
				*aggregating at the LLM level and setting a year counter
				gen Hmax=sqrt(Share_E)
				gen Emax=sqrt(EmpH)
				
				collapse (sum) nb_Dm nb_E Share_E EmpH (mean) Z_E headcount Z_P0 (max) Hmax Emax, by(`zone' pcs)
			
				gen year = "`year'"
			
				*append to previous years, if any
				append using HHI\HHI`x'_HP_`aggregate'`zone'_pcs4`m'
				*saving
				drop if year == ""
				save HHI\HHI`x'_HP_`aggregate'`zone'_pcs4`m', replace
 			}
		
		}
		
	}
		
}
}

*DISCO 2

local aggregateL cvr komcvr 
local zoneL fuaX fua1

foreach m of numlist 1 {
foreach x of numlist 2 {
	disp `x'
	foreach zone of loc zoneL {
		foreach aggregate of loc aggregateL {
			clear
		
			gen year = ""
			save HHI\HHI`x'_HP_`aggregate'`zone'_pcs2`m'_DISCO2, replace
					
			foreach year in 11 12 13 14 15 16 17 18 {
					
				disp "`aggregate'"
				disp "`year'"
				
				local year_1 = `year' - 1
				di `year_1'
				
				use idanupd`year_1', clear
				drop if type_2008 == "E"
				keep cvr pnr kom
				rename kom kom_prev_
				duplicates drop pnr cvr kom, force
				by pnr cvr, sort: gen counter = _n
				reshape wide kom_prev_, i(pnr cvr) j(counter)
				sort pnr cvr
				tempfile prev_year
				save `prev_year', replace				
				
				*PART I*
			
				use idanupd`year', clear
				
				*drop non employees
				*DROP THE SELF-EMPLOYED
				drop if type_2008 == "S"

				*keep industries & nbhours>0
				*DROP AGRICULTURAL, PUBLIC SECTOR, AND HOUSEHOLD WORKERS WITH SOME EXCEPTIONS (e.g., RECREATIONAL ACTIVITIES)
				drop if arb_hoved_bra_db07 < 51000
				drop if (arb_hoved_bra_db07 >= 840000 & arb_hoved_bra_db07 < 900000) | (arb_hoved_bra_db07 >= 910000 & arb_hoved_bra_db07 < 920000) | arb_hoved_bra_db07 >= 970000
								
				drop if loentimer == 0

				*PEOPLE WHO MOVED WITHIN THE SAME COMPANY
					
				if "`aggregate'" == "cvr" {
				
				gen not_new_hire = (ansxtilb == "T1" | ansxtilb == "T2")
				drop if ansxtilb == "U" & ansaar == `year' /*INCONSISTENCY BETWEEN ANSAAR AND ANSXTILB*/				
				
				}
				
				if "`aggregate'" == "komcvr" {
				
				preserve
				keep if ansxtilb == "T1" | ansxtilb == "T2"
				sort pnr cvr
				merge pnr cvr using `prev_year'
				tab _m
				drop if _m == 2
				drop _m
				gen transf_within_munic = (kom == kom_prev_1)
				capture replace transf_within_munic = 1 if (kom == kom_prev_2) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_3) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_4) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_5) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_6) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_7) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_8) 
				tab transf_within_munic
				
				tempfile transfers
				save `transfers', replace
				restore

				count
				drop if ansxtilb == "T1" | ansxtilb == "T2"
				count
				append using `transfers'
				count
												
				gen not_new_hire = (ansxtilb == "T1" | ansxtilb == "T2") & transf_within_munic == 1

				drop transf_within_munic
				count				
				drop if ansxtilb == "U" & ansaar == `year' /*INCONSISTENCY BETWEEN ANSAAR AND ANSXTILB*/
				
				}
				
				
				*headcount 		
				gen headcount = 1
				
				**** define new hires
				**** case 0: no filtering
				
				if `m' == 0 {
				
				if `x' == 2 {
				*construction of the indicators for presence in November of the current year and absence in November of the previous year
				*(in Denmark this can be done by checking whether the variable "year of first employment", ansaar, takes value equal to the current year)

				gen P0 = 1
				gen Hire = (ansaar == `year') & not_new_hire != 1
				sum Hire
							
				disp `x' " 2"
				}
				}

				if `m' == 1 {
				
				if `x' == 2 {
				*construction of the indicators for presence in November of the current year and absence in November of the previous year
				*(in Denmark this can be done by checking whether the variable "year of first employment", ansaar, takes value equal to the current year)

				gen P0 = 1
				gen Hire = (ansaar == `year') & not_new_hire != 1
				replace Hire = . if ansdage_2008 < 30
							
				disp `x' " 2"
				}
				}
				
				*cleanup occupational data
				tostring disco_kode, replace
				replace disco_kode=upper(disco_kode)
				replace disco_kode = substr(disco_kode, 1, 2)
					
				gen pcs = disco_kode
				drop if mi(pcs)
								
				*collapsing at the local labour market level
				collapse (sum) Z_E = Hire headcount Z_P0 = P0, by(`zone' pcs)
			
				sort `zone' pcs
				save idanupd_P_pcs2, replace
				
				*PART II*
			
				use idanupd`year', clear

				*drop non employees
				*DROP THE SELF-EMPLOYED
				drop if type_2008 == "S"

				*keep industries & nbhours>0
				*DROP AGRICULTURAL, PUBLIC SECTOR, AND HOUSEHOLD WORKERS WITH SOME EXCEPTIONS (e.g., RECREATIONAL ACTIVITIES)
				drop if arb_hoved_bra_db07 < 51000
				drop if (arb_hoved_bra_db07 >= 840000 & arb_hoved_bra_db07 < 900000) | (arb_hoved_bra_db07 >= 910000 & arb_hoved_bra_db07 < 920000) | arb_hoved_bra_db07 >= 970000
								
				drop if loentimer == 0
				
				*PEOPLE WHO MOVED WITHIN THE SAME COMPANY

				if "`aggregate'" == "cvr" {
				
				gen not_new_hire = (ansxtilb == "T1" | ansxtilb == "T2")
				drop if ansxtilb == "U" & ansaar == `year' /*INCONSISTENCY BETWEEN ANSAAR AND ANSXTILB*/				
				
				}

				if "`aggregate'" == "komcvr" {
				
				preserve
				keep if ansxtilb == "T1" | ansxtilb == "T2"
				sort pnr cvr
				merge pnr cvr using `prev_year'
				tab _m
				drop if _m == 2
				drop _m
				gen transf_within_munic = (kom == kom_prev_1)
				capture replace transf_within_munic = 1 if (kom == kom_prev_2) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_3) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_4) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_5) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_6) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_7) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_8) 
				tab transf_within_munic
				
				tempfile transfers
				save `transfers', replace
				restore

				count
				drop if ansxtilb == "T1" | ansxtilb == "T2"
				count
				append using `transfers'
				count
								
				gen not_new_hire = (ansxtilb == "T1" | ansxtilb == "T2") & transf_within_munic == 1
				drop transf_within_munic
				count				
				drop if ansxtilb == "U" & ansaar == `year' /*INCONSISTENCY BETWEEN ANSAAR AND ANSXTILB*/

				}
				
				if `m' == 0 {
				
				if `x' == 2 {
				*construction of the indicators for presence in November of the current year and absence in November of the previous year
				*(in Denmark this can be done by checking whether the variable "year of first employment", ansaar, takes value equal to the current year)

				gen P0 = 1
				gen Hire = (ansaar == `year')  & not_new_hire != 1
				sum Hire
							
				disp `x' " 3"
				}
				}
				
				if `m' == 1 {
				
				if `x' == 2 {
				*construction of the indicators for presence in November of the current year and absence in November of the previous year
				*(in Denmark this can be done by checking whether the variable "year of first employment", ansaar, takes value equal to the current year)

				gen P0 = 1
				gen Hire = (ansaar == `year') & not_new_hire != 1
				replace Hire = . if ansdage_2008 < 30
				*sum Hire
											
				disp `x' " 3"
				}
				}			
			
				*cleanup occupational data
				tostring disco_kode, replace
				replace disco_kode = upper(disco_kode)
				replace disco_kode = substr(disco_kode, 1, 2)
			
				gen pcs = disco_kode
				drop if mi(pcs)
				
				*collapsing at the firm level
				collapse (sum) Hire P0, by(`aggregate' `zone' pcs)
				
				*merge with local labour market aggregates
				merge m:1 `zone' pcs using idanupd_P_pcs2

				*squared shares of new hires
				gen Share_E=(Hire/Z_E)^2
				
				*squared shares of employment
				gen EmpH = (P0/Z_P0)^2
				
				*drop further errors in the occupation and geographical are variables, if any
				drop if pcs=="."
				drop if `zone'==""
			
				*set a counter of the number of hiring firms
				gen nb_Dm=1 if Hire!=.&Hire!=0
				
				*set a counter for employing firms
				gen nb_E=1 if P0!=.&P0!=0
			
				*aggregating at the LLM level and setting a year counter
				gen Hmax=sqrt(Share_E)
				gen Emax=sqrt(EmpH)
				
				collapse (sum) nb_Dm nb_E Share_E EmpH (mean) Z_E headcount Z_P0 (max) Hmax Emax, by(`zone' pcs)
			
				gen year = "`year'"
			
				*append to previous years, if any
				append using HHI\HHI`x'_HP_`aggregate'`zone'_pcs2`m'_DISCO2
				*saving
				drop if year == ""
				save HHI\HHI`x'_HP_`aggregate'`zone'_pcs2`m'_DISCO2, replace
 			}
		
		}
		
	}
		
}
}

*DISCO 3

local aggregateL cvr komcvr 
local zoneL fuaX fua1

foreach m of numlist 1 {
foreach x of numlist 2 {
	disp `x'
	foreach zone of loc zoneL {
		foreach aggregate of loc aggregateL {
			clear
		
			gen year = ""
			save HHI\HHI`x'_HP_`aggregate'`zone'_pcs3`m'_DISCO3, replace
					
			foreach year in 11 12 13 14 15 16 17 18 {
					
				disp "`aggregate'"
				disp "`year'"
				
				local year_1 = `year' - 1
				di `year_1'
				
				use idanupd`year_1', clear
				drop if type_2008 == "E"
				keep cvr pnr kom
				rename kom kom_prev_
				duplicates drop pnr cvr kom, force
				by pnr cvr, sort: gen counter = _n
				reshape wide kom_prev_, i(pnr cvr) j(counter)
				sort pnr cvr
				tempfile prev_year
				save `prev_year', replace				
				
				*PART I*
			
				use idanupd`year', clear
				
				*drop non employees
				*DROP THE SELF-EMPLOYED
				drop if type_2008 == "S"

				*keep industries & nbhours>0
				*DROP AGRICULTURAL, PUBLIC SECTOR, AND HOUSEHOLD WORKERS WITH SOME EXCEPTIONS (e.g., RECREATIONAL ACTIVITIES)
				drop if arb_hoved_bra_db07 < 51000
				drop if (arb_hoved_bra_db07 >= 840000 & arb_hoved_bra_db07 < 900000) | (arb_hoved_bra_db07 >= 910000 & arb_hoved_bra_db07 < 920000) | arb_hoved_bra_db07 >= 970000
								
				drop if loentimer == 0

				*PEOPLE WHO MOVED WITHIN THE SAME COMPANY
					
				if "`aggregate'" == "cvr" {
				
				gen not_new_hire = (ansxtilb == "T1" | ansxtilb == "T2")
				drop if ansxtilb == "U" & ansaar == `year' /*INCONSISTENCY BETWEEN ANSAAR AND ANSXTILB*/				
				
				}
				
				if "`aggregate'" == "komcvr" {
				
				preserve
				keep if ansxtilb == "T1" | ansxtilb == "T2"
				sort pnr cvr
				merge pnr cvr using `prev_year'
				tab _m
				drop if _m == 2
				drop _m
				gen transf_within_munic = (kom == kom_prev_1)
				capture replace transf_within_munic = 1 if (kom == kom_prev_2) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_3) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_4) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_5) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_6) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_7) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_8) 
				tab transf_within_munic
				
				tempfile transfers
				save `transfers', replace
				restore

				count
				drop if ansxtilb == "T1" | ansxtilb == "T2"
				count
				append using `transfers'
				count
												
				gen not_new_hire = (ansxtilb == "T1" | ansxtilb == "T2") & transf_within_munic == 1

				drop transf_within_munic
				count				
				drop if ansxtilb == "U" & ansaar == `year' /*INCONSISTENCY BETWEEN ANSAAR AND ANSXTILB*/
				
				}
				
				
				*headcount 		
				gen headcount = 1
				
				**** define new hires
				**** case 0: no filtering
				
				if `m' == 0 {
				
				if `x' == 2 {
				*construction of the indicators for presence in November of the current year and absence in November of the previous year
				*(in Denmark this can be done by checking whether the variable "year of first employment", ansaar, takes value equal to the current year)

				gen P0 = 1
				gen Hire = (ansaar == `year') & not_new_hire != 1
				sum Hire
							
				disp `x' " 2"
				}
				}

				if `m' == 1 {
				
				if `x' == 2 {
				*construction of the indicators for presence in November of the current year and absence in November of the previous year
				*(in Denmark this can be done by checking whether the variable "year of first employment", ansaar, takes value equal to the current year)

				gen P0 = 1
				gen Hire = (ansaar == `year') & not_new_hire != 1
				replace Hire = . if ansdage_2008 < 30
							
				disp `x' " 2"
				}
				}
				
				*cleanup occupational data
				tostring disco_kode, replace
				replace disco_kode=upper(disco_kode)
				replace disco_kode = substr(disco_kode, 1, 3)
					
				gen pcs = disco_kode
				drop if mi(pcs)
								
				*collapsing at the local labour market level
				collapse (sum) Z_E = Hire headcount Z_P0 = P0, by(`zone' pcs)
			
				sort `zone' pcs
				save idanupd_P_pcs3, replace
				
				*PART II*
			
				use idanupd`year', clear

				*drop non employees
				*DROP THE SELF-EMPLOYED
				drop if type_2008 == "S"

				*keep industries & nbhours>0
				*DROP AGRICULTURAL, PUBLIC SECTOR, AND HOUSEHOLD WORKERS WITH SOME EXCEPTIONS (e.g., RECREATIONAL ACTIVITIES)
				drop if arb_hoved_bra_db07 < 51000
				drop if (arb_hoved_bra_db07 >= 840000 & arb_hoved_bra_db07 < 900000) | (arb_hoved_bra_db07 >= 910000 & arb_hoved_bra_db07 < 920000) | arb_hoved_bra_db07 >= 970000
								
				drop if loentimer == 0
				
				*PEOPLE WHO MOVED WITHIN THE SAME COMPANY

				if "`aggregate'" == "cvr" {
				
				gen not_new_hire = (ansxtilb == "T1" | ansxtilb == "T2")
				drop if ansxtilb == "U" & ansaar == `year' /*INCONSISTENCY BETWEEN ANSAAR AND ANSXTILB*/				
				
				}

				if "`aggregate'" == "komcvr" {
				
				preserve
				keep if ansxtilb == "T1" | ansxtilb == "T2"
				sort pnr cvr
				merge pnr cvr using `prev_year'
				tab _m
				drop if _m == 2
				drop _m
				gen transf_within_munic = (kom == kom_prev_1)
				capture replace transf_within_munic = 1 if (kom == kom_prev_2) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_3) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_4) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_5) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_6) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_7) 
				capture replace transf_within_munic = 1 if (kom == kom_prev_8) 
				tab transf_within_munic
				
				tempfile transfers
				save `transfers', replace
				restore

				count
				drop if ansxtilb == "T1" | ansxtilb == "T2"
				count
				append using `transfers'
				count
								
				gen not_new_hire = (ansxtilb == "T1" | ansxtilb == "T2") & transf_within_munic == 1
				drop transf_within_munic
				count				
				drop if ansxtilb == "U" & ansaar == `year' /*INCONSISTENCY BETWEEN ANSAAR AND ANSXTILB*/

				}
				
				if `m' == 0 {
				
				if `x' == 2 {
				*construction of the indicators for presence in November of the current year and absence in November of the previous year
				*(in Denmark this can be done by checking whether the variable "year of first employment", ansaar, takes value equal to the current year)

				gen P0 = 1
				gen Hire = (ansaar == `year')  & not_new_hire != 1
				sum Hire
							
				disp `x' " 3"
				}
				}
				
				if `m' == 1 {
				
				if `x' == 2 {
				*construction of the indicators for presence in November of the current year and absence in November of the previous year
				*(in Denmark this can be done by checking whether the variable "year of first employment", ansaar, takes value equal to the current year)

				gen P0 = 1
				gen Hire = (ansaar == `year') & not_new_hire != 1
				replace Hire = . if ansdage_2008 < 30
											
				disp `x' " 3"
				}
				}			
			
				*cleanup occupational data
				tostring disco_kode, replace
				replace disco_kode = upper(disco_kode)
				replace disco_kode = substr(disco_kode, 1, 3)
			
				gen pcs = disco_kode
				drop if mi(pcs)
				
				*collapsing at the firm level
				collapse (sum) Hire P0, by(`aggregate' `zone' pcs)
				
				*merge with local labour market aggregates
				merge m:1 `zone' pcs using idanupd_P_pcs3

				*squared shares of new hires
				gen Share_E=(Hire/Z_E)^2
				
				*squared shares of employment
				gen EmpH = (P0/Z_P0)^2
				
				*drop further errors in the occupation and geographical are variables, if any
				drop if pcs=="."
				drop if `zone'==""
			
				*set a counter of the number of hiring firms
				gen nb_Dm=1 if Hire!=.&Hire!=0
				
				*set a counter for employing firms
				gen nb_E=1 if P0!=.&P0!=0
			
				*aggregating at the LLM level and setting a year counter
				gen Hmax=sqrt(Share_E)
				gen Emax=sqrt(EmpH)
				
				collapse (sum) nb_Dm nb_E Share_E EmpH (mean) Z_E headcount Z_P0 (max) Hmax Emax, by(`zone' pcs)
			
				gen year = "`year'"
			
				*append to previous years, if any
				append using HHI\HHI`x'_HP_`aggregate'`zone'_pcs3`m'_DISCO3
				*saving
				drop if year == ""
				save HHI\HHI`x'_HP_`aggregate'`zone'_pcs3`m'_DISCO3, replace
 			}
		
		}
		
	}
		
}
}

exit