


********************************************************************************
***********************I- DATA extraction****************************************
********************************************************************************
cd "C:\Users\Public\Documents\Europe"
set more off 


	********************************************************************************
**Extract panel data at the individual level 
cap log c
log using panelextraction.log, replace

* extraction of Panel Tous Salariés et EDP data

saswrapper using "Code\DADSpanel2.sas", post(`"%extraction(pan17_20082012);"') nodata clear 

saswrapper using "Code\DADSpanel2.sas", post(`"%extraction(pan17_20132017);"') nodata clear 

copy "\\casd.fr\casdfs\Projets\MATRAVE\Data\DADS_Panel tous salariés-EDP_2017\paneledp2017_20082012.sas7bdat" paneledp2017_20082012.sas7bdat, replace
saswrapper using "Code\DADSpaneledp.sas", post(`"%extraction(paneledp2017_20082012);"') nodata clear 

copy "\\casd.fr\casdfs\Projets\MATRAVE\Data\DADS_Panel tous salariés-EDP_2017\paneledp2017_20132017.sas7bdat" paneledp2017_20132017.sas7bdat, replace
saswrapper using "Code\DADSpaneledp.sas", post(`"%extraction(paneledp2017_20132017);"') nodata clear 

erase paneledp2017_20082012.sas7bdat
erase paneledp2017_20132017.sas7bdat

cap log c
log using panelextraction1.log, replace

*********** construction of an invariant educational attainment variable (ISCED)
use paneledp2017_20082012, clear
append using paneledp2017_20132017
rename *, lower
keep nninouv dip_tot dipl_04 dipl_05 dipl_06 dipl_07 dipl_08 dipl_09 dipl_10 /// 
			dipl_11 dipl_12 dipl_13 dipl_14 dipl_15 dipl_16
duplicates drop 
* coding last diploma obtained (old classification)			
	foreach x of numlist 4/9 {
	ge di`x'=.
	replace di`x'=1 if dipl_0`x'>="01"&dipl_0`x'<="14"
	replace di`x'=2 if dipl_0`x'>="15"&dipl_0`x'<="16"
	replace di`x'=3 if dipl_0`x'>="17"&dipl_0`x'<="18"
	}
	foreach x of numlist 10/14 {
	ge di`x'=.
	replace di`x'=1 if dipl_`x'>="01"&dipl_`x'<="14"
	replace di`x'=2 if dipl_`x'>="15"&dipl_`x'<="16"
	replace di`x'=3 if dipl_`x'>="17"&dipl_`x'<="18"
	}
	foreach x of numlist 15/16 {
	ge di`x'=.
	replace di`x'=1 if dipl_`x'>="01"&dipl_`x'<="13"
	replace di`x'=2 if dipl_`x'>="14"&dipl_`x'<="15"
	replace di`x'=3 if dipl_`x'>="16"&dipl_`x'<="19"
	}
* coding last diploma obtained (old classification)		
	ge ditot=.
	replace ditot=1 if dip_tot>="1"&dip_tot<="4"
	replace ditot=2 if dip_tot=="5"
	replace ditot=3 if dip_tot>="6"&dip_tot<="7"
* coding highest diploma
egen di416 = rowmax(di4 di5 di6 di7 di8 di9 di10 di11 di12 di13 di14 di15 di16)	
egen educ = rowmax(di416 ditot)
keep nninouv di416 ditot educ
compress
sort nninouv
save edp, replace
	
************** construction of other data	
cap log c

log using panelextraction2.log, replace
		
use pan17_20082012, clear 
rename *, lower

* drop household workers
drop if domempl=="7"
drop if substr(sir,1,1)=="P"
* drop missing industries
drop if apet2==""
* drop unemployed
drop if sirfict=="1"
* drop unusable year
drop if an==2008

* keep variables
keep dept comt depnai an age ancsir sx xp s_brut bascsg netnet netnetr nninouv pcs4 apet2 apen2 domempl filtre /// 
	contrat_travail nbheur debremu finremu nic4 sir entsir entpan av ce dp catjur sirfict pannouv

* redefine municipality identifiers	
replace comt=dept+comt
drop dept


* renaming year and occupation variables (and making them string)
ren an year 
ren pcs4 pcs 
tostring year pcs, replace 
replace year=substr(year,3,2)


compress

* save temporary database
save temp, replace	

use pan17_20132017, clear 
rename *, lower

* drop household workers
drop if domempl=="7"
drop if substr(sir,1,1)=="P"
* drop missing industries
drop if apet2==""
* drop unemployed
drop if sirfict=="1"
drop if ce=="A"


keep dept comt depnai an age ancsir sx xp s_brut bascsg netnet netnetr nninouv pcs4 apet2 apen2 domempl filtre /// 
	contrat_travail nbheur debremu finremu nic4 sir entsir entpan av ce dp catjur pannouv

* redefine municipality identifiers	
replace comt=dept+comt
drop dept


* renaming year and occupation variables (and making them string)
ren an year 
ren pcs4 pcs 
tostring year pcs, replace 
replace year=substr(year,3,2)

compress

* merging database files

append using temp

sort nninouv
merge m:1 nninouv using edp
drop _m



save Panelbase, replace   //Base file
 
erase temp.dta

********************************************************************************
***********************II- DATA cleaning****************************************
********************************************************************************


cap log c
log using mergefuaPanel.log, replace

***** Merging with data on cantons (French-specific) and data on FUAs 
* comt is the merging variable


use Panelbase.dta, clear


drop if regexm(comt,"^97") //drop Outre-mer  
drop if regexm(comt,"^98") // drop Outre-mer
drop if regexm(comt,"^99") //drop Outre-mer
drop if strlen(comt)!=5 // drop missing municipality


*pre-merging reassignment of the codes of Paris, Lyon and Marseille, which refer to intra-municipality divisions
replace comt="76108" if comt=="76095"
	replace comt="75056" if regexm(comt,"751")
	replace comt="13055" if regexm(comt,"^132")
	replace comt="69123" if regexm(comt,"^6938")
	
*drop public adminsitration with no municipality	
	drop if substr(comt,3,3)=="000"
	drop if comt=="40529"&nic==comt
	drop if comt=="29603"&nic==comt
	drop if comt=="33998"&nic==comt
	drop if comt=="57998"&nic==comt
	drop if comt=="92902"&nic==comt
	drop if sir=="662043116" /* office national des forets */
	drop if sir=="160020012" /* MONNAIE */
	drop if sir=="110068012" /* ministere ecologie */

	
	

* recoding old municipalities and errors
	replace comt="05139" if comt=="05002"	
	replace comt="05132" if comt=="05020"	
	replace comt="05139" if comt=="05042"	
	replace comt="05132" if comt=="05067"	
	replace comt="05139" if comt=="05138"	
	replace comt="28361" if comt=="28042"	
	replace comt="49042" if comt=="49199"	
	replace comt="49018" if comt=="49213"	
	replace comt="49018" if comt=="49245"	
	replace comt="49018" if comt=="49303"	
	replace comt="49018" if comt=="49372"	
	replace comt="49018" if comt=="49380"	
	replace comt="59183" if comt=="59248"	
	replace comt="59183" if comt=="59540"	
	replace comt="69248" if comt=="69025"	
	replace comt="69248" if comt=="69041"	
	replace comt="69248" if comt=="69128"	
	replace comt="69248" if comt=="69129"	
	replace comt="69208" if comt=="69144"	
	replace comt="79030" if comt=="79353"	
	replace comt="79242" if comt=="79356"	
	replace comt="88176" if comt=="88282"	
	replace comt="2A041" if comt=="20041"
	replace comt="2A090" if comt=="20090"
	replace comt="2A200" if comt=="20200"
	replace comt="2B250" if comt=="20250"
	replace comt="33439" if comt=="33620"
	replace comt="69296" if comt=="69360"
	replace comt="69292" if comt=="69580"
	replace comt="69238" if comt=="69590"
	replace comt="84035" if comt=="84300"
	replace comt="92063" if comt=="92500"
	replace comt="06004" if comt=="06604"

	replace comt="83042" if sir=="449401249"&nic4=="0003"

	replace comt="81132" if comt=="81107"
	replace comt="94068" if comt=="94109"
	
	
* merging with cantons/FUAs	
sort comt
merge m:1 comt using geodata\interdata\mergedMunicipalitiesOtherFUAs

* drop unmatched municipalities (municipalities where there are no job posts)
drop if _m==2
tab comt if _m==1 // quality check
drop _m
* drop useless vars
drop Nameoffunctionalurbanarea Namemunicipality fua ct_large
drop xp entpan av bascsg

*construct string identifiers for intercommunalité (EPCI) 
ren EPCI epci
	ge l=length(epci)
	replace epci="0000000"+epci if l==2
	drop l	

* generate firmXepci identifier
gen sirepci=epci+sir
* generate firmXlau1 identifier (firm X canton)
gen sirlau1=lau1+sir
* generate firmXmunicipality identifier
gen sircomt=comt+sir


* merging coordinates for place of work
replace comt=subinstr(comt,"A","0",1) if substr(comt,2,1)=="A"
replace comt=subinstr(comt,"B","0",1) if substr(comt,2,1)=="B"

replace comt="52332" if comt=="52033"
replace comt="52332" if comt=="52465"
replace comt="52504" if comt=="52124"
replace comt="52427" if comt=="52266"

sort comt
merge m:1 comt using geodata\geobase_comt
* drop unmatched municipalities (municipalities where there are no job posts)
drop if _m==2
tab comt if _m==1 // quality check
drop _m


* keep if number of hours>0
keep if nbheur>0


compress

drop pannouv // useless indicator of presence in EDP
save PanelbaseFUA.dta, replace
cap log c

********************************************************************************
***********************III-VARIABLE CONSTRUCTION********************************
********************************************************************************
cap log c
log using absent_present.log, replace

*** absent/present year before
use PanelbaseFUA.dta, clear

ge dp2=dp
replace dp2=finremu-debremu+1 if dp==. // comleting spell duration variable if missing
ge P1y = (dp2!=.|netnet>0) // present in the year
ge P1m = ((debremu<=330&finremu>=301)) // present in November

*firmXmunicipality
collapse (max) P1y P1m, by(nninouv sircom sir year)
destring year, ge(an)
compress
replace an=an+1
drop if an==18
rename P1m P1msircom
rename P1y P1ysircom
sort nninouv sircom sir an
save P1sircom, replace

* firm
drop sircom
rename P1m P1msiren
rename P1y P1ysiren
sort nninouv sir an
save P1siren, replace

*overall (absent means not in employment)
collapse (max) P1y P1m, by(nninouv an)
rename P1m P1m
rename P1y P1y
sort nninouv an
save P1, replace

*** absent/present year before epci
use PanelbaseFUA.dta, clear

*firmXepci
ge dp2=dp
replace dp2=finremu-debremu+1 if dp==.
ge P1y = (dp2!=.|netnet>0)
ge P1m = ((debremu<=330&finremu>=301))
collapse (max) P1y P1m, by(nninouv sirepci sir year)
destring year, ge(an)
compress
replace an=an+1
drop if an==18
rename P1m P1msirepci
rename P1y P1ysirepci
sort nninouv sirepci sir an
save P1sirepci, replace

*** absent/present year before lau1
use PanelbaseFUA.dta, clear

* firmXlau1
ge dp2=dp
replace dp2=finremu-debremu+1 if dp==.
ge P1y = (dp2!=.|netnet>0)
ge P1m = ((debremu<=330&finremu>=301))
collapse (max) P1y P1m, by(nninouv sirlau1 sir year)
destring year, ge(an)
compress
replace an=an+1
drop if an==18
rename P1m P1msirlau1
rename P1y P1ysirlau1
sort nninouv sirlau1 sir an
save P1sirlau1, replace

cap log c


*** preparing variables for basic wage regressions
log using wageregressionprewage.log, replace

use PanelbaseFUA.dta, clear
ge dp2=dp
replace dp2=finremu-debremu+1 if dp==. // comleting spell duration variable if missing
keep if dp2>=30 // keep if at least 30 days in the job
drop dp2

*keep industries
keep if (substr(apet, 1, 2)>="05"&substr(apet, 1, 2)<="82")|substr(apet, 1, 2)=="90"| ///
						substr(apet, 1, 2)>="92"&substr(apet, 1, 2)<="96"

* drop useless vars
drop debremu finremu filtre s_brut contrat_travail apen2 lat lng

* ge fulltime var 
ge ftpt=(ce=="C")

ge wage=log(netnet/nbheur) // hourly wages
* censoring hourly wages
drop if wage==.
ge wagen=wage // uncensored variable
destring year, ge(an) 
foreach year of numlist 10/17 {
	sum wage if an==`year' ,d  //drop extreme values 
	replace wage=. if inrange(wage,`r(p1)',`r(p99)')!=1 & an==`year' 

		}

* full-time daily wage (censored)	
ge dwage=log(netnet/dp) if ftpt==1 
foreach year of numlist 10/17 {
	sum dwage if an==`year',d  //drop extreme values 
	replace dwage=. if inrange(dwage,`r(p1)',`r(p99)')!=1 & an==`year'&dwage!=.


		}
		

* ge variables for interacted fixed effects
ge pcs2=substr(pcs,1,2)



		egen firm=group(sir)
		egen mun=group(comt)
		egen occ=group(pcs)
		egen occ2=group(pcs2)
		egen geo=group(fuaX) 
		egen nuts=group(dep) 
		egen fua1_n=group(fua1)
		egen lau1_n=group(lau1)
		egen epci_n=group(epci)
		egen ind=group(apet2)
			egen id=group(nninouv) 
			egen nic=group(nic4)
			egen ag=group(age)
			replace ag=0 if age==. // creating a missing age variable
					egen cluster=group(geo occ an) 
					egen cluster2=group(nuts occ an)
					egen cluster3=group(fua1_n occ an)

compress
* drop 2009
drop if year=="09"

save prewage, replace

********************************************************************************
***********************IV - DESCRIPTIVE STATISTICS (part) **********************
********************************************************************************


cap log c
log using wageregression_descstats.log, replace


* variable for Appendix Table 1.1 (except variables used in the contract type regressions)

	*** looping over different type of wage variables
	foreach var in wagen wageft dwage wage {	
				
					use prewage, clear
					*drop useless vars
					drop ce entsir ancsir
					
					* limit sample to full time (if relevant)
					ge wageft = wage if ftpt==1
					disp "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
					disp "`var' HHI1 fuaX sircomt" 
					disp "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
					if "`var'"=="dwage"|"`var'"=="wageft" {
						keep if ftpt==1
					}
					
					* merging with other covariates
						sort nninouv sircom sir an
						merge 1:1 nninouv sircom sir an using P1sircom
						drop if _m==2
						drop _m
					
					drop P1m
					sort nninouv an
					merge m:1 nninouv an using P1
					drop if _m==2
					drop _m
					
					* new hire and employed the year before variables
					ge Hire=(P1ysir!=1)
					ge Emp1y=(Hire*P1y==1)
					drop P1*
	
					* merging with HHI
					sort fuaX pcs year			
					merge m:1 fuaX pcs year using HHI\HHI1_HPsircomtfuaX_pcs41
					keep if _m==3
					drop _m	
					ge logShare_E=log(Share_E)
					
	
					compress

* stats
ge e`var'=exp(`var')
ge educ1=(educ==1)
ge educ2=(educ==2)
ge educ3=(educ==3)
ge educ4=(educ==.)
destring sx, replace
qui regress `var' ftpt logShare_E Hire Emp1y id occ geo firm mun an nic age

disp "Full sample"
* all variables except wage variables, full sample
if "`var'"=="wagen" {
sum Share_E sx age ftpt educ1-educ4 Hire if e(sample)
}

*hourly wage (all)
if "`var'"=="wage" {
sum e`var' if e(sample)
keep if Hire==1
disp "New hires"
sum e`var' if e(sample)
}

*hourly wage (full-timers)
if "`var'"=="wageft" {
sum e`var' if e(sample)
keep if Hire==1
disp "New hires"
sum e`var' if e(sample)
}

*daily wage (full-timers)
if "`var'"=="dwage" {
sum e`var' if e(sample)
keep if Hire==1
disp "New hires"
sum e`var' if e(sample)
}

}


* NUMBER OF OCCUPATIONS


			
					use prewage, clear
					*drop useless vars
					drop ce entsir ancsir
					
					
					* merging with other covariates
						sort nninouv sircom sir an
						merge 1:1 nninouv sircom sir an using P1sircom
						drop if _m==2
						drop _m
					
					drop P1m
					sort nninouv an
					merge m:1 nninouv an using P1
					drop if _m==2
					drop _m

					ge Hire=(P1ysir!=1)
					ge Emp1y=(Hire*P1y==1)
					drop P1*
	
					* merging with HHI
					sort fuaX pcs year			
					merge m:1 fuaX pcs year using HHI\HHI1_HPsircomtfuaX_pcs41
					keep if _m==3
					drop _m	
					ge logShare_E=log(Share_E)
					
	
					compress

* limit the sample
qui regress wagen ftpt logShare_E Hire Emp1y id occ geo firm mun an nic age
keep if e(sample)
disp "Full sample"

* Number of occupations per firmXmunicipality

* We use the same samples on which we have computed descriptive statistics in Appendix Table 1.1. Drop all other observations.
global occ occ // varname of occupation variable
global sircom sircom // varname containing firmXmunicipality identifiers 
global year year // varname containing years



* computing number of occupations at the firmXmunicipality-by-year level
preserve
ge one=1
collapse (count) one, by($occ $sircom $year)
duplicates tag $sircom $year, ge(numb_occ) 
replace numb_occ=numb_occ+1
drop one
sort $occ $sircom $year
save numb_occ, replace

*calculating the mean over the distribution of individual observation
restore
sort $occ $sircom $year
merge m:1 $occ $sircom $year using numb_occ
drop if _m==2
drop _m
sum numb_occ

* this is the mean number (as reported in Section III.A)
disp "mean number of occupations - full: " r(mean)



