
*************************************************************************************
**** MASTER FILE ********************************************************************

cd "C:\Users\Public\Documents\Europe" // this is the location of all the programmes and log files
set more off 


cap log c


* preparation of geographical variables
cap mkdir geodata\interdata
do mergeMunicipalitiesOtherFUAs.do


*DATA extraction and HHI calculation + Table 1 & Figures 1.1, 1.2 and 1.3
do HHI.do
* multiple log files are created by this programme

*PANEL DATA extraction, variable construction and (some) descriptive stats (Part of Table 1.1)
do Panel.do
* multiple log files are created by this programme

*Baseline wage regressions (Tables 2; 4; 2.1; 2.2; 2.7; 2.8; 2.11; 2.12)
do WageRegressionsBaseline.do

*Table 2.3
do WageRegressionsPureLeaveOneOut.do

*Table 2.4
do WageRegressionsEmployment.do

*Table 2.5
do WageRegressionsShareOcc.do

*Table 2.6
do WageRegressionsConley.do

*Table 2.9
do WageRegressions2digit.do

*Construct Arnold's HHI
do ArnoldHHI.do

*Table 2.10
do WageRegressionsArnold.do

*Table 5 and wage part of Figures 1-4
do WageRegressionsInteractions.do

* Variable construction for contract regressions, descriptive statistics completing Table 1.1 and baseline contract regressions including pure leave-on-out IV (Tables 6; 2.13; 2.14; 2.15; 2.16; 2.20; 2.23; 2.24)
do ContractRegressionsBaseline.do
* multiple log files are created by this programme

* Table 2.17
do ContractRegressionsEmployment.do

* Table 2.18
do ContractRegressionsShareOcc.do

* Table 2.19
do ContractRegressionsConley.do

* Table 2.21
do ContractRegressions2digit.do

* Table 2.22
do ContractRegressionsArnold.do

*Contract part of Figures 1-4
do ContractRegressionsInteractions.do

* Share of within 4-digit occupation job changes in 2-digit occupation changes
do tprob2&4.do  
