********************************************************************************
* Title: 04.c Estimate occupation shares.do
* Description: This dofile estimates occupational shares.
********************************************************************************
	
	clear
	set trace off
	global date: di %tdCYND daily("$S_DATE", "DMY")

********************************************************************************
* B. Log
********************************************************************************

	global date: di %tdCYND daily("$S_DATE", "DMY")

	cap log close

	cap log using "$logs\04.c Estimate ocupation shares $date.log",replace

********************************************************************************
* C. Load and prepare the data
********************************************************************************
		
	use "$input\collapse_by_year",clear	
		
		keep one_cc2 OCUP year
			
		keep if one_cc2 == 1	
		
		drop if mi(OCUP)
			
********************************************************************************
* D. Estimate the shares of occupation
********************************************************************************

	collapse (sum) one_cc2, by(OCUP year)
	egen tot=sum(one_cc2), by(year)
	ge shocc=one_cc2/tot
	keep OCUP one_cc2 year shocc
	sort one_cc2 year
	
	save "$input\intermediate_files\shocc", replace
	
*************************** END OF THIS DOFILE *********************************
	cap log close
	exit, clear
