
*** 2. DESCRIPTIVE ANALYSIS ***






*legend:
*4 = FUAs + (residual) NUTS-3 regions --> adjusted for NUTS-3 enclaves --> average HHI = 0.062
*5 = NUTS-3 regions --> adjusted for NUTS-3 enclaves --> average HHI = 0.091
*1 = FUAs   --> average HHI = 0.048

*2 = FUAs + (residual) NUTS-3 regions --> average HHI = 0.064
*3 = NUTS-3 regions --> average HHI = 0.095



*** 2.1 LABOR MARKET CONCENTRATION (WORKPLACE): FUAs + NUTS-3 REGIONS (ADJUSTED FOR NUTS-3 ENCLAVES) ***


use "$data\LMC_4_4_1218.dta", clear
drop INS_* ln_INS_*
rename *_week_* *_w*
rename *_month_* *_m*
rename *_year_* *_y*
rename *_4_4 *





*comparison of main summary statistics over hiring concepts

sum HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01
sum HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=L_y01]
sum HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=H_y01]



*Table 1

sum HHI_y01 [fweight=H_y01] if HHI_y01!=0 & HHI_y01!=. , detail // Mean = 0.0591, Std Dev = 0.1213, P25 = 0.0057, P50 = 0.0171, P75 = 0.0511, P90 = 0.1508

tabstat HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 , statistics(mean) columns(statistics)
tabstat HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=L_y01], statistics(mean) columns(statistics)
tabstat HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=H_y01], statistics(mean) columns(statistics)





*correlation patterns

local HHI HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01

foreach x of local HHI {
    
	
	gen ln_`x' = ln(`x')
	
	
}


correlate HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 
correlate ln_HHI_w13 ln_HHI_w26 ln_HHI_w39 ln_HHI_w52 ln_HHI_m03 ln_HHI_m06 ln_HHI_m09 ln_HHI_m12 ln_HHI_y01 

correlate HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=L_y01]
correlate ln_HHI_w13 ln_HHI_w26 ln_HHI_w39 ln_HHI_w52 ln_HHI_m03 ln_HHI_m06 ln_HHI_m09 ln_HHI_m12 ln_HHI_y01  [fweight=L_y01]

correlate HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01  [fweight=H_y01]
correlate ln_HHI_w13 ln_HHI_w26 ln_HHI_w39 ln_HHI_w52 ln_HHI_m03 ln_HHI_m06 ln_HHI_m09 ln_HHI_m12 ln_HHI_y01 [fweight=H_y01]



scatter ln_HHI_w52 ln_HHI_y01, msize(tiny)
graph export "$fig\Scatter_4_Low.png", as(png) replace width(1000)

scatter ln_HHI_w52 ln_HHI_m12, msize(tiny)
graph export "$fig\Scatter_4_Week_Month.png", as(png) replace width(1000)


scatter ln_HHI_m12 ln_HHI_y01, msize(tiny)
graph export "$fig\Scatter_4_Month_Year.png", as(png) replace width(1000)


label var ln_HHI_y01 "log HHI year"  
label var ln_HHI_m12 "log HHI month/year"  


*Appendix Figure 1.3
twoway scatter ln_HHI_m12 ln_HHI_y01, msize(tiny) title(Germany) 
graph export "$fig/HHI1HHI2_Germany.png", replace  




*slope estimates



local HHI HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01


foreach x of local HHI {
    
	foreach y of local HHI {
	    
		reg ln_`x' ln_`y'
		
		
	}
}


regr ln_HHI_m12 ln_HHI_y01 [pw=H_y01]




*detailed statistics for year concept

*sum HHI_w52, detail 
*sum HHI_w52  [fweight=L_w52], detail
*sum HHI_w52  [fweight=H_w52], detail

*sum HHI_m12, detail 
*sum HHI_m12  [fweight=L_m12], detail
*sum HHI_m12  [fweight=H_m12], detail

sum HHI_y01, detail 
sum HHI_y01  [fweight=L_y01], detail
sum HHI_y01  [fweight=H_y01], detail

gen HHI_y01_ter = .
replace HHI_y01_ter = 1 if HHI_y01<0.15
replace HHI_y01_ter = 2 if HHI_y01>=0.15 & HHI_y01<0.25
replace HHI_y01_ter = 3 if HHI_y01>=0.25
replace HHI_y01_ter = . if HHI_y01==.

label define LMC 1 "1 Low LM Concentration (0.00-0.15)" 2 "2 Medium LM Concentration (0.15-0.25)"  3 " 3 High LM Concentration (0.25-1.00)"
label values HHI_y01_ter LMC

tab HHI_y01_ter
tab HHI_y01_ter [fweight=H_y01]
tab HHI_y01_ter [fweight=L_y01]




/*

gen HHI_y01_terEU = .
replace HHI_y01_terEU = 1 if HHI_y01<0.10
replace HHI_y01_terEU = 2 if HHI_y01>=0.10 & HHI_y01<0.20
replace HHI_y01_terEU = 3 if HHI_y01>=0.20
replace HHI_y01_terEU = . if HHI_y01==.

label define LMC_EU 1 "1 Low LM Concentration (0.00-0.10)" 2 "2 Medium LM Concentration (0.10-0.20)"  3 " 3 High LM Concentration (0.20-1.00)"
label values HHI_y01_terEU LMC_EU

tab HHI_y01_terEU
tab HHI_y01_terEU [fweight=H_y01]
tab HHI_y01_terEU [fweight=L_y01]

*/



*histogram



hist HHI_y01, xtitle(HHI (Year Concept))


graph export "$fig\Hist_4.png", as(png) replace width(1000)




*cumulative distribution

use "$data\LMC_4_4_1218.dta", clear
drop INS_* ln_INS_*
rename *_week_* *_w*
rename *_month_* *_m*
rename *_year_* *_y*
rename *_4_4 *



drop if HHI_y01==.

cumul HHI_y01 , gen(cumul_fweight_LM)
cumul HHI_y01 [fweight=H_y01], gen(cumul_fweight_H)
cumul HHI_y01 [fweight=L_y01], gen(cumul_fweight_L)


gen n = _n
gen mod = mod(n,100)
keep if mod==0



sort cumul_fweight_LM
line cumul_fweight_H cumul_fweight_L cumul_fweight_LM HHI_y01, ytitle(Cumulative Distribution) xtitle(HHI (Year Concept)) legend(order( 1 "Hires" 2 "Workers" 3 "Labor Markets" ))

graph export "$fig\Cumul_4.png", as(png) replace width(1000)



*by years



use "$data\LMC_4_4_1218.dta", clear


bys year: sum HHI_year_01_4_4 [fweight=H_year_01_4_4] if HHI_year_01_4_4!=0 & HHI_year_01_4_4!=.  // 2012 = 0.0597, 2013 = 0.0593, 2014 = 0.0604, 2015 = 0.0600, 2016 = 0.0592, 2017 = 0.0591, 2018 = 0.0564





*trend over time


use "$data\LMC_4_4_1218.dta", clear
drop INS_* ln_INS_*
rename *_week_* *_w*
rename *_month_* *_m*
rename *_year_* *_y*
rename *_4_4 *


tabstat HHI_y01, by(year) statistics(p25)
tabstat HHI_y01, by(year) statistics(p50)
tabstat HHI_y01, by(year) statistics(mean) 
tabstat HHI_y01, by(year) statistics(p75)


collapse  (p25) HHI_p25_t=HHI_y01 (p50) HHI_p50_t=HHI_y01 (mean) HHI_mean_t=HHI_y01 (p75) HHI_p75_t=HHI_y01, by(year)


twoway (line HHI_p25_t year) (line HHI_p50_t year) (line HHI_mean_t year) (line HHI_p75_t year), xtitle(year) ytitle(HHI (Year Concept)) title("By Percentile") xscale(range(2012(1)2018)) yscale(range(0(0.1)1)) ytick(0(0.1)1) ylabel(0(0.1)1)

graph export "$fig\Trend_4.png", as(png) replace width(1000)




*Occupations

use "$data\LMC_4_4_1218.dta", clear
drop INS_* ln_INS_*
rename *_week_* *_w*
rename *_month_* *_m*
rename *_year_* *_y*
rename *_4_4 *

keep isco08_4_imp nuts07_3_fua year HHI_y01

collapse (p25) HHI_p25_4=HHI_y01 (p50) HHI_median_4=HHI_y01 (p75) HHI_p75_4=HHI_y01 (mean) HHI_mean_4=HHI_y01, by(isco08_4_imp)

sort HHI_median HHI_p25 HHI_p75 HHI_mean


egen rank_4_median = rank(-HHI_median_4), field 
egen rank_4_p25 = rank(-HHI_p25_4), field 
egen rank_4_p75 = rank(-HHI_p75_4), field 
egen rank_4_mean = rank(-HHI_mean_4), field 

sort rank_4_median rank_4_p25 rank_4_p75 rank_4_mean

gen rank_4 = _n

drop rank_4_median rank_4_p25 rank_4_p75 rank_4_mean

sort rank_4
order isco08_4_imp rank_4 HHI_median_4 HHI_p25_4 HHI_p75_4 HHI_mean_4


format %4.3f HHI_*

save "$data\Occupations_4_4.dta", replace
	
	
export excel using "$data\Occupations_4_4.xlsx", firstrow(variables) keepcellfmt replace

					
	






























	
	

*** 2.2 LABOR MARKET CONCENTRATION (WORKPLACE): FUAs ***


use "$data\LMC_4_1_1218.dta", clear
drop INS_* ln_INS_*
rename *_week_* *_w*
rename *_month_* *_m*
rename *_year_* *_y*
rename *_4_1 *



*comparison of main summary statistics over hiring concepts

sum HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01
sum HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=L_y01]
sum HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=H_y01]



tabstat HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01, statistics(mean) columns(statistics)
tabstat HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=L_y01], statistics(mean) columns(statistics)
tabstat HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=H_y01], statistics(mean) columns(statistics)




*smaller for two reasons:
*- only urban areas
*- larger than NUTS-3 regions




*correlation patterns

local HHI HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 

foreach x of local HHI {
    
	
	gen ln_`x' = ln(`x')
	
	
}


correlate HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 
correlate ln_HHI_w13 ln_HHI_w26 ln_HHI_w39 ln_HHI_w52 ln_HHI_m03 ln_HHI_m06 ln_HHI_m09 ln_HHI_m12 ln_HHI_y01 

correlate HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=L_y01]
correlate ln_HHI_w13 ln_HHI_w26 ln_HHI_w39 ln_HHI_w52 ln_HHI_m03 ln_HHI_m06 ln_HHI_m09 ln_HHI_m12 ln_HHI_y01 [fweight=L_y01]

correlate HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=H_y01]
correlate ln_HHI_w13 ln_HHI_w26 ln_HHI_w39 ln_HHI_w52 ln_HHI_m03 ln_HHI_m06 ln_HHI_m09 ln_HHI_m12 ln_HHI_y01 [fweight=H_y01]




scatter ln_HHI_w52 ln_HHI_m12, msize(tiny)
graph export "$fig\Scatter_1_Week_Month.png", as(png) replace width(1000)


scatter ln_HHI_w52 ln_HHI_y01, msize(tiny)
graph export "$fig\Scatter_1_Week_Year.png", as(png) replace width(1000)


scatter ln_HHI_m12 ln_HHI_y01, msize(tiny)
graph export "$fig\Scatter_1_Month_Year.png", as(png) replace width(1000)




*detailed statistics for year

*sum HHI_w52, detail 
*sum HHI_w52  [fweight=L_w52], detail
*sum HHI_w52  [fweight=H_w52], detail

*sum HHI_m12, detail 
*sum HHI_m12  [fweight=L_m12], detail
*sum HHI_m12  [fweight=H_m12], detail

sum HHI_y01, detail 
sum HHI_y01  [fweight=L_y01], detail
sum HHI_y01  [fweight=H_y01], detail

gen HHI_y01_ter = .
replace HHI_y01_ter = 1 if HHI_y01<0.15
replace HHI_y01_ter = 2 if HHI_y01>=0.15 & HHI_y01<0.25
replace HHI_y01_ter = 3 if HHI_y01>=0.25
replace HHI_y01_ter = . if HHI_y01==.

label define LMC 1 "1 Low LM Concentration (0.00-0.15)" 2 "2 Low LM Concentration (0.15-0.25)"  3 " 3 Low LM Concentration (0.25-1.00)"
label values HHI_y01_ter LMC

tab HHI_y01_ter
tab HHI_y01_ter [fweight=H_y01]
tab HHI_y01_ter [fweight=L_y01]




*Occupations

use "$data\LMC_4_1_1218.dta", clear
drop INS_* ln_INS_*
rename *_week_* *_w*
rename *_month_* *_m*
rename *_year_* *_y*
rename *_4_1 *

keep isco08_4_imp fua year HHI_y01

collapse (p25) HHI_p25_1=HHI_y01 (p50) HHI_median_1=HHI_y01 (p75) HHI_p75_1=HHI_y01 (mean) HHI_mean_1=HHI_y01, by(isco08_4_imp)

sort HHI_median HHI_p25 HHI_p75 HHI_mean


egen rank_1_median = rank(-HHI_median_1), field 
egen rank_1_p25 = rank(-HHI_p25_1), field 
egen rank_1_p75 = rank(-HHI_p75_1), field 
egen rank_1_mean = rank(-HHI_mean_1), field 

sort rank_1_median rank_1_p25 rank_1_p75 rank_1_mean

gen rank_1 = _n

drop rank_1_median rank_1_p25 rank_1_p75 rank_1_mean

sort rank_1
order isco08_4_imp rank_1 HHI_median_1 HHI_p25_1 HHI_p75_1 HHI_mean_1


format %4.3f HHI_*

save "$data\Occupations_4_1.dta", replace
	
	
export excel using "$data\Occupations_4_1.xlsx", firstrow(variables) keepcellfmt replace

			




















*** 2.3 LABOR MARKET CONCENTRATION (WORKPLACE): NUTS-3 REGIONS (ADJUSTED FOR NUTS-3 ENCLAVES) ***



use "$data\LMC_4_5_1218.dta", clear
drop INS_* ln_INS_*
rename *_week_* *_w*
rename *_month_* *_m*
rename *_year_* *_y*
rename *_4_5 *


rename nuts07_3_adj_work nuts07_3_adj

merge m:1 nuts07_3_adj using "$data\FUA_nuts_adj.dta"
gen fua = (_merge==3)
label variable fua "NUTS-3 Region Belongs to FUA (No=0, Yes=1)"

rename nuts07_3_adj nuts07_3_adj_work


*comparison of main summary statistics over hiring concepts

sum HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01
sum HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=L_y01]
sum HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=H_y01]


bysort fua: sum HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01[fweight=H_y01]

 
tabstat HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01, statistics(mean) columns(statistics)
tabstat HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=L_y01], statistics(mean) columns(statistics)
tabstat HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=H_y01], statistics(mean) columns(statistics)





*correlation patterns

local HHI HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01

foreach x of local HHI {
    
	
	gen ln_`x' = ln(`x')
	
	
}


correlate HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 
correlate ln_HHI_w13 ln_HHI_w26 ln_HHI_w39 ln_HHI_w52 ln_HHI_m03 ln_HHI_m06 ln_HHI_m09 ln_HHI_m12 ln_HHI_y01 

correlate HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=L_y01]
correlate ln_HHI_w13 ln_HHI_w26 ln_HHI_w39 ln_HHI_w52 ln_HHI_m03 ln_HHI_m06 ln_HHI_m09 ln_HHI_m12 ln_HHI_y01 [fweight=L_y01]

correlate HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=H_y01]
correlate ln_HHI_w13 ln_HHI_w26 ln_HHI_w39 ln_HHI_w52 ln_HHI_m03 ln_HHI_m06 ln_HHI_m09 ln_HHI_m12 ln_HHI_y01 [fweight=H_y01]




scatter ln_HHI_w52 ln_HHI_m12, msize(tiny) 
graph export "$fig\Scatter_5_Week_Month.png", as(png) replace width(1000)


scatter ln_HHI_w26 ln_HHI_y01, msize(tiny)
graph export "$fig\Scatter_5_Week_Year.png", as(png) replace width(1000)


scatter ln_HHI_m12 ln_HHI_y01, msize(tiny)
graph export "$fig\Scatter_5_Month_Year.png", as(png) replace width(1000)





*detailed statistics for year concept

*sum HHI_w52, detail 
*sum HHI_w52  [fweight=L_w52], detail
*sum HHI_w52  [fweight=H_w52], detail

*sum HHI_m12, detail 
*sum HHI_m12  [fweight=L_m12], detail
*sum HHI_m12  [fweight=H_m12], detail

sum HHI_y01, detail 
sum HHI_y01  [fweight=L_y01], detail
sum HHI_y01  [fweight=H_y01], detail

gen HHI_y01_ter = .
replace HHI_y01_ter = 1 if HHI_y01<0.15
replace HHI_y01_ter = 2 if HHI_y01>=0.15 & HHI_y01<0.25
replace HHI_y01_ter = 3 if HHI_y01>=0.25
replace HHI_y01_ter = . if HHI_y01==.

label define LMC 1 "1 Low LM Concentration (0.00-0.15)" 2 "2 Low LM Concentration (0.15-0.25)"  3 " 3 Low LM Concentration (0.25-1.00)"
label values HHI_y01_ter LMC

tab HHI_y01_ter
tab HHI_y01_ter [fweight=H_y01]
tab HHI_y01_ter [fweight=L_y01]


bysort fua: tab HHI_y01_ter [fweight=H_y01] // less concentration in (functional) urban areas




*Occupations

use "$data\LMC_4_5_1218.dta", clear
drop INS_* ln_INS_*
rename *_week_* *_w*
rename *_month_* *_m*
rename *_year_* *_y*
rename *_4_5 *

keep isco08_4_imp nuts07_3 year HHI_y01

collapse (p25) HHI_p25_5=HHI_y01 (p50) HHI_median_5=HHI_y01 (p75) HHI_p75_5=HHI_y01 (mean) HHI_mean_5=HHI_y01, by(isco08_4_imp)

sort HHI_median HHI_p25 HHI_p75 HHI_mean


egen rank_5_median = rank(-HHI_median_5), field 
egen rank_5_p25 = rank(-HHI_p25_5), field 
egen rank_5_p75 = rank(-HHI_p75_5), field 
egen rank_5_mean = rank(-HHI_mean_5), field 

sort rank_5_median rank_5_p25 rank_5_p75 rank_5_mean

gen rank_5 = _n

drop rank_5_median rank_5_p25 rank_5_p75 rank_5_mean

sort rank_5
order isco08_4_imp rank_5 HHI_median_5 HHI_p25_5 HHI_p75_5 HHI_mean_5


format %4.3f HHI_*

save "$data\Occupations_4_5.dta", replace
	
	
export excel using "$data\Occupations_4_5.xlsx", firstrow(variables) keepcellfmt replace

					
	
	
	


*** 2.4 LABOR MARKET CONCENTRATION (WORKPLACE): FUAs + NUTS-3 REGIONS (NOT ADJUSTED FOR NUTS-3 ENCLAVES) ***


use "$data\LMC_4_2_1218.dta", clear
drop INS_* ln_INS_*
rename *_week_* *_w*
rename *_month_* *_m*
rename *_year_* *_y*
rename *_4_2 *



*comparison of main summary statistics over hiring concepts

sum HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01
sum HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=L_y01]
sum HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=H_y01]








*** 2.5 LABOR MARKET CONCENTRATION (WORKPLACE): NUTS-3 REGIONS (NOT ADJUSTED FOR NUTS-3 ENCLAVES) ***


use "$data\LMC_4_3_1218.dta", clear
drop INS_* ln_INS_*
rename *_week_* *_w*
rename *_month_* *_m*
rename *_year_* *_y*
rename *_4_3 *



*comparison of main summary statistics over hiring concepts

sum HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01
sum HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=L_y01]
sum HHI_w13 HHI_w26 HHI_w39 HHI_w52 HHI_m03 HHI_m06 HHI_m09 HHI_m12 HHI_y01 [fweight=H_y01]








	
	
	
	
	





*** 2.6 MAP




use "$data\BeH_FUA.dta", clear


keep nuts07_3 nuts07_3_adj fua nuts07_3_fua_adj
duplicates drop

bysort nuts07_3: gen n = _n
bysort nuts07_3: gen N = _N

drop if n==2
drop N n

sort nuts07_3

save "$data\Map.dta", replace



clear

*source of map data: http://www.geodatenzentrum.de/geodaten/gdz_rahmen.gdz_div?gdz_spr=deu&gdz_akt_zeile=5&gdz_anz_zeile=1&gdz_unt_zeile=14&gdz_user_id=0
*name of dataset: Verwaltungsgebiete 1:250 000 - Stand 01.01.2018
*code of dataset: vg_250_ebenen/2018/vg250_2018-01-01.tm32.shape.ebenen.zip
*note: 1 Jan 2018 refers to administrative delineation valid on 31 Dec 2017 (unification of Goettingen, District and Osterode (Harz), District was implemented)
*saved under "N:\Ablagen\D01700-Projekte\D01700-Labor_Demand\5 Empirics\orig\Map"

*see the following link: https://www.stata.com/support/faqs/graphics/spmap-and-maps/

cd "$orig\Map\vg250_2018-01-01.tm32.shape.ebenen\vg250_ebenen"

*create dta files (can be read by Stata) from db and shp files (cannot be read by Stata)
shp2dta using VG250_KRS, database(db) coordinates(coord) genid(mapid) gencentroids(centroid) replace

use "db.dta", clear
save "$data\db.dta", replace

use "coord.dta", clear
save "$data\coord.dta", replace



cd "$main"
use "$data\db.dta", clear

count if RS!=AGS

duplicates report RS // (374-0) + (48-24) + (9-6) = 374 + 24 + 3 = 401 = 107 independent towns + 294 districts

*note: due to islands or enclaves, some districts or independent towns have more than one observation in map file


sort RS 
destring RS, replace // RS is saved as a string (str5), but for merging later on we need integer format
rename RS nuts07_3   

save "$data\db.dta", replace







use "$data\db.dta", clear

merge n:1 nuts07_3 using "$data\Map.dta", keepusing(nuts07_3_adj fua nuts07_3_fua_adj)
drop _merge

gen type = .
replace type = 0 if fua==. // Independent NUTS-3 Regions
replace type = 1 if fua!=. // NUTS-3 region belonging to FUA


label define type 0 "Independent NUTS-3 Regions" 1 "NUTS-3 Regions Belonging to FUA" 
label values type type

tab type, m



spmap using "$data\coord.dta", id(mapid) clmethod(unique) // NUTS-3 regions by type
graph export "$fig\Map_1.png", replace width(1000)

spmap type using "$data\coord.dta", id(mapid) clmethod(unique) legend(pos(6) ring(1)) // NUTS-3 regions by type


mergepoly mapid using "$data\coord.dta", by(nuts07_3_adj) coor("$data\coord_nuts07_3_adj.dta") replace
spmap type using "$data\coord_nuts07_3_adj", id(mapid) clmethod(unique) legend(pos(6) ring(1)) // adjusted NUTS-3 regions by type
graph export "$fig\Map_1_Without_Enclaves.png", replace width(1000)











use "$data\db.dta", clear

merge n:1 nuts07_3 using "$data\Map.dta", keepusing(nuts07_3_adj fua nuts07_3_fua_adj)
drop _merge

gen type = .
replace type = 0 if fua==. // Independent NUTS-3 Regions
replace type = 1 if fua!=. // NUTS-3 region belonging to FUA


label define type 0 "Independent NUTS-3 Regions" 1 "NUTS-3 Regions Belonging to FUA" 
label values type type


tab type, m



mergepoly mapid using "$data\coord.dta", by(nuts07_3_fua_adj) coor("$data\coord_nuts07_3_fua_adj.dta") replace

spmap using "$data\coord_nuts07_3_fua_adj.dta", id(mapid) clmethod(unique) // FUAs by type



spmap type using "$data\coord_nuts07_3_fua_adj.dta", id(mapid) clmethod(unique) legend(pos(6) ring(1)) // FUAs by type
graph export "$fig\Map_2.png", replace width(1000)












use "$data\db.dta", clear

merge n:1 nuts07_3 using "$data\Map.dta", keepusing(nuts07_3_adj fua nuts07_3_fua_adj)
drop _merge

gen type = .
replace type = 0 if fua==. // Independent NUTS-3 Regions
replace type = 1 if fua!=. // NUTS-3 region belonging to FUA


label define type 0 "Independent NUTS-3 Regions" 1 "NUTS-3 Regions Belonging to FUA" 
label values type type


tab type, m

mergepoly mapid using "$data\coord.dta", by(nuts07_3_adj) coor("$data\coord_nuts07_3_adj.dta") replace

spmap type using "$data\coord_nuts07_3_adj.dta", id(mapid) clmethod(unique) ocolor(black) osize(vthin) legstyle(1) polygon( data("$data\coord_nuts07_3_fua_adj.dta") ocolor(black) osize(medthick) legenda(on) leglabel("FUAs")) legend(pos(6) ring(1)) // FUAs by type
graph export "$fig\Map_3.png", replace width(1000)





*** 2.7 SHARE OF WITHIN-4-DIGIT OCCUPATIONS TRANSITIONS IN WITHIN-2-DIGIT OCCUPATIONS TRANSITIONS


	
		
***** First step: create a database with variables for observations at t and at t-1 (to avoid tsetting)

** create a dataset with relevant variables for job matches in the previous year

use "$data\HHI_Arnold_V1.dta", clear

clonevar an = year // create numeric variable for years
replace an=an+1

tab an, m // should match with years 2012-2017
	
*drop if an==2018 // maxyear     = t-1 = 2017, i.e. for t=2018 (not part of 2012-2017 and therefore irrelevant)
drop if an==2019 // maxyear + 1 = t-1 = 2018, i.e. for t=2019 (not part of 2012-2017 and therefore irrelevant)





*** first condition for identification of main job: main job one year ago should be at least 30 days duration
keep if duration>=30

rename isco08_4_imp isco08_4_imp_1
rename duration duration_1
*rename $nbheur nbheur_1
rename wage_sum wage_sum_1

keep an betnr prs_id duration_1 isco08_4_imp_1 wage_sum_1

drop if isco08_4_imp==.


sort prs_id betnr an

duplicates report prs_id betnr an


save "$data\indiv_origin2.dta", replace






*** merging with variable containing  current job matches


use "$data\HHI_Arnold_V1.dta", clear

clonevar an = year // create numeric variable for years

tab an, m // should match with years 2012-2017

drop if an==2011 // minyear
*drop if an==2018 // maxyear 


keep if duration>=30 // note that this is the standard condition on durations - at least 9 months applies only to the year before


*keep industries

tab wz08_2_imp, m
keep if (wz08_2_imp>=5 & wz08_2_imp<=82) | wz08_2_imp==90 | (wz08_2_imp>=92 & wz08_2_imp<=96)  // keep only non-agricultural business sector







* find new hires and keep only new hires
*sort prs_id betnr an
*merge m:1 prs_id betnr an using "$dat\P1sircom.dta"
*drop if _merge==2
*drop _merge

*ge ftpt=(ce=="C") // this condition must be deblocked to run the code in France					
*sort prs_id an
*merge m:1 prs_id an using P1
*drop if _m==2
*drop _m

*ge Hire=(P1ysir!=1)
*ge Emp1y=(Hire*P1y==1)

rename inflow Hire
rename employment Emp1y

					
keep if Hire==1	



				

* merging with records of the previous year				
sort prs_id betnr an
merge 1:1 prs_id betnr an using "$data\indiv_origin2.dta"
rename _merge mergeorigin // _merge==1 & _merge==2 are kept!


sort prs_id an

* saving a temporary file containing, on the same line, 
save "$data\temp_t2.dta", replace




*** second step: identifying the main job previous year among those with at least 30 days duration
* looping over years


foreach y of numlist 2012/2018 {
	
	
	display "Year: `y'"
	
	quietly {
	
		use "$data\temp_t2.dta", clear

		gen p1=1 
		
		keep if an==`y'


		
	
		* second condition: pick that with the same occupation, if there is any
		
		ge occorigin = .
		
		levelsof isco08_4_imp_1, local(isco)

		foreach p of local isco {
			
			*disp 2014 `p'
						
			gen p1_`p' = (isco08_4_imp_1==`p')
			egen maxp1_`p' = max(p1_`p'), by(prs_id)
			replace occorigin = `p' if isco08_4_imp==`p' & maxp1_`p'==1
			drop p1_`p' maxp1_`p'
					
		}		
		
		
		* indicators for max duration, max hours (if same duration) and max salary (if same duration and hours)
		
		egen maxdp = max(duration_1), by(prs_id)	
		
		egen maxw = max(wage_sum_1)	if abs(maxdp-duration_1)<1, by(prs_id)		

	
		** NOTE: in order to "transfer" the occupation of origin from one job match the year before to a current one, I use the operator "mode"
		* which works also for alphanumeric variables
		
		* third condition: pick the one with the longest duration, if there are no ties
		* identify occupations of job matches with longest duration 
		
		gen occmode = isco08_4_imp_1 if abs(maxdp-duration_1)<1 & occorigin==.
		
		* tag = number of maximum duration minus 1 per individual
		duplicates tag prs_id if occmode!=., gen(tag)
		
		* tag2 = number of maximum duration minus 1 per individual and occupation
		duplicates tag prs_id occmode if occmode!=., gen(tag2)
		
		* choose the occupation with the modal maximum duration if this is unique (per individual)
		egen mode = mode(occmode) if tag==tag2, by(prs_id)
		replace occorigin = mode if occorigin==.
		drop mode occmode tag tag2

	
		* fourth condition: among the new ties, pick the one with the longest hours, if there are no new ties 
		* (occmode, tag, tag2 & mode play the same role as before)
		*ge occmode=isco08_4_imp_1 if abs(maxdp-duration_1)<1&abs(maxh-nbheur_1)<1
		*duplicates tag prs_id if occmode!=., ge(tag)
		*duplicates tag prs_id occmode if occmode!=., ge(tag2)
		*egen mode=mode(occmode) if tag==tag2, by(prs_id)
		*replace occorigin=mode if occorigin==.
		*drop mode occmode tag tag2
		
		* fifth condition: among the new ties, pick the one with the highest salary, if there are no new ties
		* (occmode, tag, tag2 & mode play the same role as before)
		gen occmode = isco08_4_imp_1 if abs(maxdp-duration_1)<1 & abs(maxw-wage_sum_1)<1
		duplicates tag prs_id if occmode!=., gen(tag)
		duplicates tag prs_id occmode if occmode!=., gen(tag2)
		egen mode = mode(occmode) if tag==tag2, by(prs_id)
		replace occorigin = mode if occorigin==.
		drop mode occmode tag tag2

	* sixth condition: among the new ties, pick the most frequent, if there are no new ties
		gen occmode = isco08_4_imp_1 if abs(maxdp-duration_1)<1 & abs(maxw-wage_sum_1)<1 & occorigin==.
		egen mode = mode(occmode), by(prs_id)
		replace occorigin = mode if occorigin==.
		drop mode occmode

		* seventh condition: among the new ties, pick one at random
		set seed 1
		gen u = runiform()
		gen d = abs((_n/_N)-u)
		egen mind=min(d) if abs(maxdp-duration_1)<1 & abs(maxw-wage_sum_1)<1 & occorigin==., by(prs_id)
		gen occmode = isco08_4_imp_1 if abs(maxdp-duration_1)<1 & abs(maxw-wage_sum_1)<1 & abs(mind-d)<0.00000001 & occorigin==.
		egen mode = mode(occmode), by(prs_id)
		replace occorigin = mode if occorigin==.
		drop mode occmode
		
		
	** cleaning up (normally not needed)

		keep if isco08_4_imp!=.
		keep if occorigin!=.
		
		compress
		
		save "$data\temp_t`y'2.dta", replace		
		
	}
	
}




*** third step: construct a squared matrix of occupation

use "$data\LMC_4_4_1218.dta", clear

collapse (sum) L_year_01_4_4, by(isco08_4_imp)
ge one=1
rename L_year_01_4_4 Z_P00
sort one
save "$data\pcs_list2.dta", replace


rename isco08_4_imp occorigin
rename Z_P00 Z_P01
sort one
joinby one using "$data\pcs_list2.dta"

keep isco08_4_imp occorigin Z_P01 Z_P00
sort isco08_4_imp occorigin
save "$data\pcs_squared2.dta", replace




*** fourth step: transition probabilities

* create a frequency dataset by current and previous year occupations (main job only as defined above for previous year) 

clear

set obs 1

gen v1 = .

save "$data\tprob2.dta", replace

foreach y of numlist 2012/2018 {
	
	use "$data\temp_t`y'2.dta", clear
	
	collapse (sum) p1, by(occorigin isco08_4_imp ) // this transforms p1 in a variable that counts transitions
	replace p1 = 0 if p1==.
	
	gen year = "`y'"
	
	append using "$data\tprob2.dta"
	save "$data\tprob2.dta", replace

	
}

use "$data\tprob2.dta", clear

drop if p1==.

* summing frequency over years
collapse (sum) p1, by(isco08_4_imp occorigin) // transitions are now aggregated across years
label var p1 "frequency of occupation couple"
sort isco08_4_imp occorigin


* ensure that all occupations are included in the transition matrix
merge 1:1 isco08_4_imp occorigin using "$data\pcs_squared2.dta"
drop if _merge==1
replace p1 = 0 if p1==.

* cleaning
drop _merge
sort isco08_4_imp occorigin
compress

*generate dummy for within-2-digit transition
tostring isco08_4_imp, force replace
tostring occorigin, force replace


gen length_1 = length(isco08_4_imp)
gen length_2 = length(occorigin)

replace isco08_4_imp = "0" + isco08_4_imp if length_1==3
replace occorigin = "0" + occorigin if length_2==3
drop length_*

gen same2=(substr(isco08_4_imp ,1,2)==substr(occorigin,1,2))

*generate dummy for within-4-digit transition
gen same4=(isco08_4_imp==occorigin)

*generate occupation codes for 2-digit occupations of origin
gen occ2=substr(occorigin,1,2)

*generate frequency of within 2 and 4 digit transitions
gen trans2=p1*same2
gen trans4=p1*same4

*collapse at occ2 level and compute share of within-2-digit transitions accounted for by 4-digit transitions
collapse (sum) trans2 trans4 p1, by(occ2)

gen ratio = trans4/trans2
sum ratio [aw=p1] // Footnote 33: the mean is the desired statistic = 86.6 percent



	


