

*** 1. PREPARATION OF DATA ***




*** 1.1 DELINEATION OF FUNCTIONAL AREAS ***


*** MUNICIPALITIES (LAUs) ***


*source: GENESIS-Regional, time series: 11111-01-01-5

import excel using "$orig\FUAs\11111-01-01-5.xlsx", cellrange(A6:C13921) clear

drop if C=="-" // dissolved municipalities


replace A = "02000" if A=="02" // Hamburg
replace A = "11000" if A=="11" // Berlin

gen length = strlen(A)
tab length, m

drop if length==2 // drop NUTS-1 regions (except Berlin and Hamburg)
drop if length==3 // drop NUTS-2 regions

count if length==5 // 401 NUTS-3 regions = 294 districts + 107 independent cities (excluding S)

destring A, replace force
rename A lau17

gen district = .
replace district = 0 if length==8


gen string_kreisfreiestadt = ""
replace string_kreisfreiestadt = substr(B,-16,16)
replace string_kreisfreiestadt = "" if string_kreisfreiestadt!="Kreisfreie Stadt"
replace string_kreisfreiestadt = substr(B,7,16) if string_kreisfreiestadt==""
replace string_kreisfreiestadt = "" if string_kreisfreiestadt!="Kreisfreie Stadt"
replace district = 0 if string_kreisfreiestadt=="Kreisfreie Stadt" & length==5 & district==.

gen string_krsfrstadt = substr(B,-12,12)
replace string_krsfrstadt="" if string_krsfrstadt!="krsfr. Stadt" 
replace district = 0 if string_krsfrstadt=="krsfr. Stadt" & length==5 & district==.

gen string_stadt = substr(B,-5,5)
replace string_stadt="" if string_stadt!="Stadt" 
replace district = 0 if string_stadt=="Stadt" & length==5 & district==.

gen string_stadtkreis = substr(B,-10,10)
replace string_stadtkreis="" if string_stadtkreis!="Stadtkreis" 
replace district = 0 if string_stadtkreis=="Stadtkreis" & length==5 & district==.

replace district = 0 if lau17== 2000 // Hamburg
replace district = 0 if lau17== 9161 // Ingolstadt
replace district = 0 if lau17== 9162 // München, Landeshaupstadt
replace district = 0 if lau17== 9163 // Rosenheim
replace district = 0 if lau17== 9261 // Landshut
replace district = 0 if lau17== 9262 // Passau
replace district = 0 if lau17== 9263 // Straubing
replace district = 0 if lau17== 9361 // Amberg
replace district = 0 if lau17== 9362 // Regensburg
replace district = 0 if lau17== 9363 // Weiden i.d. OPf.
replace district = 0 if lau17== 9461 // Bamberg
replace district = 0 if lau17== 9462 // Bayreuth
replace district = 0 if lau17== 9463 // Coburg
replace district = 0 if lau17== 9464 // Hof
replace district = 0 if lau17== 9561 // Ansbach
replace district = 0 if lau17== 9562 // Erlangen
replace district = 0 if lau17== 9563 // Fürth
replace district = 0 if lau17== 9564 // Nürnberg
replace district = 0 if lau17== 9565 // Schwabach
replace district = 0 if lau17== 9661 // Aschaffenburg
replace district = 0 if lau17== 9662 // Schweinfurt
replace district = 0 if lau17== 9663 // Würzburg
replace district = 0 if lau17== 9761 // Augsburg
replace district = 0 if lau17== 9762 // Kaufbeuren
replace district = 0 if lau17== 9763 // Kempten (Allgäu)
replace district = 0 if lau17== 9764 // Memmingen
replace district = 0 if lau17==11000 // Berlin



gen string_landkreis = ""
replace string_landkreis=substr(B,-9,9)
replace string_landkreis="" if string_landkreis!="Landkreis"
replace string_landkreis=substr(B,7,9) if string_landkreis==""
replace string_landkreis="" if string_landkreis!="Landkreis"
replace district = 1 if string_landkreis=="Landkreis" & length==5 & district==.

gen string_kreis = substr(B,-5,5)
replace string_kreis="" if string_kreis!="Kreis" & string_kreis!="kreis"
replace district = 1 if ( string_kreis=="Kreis" | string_kreis=="kreis" ) & length==5 & district==.

replace district = 1 if lau17== 3159 // Göttingen, Landkreis
replace district = 1 if lau17== 3241 // Region Hannover
replace district = 1 if lau17== 5162 // Rhein-Kreis Neuss
replace district = 1 if lau17== 5334 // Städteregion Aachen
replace district = 1 if lau17== 7232 // Eifelkreis Bitburg-Prüm
replace district = 1 if lau17==10041 // Saarbrücken Regionalverband
replace district = 1 if lau17==15081 // Altmarkkreis Salzwedel

tab district if length==5, m // 294 districts + 107 independent cities

drop if district==1 // drop NUTS-3 regions that are not an independent city (and therefore not a municipality)
drop district string_*

tostring lau17, replace force

replace lau17 = lau17 + "001" if length==5

drop length

destring lau17, replace force

rename B lau17_name

rename C lau17_area
destring lau17_area, replace force


tostring lau17, gen(lau17_string)

replace lau17_string = "0" + lau17_string if lau17<=9780451

gen nuts07_3 = substr(lau17_string,1,5)

destring nuts07_3, replace force




quietly do "$prog\NUTS07-3.do"
label values nuts07_3 nuts07_3




gen string = substr(lau17_string, -3, 3)
replace string = "" if string!="001"

drop if lau17>=11001001 & lau17<=11012012 // drop municipalities in Berlin (not differentiated in BeH)



replace string="" if inlist(lau17, ///
 1051001,  1053001,  1054001,  1055001,  1056001,  1057001,  1058001,  1059001, ///
 1061001,  1062001,  3151001,  3152001,  3154001,  3155001,  3157001,  3159001, /// 
 3241001,  3251001,  3252001,  3254001,  3255001,  3256001,  3257001,  3351001, ///   
 3353001,  3354001,  3355001,  3356001,  3357001,  3358001,  3359001,  3360001, ///   
 3361001,  3451001,  3452001,  3453001,  3454001,  3456001,  3458001,  3459001, ///   
 3460001,  3461001,  3462001,  6431001,  6432001,  6433001,  6434001,  6435001, ///   
 6436001,  6437001,  6438001,  6439001,  6440001,  6531001,  6532001,  6533001, ///   
 6534001,  6535001,  6631001,  6632001,  6633001,  6634001,  6635001,  6636001, ///   
 7131001,  7132001,  7133001,  7134001,  7135001,  7137001,  7140001,  7141001, ///   
 7143001,  7231001,  7232001,  7235001,  7331001,  7332001,  7333001,  7334001, ///   
 7336001,  7337001,  7338001,  7339001,  7340001,  8115001,  8117001,  8118001, ///   
 8119001,  8125001,  8225001,  8317001,  8325001,  8335001,  8426001,  8436001, ///  
13071001, 13072001, 13073001, 13074001, 13075001, 13076001, 16061001, 16065001, ///  
16068001, 16069001, 16070001, 16071001, 16073001, 16074001, 16077001 )

drop lau17

rename lau17_string lau17

replace lau17 = substr(lau17, 1, 5) + "000" if string=="001" // 107 changes = 107 independent cities
drop string

destring lau17, replace force



*note: some old municipalities in Thuringia were grouped together to new municipalities already on 31 Dec 2019 (and NOT only on 1 Jan 2020) and are thus no longer part of this table (which refers to 31 Dec 2019)
*however: this change came only into effect in BeH on 1 Jan 2020 (this BeH version here refers to 31 Dec 2019)
*therefore: replace new municipalities by their old ones in this table

drop if lau17==16063104 // Amt Creuzburg
input
16063013 "Creuzburg, Stadt"			35.40	16063
16063019 "Ebenshausen"			     2.62	16063	
16063055 "Mihla"					31.66	16063
end


drop if lau17==16064077 // Nottertal-Heilinger Höhen, St. 
input
16064008 "Bothenheilingen"			 9.47	16064
16064029 "Issersheilingen"			 4.22	16064	
16064035 "Kleinwelsbach"			 3.46	16064
16064048 "Neunheilingen"			14.75	16064
16064052 "Obermehler"				21.66	16064
16064057 "Schlotheim, Stadt"		22.40	16064

end


replace lau17_area=40.74 if lau17==16065014 // Ebeleben, Stadt
input
16065072 "Thüringenhausen"			  3.8	16065
end

replace lau17_area=89.88 if lau17==16066042 // Meiningen, Stadt
input
16066071 "Stepfershausen"			15.76	16066
end



drop if lau17==16067092 // Georgenthal 
input
16067025 "Georgenthal/Thür. Wald"	28.82	16067
16067039 "Hohenkirchen"			     6.80	16067	
16067054 "Petriroda"		     	 3.15	16067
16067083 "Leinatal"			        36.01	16067
end


replace lau17_area=14.85 if lau17==16068053 // Straußfurt
input
16068026 "Henschleben"			    6.99	16068
end



replace lau17_area=8.9 if lau17==16070034 // Martinroda
input
16070003 "Angelroda"			    4.95	16070
end


replace lau17_area=73.63 if lau17==16070028 // Amt Wachsenburg
input
16070044 "Rockhausen"			    4.01	16070
end


drop if lau17==16071103 // Grammetal 
input
16071006 "Bechstedtstraß"	        5.75	16071
16071012 "Daasdorf a. Berge"	    2.85	16071	
16071034 "Hopfgarten"	            9.11	16071
16071036 "Isseroda"	                3.91	16071
16071057 "Mönchenholzhausen"	   19.42	16071	
16071065 "Niederzimmern"	       13.22	16071
16071067 "Nohra"	               19.64	16071
16071073 "Ottstedt a. Berge"	    5.11	16071	
16071088 "Troistedt"	            9.27	16071
end

replace lau17_area=48.31 if lau17==16071004 // Bad Sulza
input
16071099 "Saaleplatte"			   42.83	16071
end

replace lau17_area=33.56 if lau17==16072015 // Schalkau, Stadt
input
16072001 "Bachfeld"			       10.46	16072
end

replace lau17_area=74.65 if lau17==16075098 // Schleiz, Stadt
input
16075009 "Burgk"			       13.66	16075
end

replace lau17_area=44.18 if lau17==16075073 // Neustadt an der Orla
input
16075018 "Dreba"			       12.47	16075
16075049 "Knau"			           12.76	16075
16075061 "Linda b. Neustadt/Orla"  16.67	16075

end


replace lau17_area=76.43 if lau17==16076022 // Greiz, Stadt
input
16076052 "Neumühle/Elster"			 8.43	16076
end




bysort nuts07_3: egen nuts07_3_area = total(lau17_area)


label variable lau17 "Municipality"
label variable lau17_area "Area (in sqkm)"


label variable nuts07_3 "District (NUTS-3)"
label variable nuts07_3_area "Area (in sqkm)"


save "$data\LAU.dta", replace






*** FUNCTIONAL URBAN AREAS (FUAs) ***


*source: http://www.oecd.org/cfe/regionaldevelopment/functionalurbanareasbycountry.htm


import excel using "$orig\FUAs\list-of-municipalities-in-functional-urban-areas.xls", cellrange(A17940:G23957) sheet("list_mun") clear

keep C D F G

gen fua = substr(C,3,3)
destring fua, force replace
drop C

rename D fua_name

rename F lau17_old_name

gen lau17_fua = substr(G, 3, 12)
drop G

*format %12.0f lau17_fua 


duplicates report lau17_fua



label define fua 1 "1 Berlin", modify
label define fua 2 "2 Hamburg", modify
label define fua 3 "3 Munich", modify
label define fua 4 "4 Cologne", modify
label define fua 5 "5 Frankfurt am Main", modify
label define fua 7 "7 Stuttgart", modify
label define fua 8 "8 Leipzig", modify
label define fua 9 "9 Dresden", modify
label define fua 11 "11 Duesseldorf", modify
label define fua 12 "12 Bremen", modify
label define fua 13 "13 Hanover", modify
label define fua 14 "14 Nuremberg", modify
label define fua 17 "17 Bielefeld", modify
label define fua 18 "18 Halle an der Saale", modify
label define fua 19 "19 Magdeburg", modify
label define fua 20 "20 Wiesbaden", modify
label define fua 21 "21 Gottingen", modify
label define fua 25 "25 Darmstadt", modify
label define fua 26 "26 Trier", modify
label define fua 27 "27 Freiburg im Breisgau", modify
label define fua 28 "28 Regensburg", modify
label define fua 29 "29 Frankfurt", modify
label define fua 30 "30 Weimar", modify
label define fua 31 "31 Schwerin", modify
label define fua 32 "32 Erfurt", modify
label define fua 33 "33 Augsburg", modify
label define fua 34 "34 Bonn", modify
label define fua 35 "35 Karlsruhe", modify
label define fua 36 "36 Moenchengladbach", modify
label define fua 37 "37 Mainz", modify
label define fua 38 "38 Ruhr", modify
label define fua 39 "39 Kiel", modify
label define fua 40 "40 Saarbrucken", modify
label define fua 42 "42 Koblenz", modify
label define fua 43 "43 Rostock", modify
label define fua 44 "44 Kaiserslautern", modify
label define fua 45 "45 Iserlohn", modify
label define fua 48 "48 Wilhelmshaven", modify
label define fua 50 "50 Tuebingen", modify
label define fua 51 "51 Villingen-Schwenningen", modify
label define fua 52 "52 Flensburg", modify
label define fua 53 "53 Marburg", modify
label define fua 54 "54 Constance", modify
label define fua 55 "55 Neumunster", modify
label define fua 56 "56 Brandenburg an der Havel", modify
label define fua 57 "57 Giessen", modify
label define fua 58 "58 Lueneburg", modify
label define fua 59 "59 Bayreuth", modify
label define fua 60 "60 Celle", modify
label define fua 61 "61 Aschaffenburg", modify
label define fua 62 "62 Bamberg", modify
label define fua 63 "63 Plauen", modify
label define fua 64 "64 Neubrandenburg", modify
label define fua 65 "65 Fulda", modify
label define fua 66 "66 Kempten (Allgovia)", modify
label define fua 67 "67 Landshut", modify
label define fua 69 "69 Rosenheim", modify
label define fua 71 "71 Stralsund", modify
label define fua 72 "72 Friedrichshafen", modify
label define fua 73 "73 Offenburg", modify
label define fua 74 "74 Goerlitz", modify
label define fua 77 "77 Schweinfurt", modify
label define fua 78 "78 Greifswald", modify
label define fua 79 "79 Wetzlar", modify
label define fua 81 "81 Passau", modify
label define fua 82 "82 Dessau", modify
label define fua 83 "83 Braunschweig-Wolfsburg", modify
label define fua 84 "84 Mannheim-Ludwigshafen", modify
label define fua 504 "504 Muenster", modify
label define fua 505 "505 Chemnitz", modify
label define fua 507 "507 Aachen", modify
label define fua 508 "508 Krefeld", modify
label define fua 510 "510 Luebeck", modify
label define fua 513 "513 Kassel", modify
label define fua 516 "516 Solingen", modify
label define fua 517 "517 Osnabrueck", modify
label define fua 520 "520 Oldenburg", modify
label define fua 522 "522 Heidelberg", modify
label define fua 523 "523 Paderborn", modify
label define fua 524 "524 Wuerzburg", modify
label define fua 527 "527 Bremerhaven", modify
label define fua 529 "529 Heilbronn", modify
label define fua 530 "530 Remscheid", modify
label define fua 532 "532 Ulm", modify
label define fua 533 "533 Pforzheim", modify
label define fua 534 "534 Ingolstadt", modify
label define fua 535 "535 Gera", modify
label define fua 537 "537 Reutlingen", modify
label define fua 539 "539 Cottbus", modify
label define fua 540 "540 Siegen", modify
label define fua 542 "542 Hildesheim", modify
label define fua 544 "544 Zwickau", modify
label define fua 546 "546 Wuppertal", modify
label define fua 547 "547 Jena", modify
label define fua 548 "548 Dueren", modify
label define fua 549 "549 Bocholt", modify


label save fua using "$prog\FUA.do", replace

label values fua fua


drop fua_name


sort lau17_fua lau17_old_name fua
order lau17_fua lau17_old_name fua


gen nuts07_1 = substr(lau17_fua, 1, 2)
destring nuts07_1, replace force

quietly do "$prog\NUTS07-1.do"
label values nuts07_1 nuts07_1



gen lau17_old = "" 

replace lau17_old = substr(lau17_fua, 1, 3) + substr(lau17_fua, 5, 2) + substr(lau17_fua, 10, 3) if inlist(nuts07_1, 1, 4, 5, 6, 8, 9, 10, 12, 13)
replace lau17_old = "02000001" if nuts07_1==2
replace lau17_old = substr(lau17_fua, 1, 2) + substr(lau17_fua, 4, 3) + substr(lau17_fua, 10, 3) if inlist(nuts07_1, 3, 7, 14, 15, 16)
replace lau17_old = "11000001" if nuts07_1==11



gen string = substr(lau17_old, -3, 3)
replace string = "" if string!="001"

destring lau17_old, generate(lau17_old_numeric)

replace string="" if inlist(lau17_old_numeric,  1053001,  1055001,  1056001,  1057001,  1058001,  1059001,  1062001 ///
,  3151001,  3152001,  3154001,  3155001,  3157001,  3241001,  3251001 ///
,  3254001,  3257001,  3351001,  3353001,  3355001,  3356001,  3357001 ///
,  3359001,  3361001,  3451001,  3458001,  3459001,  6431001,  6432001 ///
,  6433001,  6434001,  6435001,  6436001,  6438001,  6439001,  6440001 ///
,  6531001,  6532001,  6534001,  6631001,  6633001,  7132001,  7137001 ///
,  7235001,  7332001,  7336001,  7338001,  7339001,  8115001,  8117001 ///
,  8118001,  8119001,  8125001,  8317001,  8335001, 13071001, 13072001 ///
, 13073001, 13075001, 13076001, 16068001, 16070001, 16071001, 16074001 ) 


drop lau17_old_numeric

replace lau17_old = substr(lau17_old, 1, 5) + "000" if string=="001" // 91 changes = 107 independent cities - 16 independent cities without FUA
drop string

destring lau17_old, replace force
drop lau17_fua


preserve // translate old LAU codes from FUA dataset (from around 2012) into newest municipality code from BeH (31 Dec 2019)

	use "$orig\FUAs\gebiet_ba_schl_v8_02_202006_2019.dta", clear

	destring, force replace

	keep gem_region_schl_alt gem_region_schl_neu
	drop if gem_region_schl_alt==. 
	drop if gem_region_schl_neu==.


	duplicates drop
	rename gem_region_schl_alt lau17_old
	rename gem_region_schl_neu lau17

	duplicates report lau17_old // there are ambiguities for five old municipality codes --> municipality was divided and merged to different other municipalities

	duplicates tag lau17_old, gen(dup)
	*br if dup==1 // municipality codes with ambiguities are: 1054033 5915000 12064036 12064304 14383010
	drop dup
	
	
	bysort lau17_old: gen n = _n
	tab n, m

	order lau17_old n lau17

	duplicates report lau17_old n

	save "$data\LAU_translation.dta", replace


restore
 
 
duplicates report lau17_old
 
expand 2 if lau17_old== 1054033 // does not belong to FUA --> irrelevant
expand 2 if lau17_old== 5915000 // relevant
expand 2 if lau17_old==12064036 // does not belong to FUA --> irrelevant 
expand 2 if lau17_old==12064304 // does not belong to FUA --> irrelevant
expand 2 if lau17_old==14383010 // does not belong to FUA --> irrelevant
 
duplicates report lau17_old

bysort lau17_old: gen n = _n
 
tab n, m 


merge 1:1 lau17_old n using "$data\LAU_translation.dta", keepusing(lau17)
sort _merge lau17_old

*drop if _merge==1 // drop municipalities without workplaces (not existent in BeH)
replace lau17 = lau17_old if _merge==1 & !inlist(lau17_old, 8317971, 8415971, 9375454, 9472457, 9671452, 9671454, 9677462)
drop if inlist(lau17_old, 8317971, 8415971, 9375454, 9472457, 9671452, 9671454, 9677462) // heuristic from line above does not work





drop if _merge==2 // drop BeH codes without match in FUA (either no FUA for municipality or outdated municipality code)



rename _merge merge_type

*br if lau17_old==5915000 // old municipality code refers to two different new municipality codes --> unproblematic
drop n

keep lau17 fua // lau17_old merge_type

sort lau17 fua
order lau17 fua // lau17_old merge_type


duplicates drop // duplicates due to merging of smaller municipalities into a new larger one

duplicates report lau17 // no duplicates 

label variable lau17 "Municipality"
label variable fua "Functional Urban Area"

save "$data\FUA.dta", replace






*** ASSIGNMENT BETWEEN LAUs AND FUAs ***


use "$data\LAU.dta", replace

merge 1:1 lau17 using "$data\FUA.dta", keepusing(fua)

sort _merge
drop if _merge==2 // irrelevant or dissolved municipalities
drop _merge

preserve

	keep nuts07_3 fua
	duplicates drop
	bysort nuts07_3: gen N = _N
	
	tab nuts07_3 if N>1, m // note: FUA assignment is entirely based on NUTS-3 region, four exemptions: Goettingen, District + Trier-Saarburg, District + Barnim, District + Vorpommern-Greifswald, District --> likely errors --> correction necessary

	
	keep if fua!=.
	keep nuts07_3
	

	duplicates drop
	save "$data\FUA_nuts.dta", replace

	

restore





sort lau17

gen lau_17_area_fua = 0
replace lau_17_area_fua = lau17_area if fua==.


sort nuts07_3

by nuts07_3: egen nuts07_3_area_fua = total(lau_17_area_fua)

gen non_fua_share = nuts07_3_area_fua / nuts07_3_area

replace non_fua_share = round(non_fua_share, 0.01)

tab non_fua_share, m // FUA delineation is almost entirely based on NUTS-3 regions --> correct for outliers in next step




*correct for errors in FUA code

replace fua = 21 if nuts07_3==3159 // Goettingen, District --> several municipalities affected
replace fua = 26 if nuts07_3==7235 // Trier-Saarburg, Disrict --> one municipality affected only (7235207 Trittenheim)
replace fua = . if nuts07_3==12060 // Barnim, District  --> one municipality affected only (12060005 Ahrensfelde)
replace fua = 78 if nuts07_3==13075 // Vorpommern-Greifswald --> munipalities belong to two FUAs --> assign all to FUA of Greifswald whose share in this NUTS-3 region is about ten times higher than the share of FUA Neubrandenburg





gen nuts07_3_fua = .

replace nuts07_3_fua = fua if fua!=.
replace nuts07_3_fua = nuts07_3 if fua==. // & non_fua_share>0.7


tab nuts07_3_fua, m


keep lau17 lau17_name nuts07_3 fua nuts07_3_fua


label define nuts07_3_fua 1 "1 Berlin", modify
label define nuts07_3_fua 2 "2 Hamburg", modify
label define nuts07_3_fua 3 "3 Munich", modify
label define nuts07_3_fua 4 "4 Cologne", modify
label define nuts07_3_fua 5 "5 Frankfurt am Main", modify
label define nuts07_3_fua 7 "7 Stuttgart", modify
label define nuts07_3_fua 8 "8 Leipzig", modify
label define nuts07_3_fua 9 "9 Dresden", modify
label define nuts07_3_fua 11 "11 Duesseldorf", modify
label define nuts07_3_fua 12 "12 Bremen", modify
label define nuts07_3_fua 13 "13 Hanover", modify
label define nuts07_3_fua 14 "14 Nuremberg", modify
label define nuts07_3_fua 17 "17 Bielefeld", modify
label define nuts07_3_fua 18 "18 Halle an der Saale", modify
label define nuts07_3_fua 19 "19 Magdeburg", modify
label define nuts07_3_fua 20 "20 Wiesbaden", modify
label define nuts07_3_fua 21 "21 Gottingen", modify
label define nuts07_3_fua 25 "25 Darmstadt", modify
label define nuts07_3_fua 26 "26 Trier", modify
label define nuts07_3_fua 27 "27 Freiburg im Breisgau", modify
label define nuts07_3_fua 28 "28 Regensburg", modify
label define nuts07_3_fua 29 "29 Frankfurt/Oder", modify
label define nuts07_3_fua 30 "30 Weimar", modify
label define nuts07_3_fua 31 "31 Schwerin", modify
label define nuts07_3_fua 32 "32 Erfurt", modify
label define nuts07_3_fua 33 "33 Augsburg", modify
label define nuts07_3_fua 34 "34 Bonn", modify
label define nuts07_3_fua 35 "35 Karlsruhe", modify
label define nuts07_3_fua 36 "36 Moenchengladbach", modify
label define nuts07_3_fua 37 "37 Mainz", modify
label define nuts07_3_fua 38 "38 Ruhr", modify
label define nuts07_3_fua 39 "39 Kiel", modify
label define nuts07_3_fua 40 "40 Saarbrucken", modify
label define nuts07_3_fua 42 "42 Koblenz", modify
label define nuts07_3_fua 43 "43 Rostock", modify
label define nuts07_3_fua 44 "44 Kaiserslautern", modify
label define nuts07_3_fua 45 "45 Iserlohn", modify
label define nuts07_3_fua 48 "48 Wilhelmshaven", modify
label define nuts07_3_fua 50 "50 Tuebingen", modify
label define nuts07_3_fua 51 "51 Villingen-Schwenningen", modify
label define nuts07_3_fua 52 "52 Flensburg", modify
label define nuts07_3_fua 53 "53 Marburg", modify
label define nuts07_3_fua 54 "54 Constance", modify
label define nuts07_3_fua 55 "55 Neumunster", modify
label define nuts07_3_fua 56 "56 Brandenburg an der Havel", modify
label define nuts07_3_fua 57 "57 Giessen", modify
label define nuts07_3_fua 58 "58 Lueneburg", modify
label define nuts07_3_fua 59 "59 Bayreuth", modify
label define nuts07_3_fua 60 "60 Celle", modify
label define nuts07_3_fua 61 "61 Aschaffenburg", modify
label define nuts07_3_fua 62 "62 Bamberg", modify
label define nuts07_3_fua 63 "63 Plauen", modify
label define nuts07_3_fua 64 "64 Neubrandenburg", modify
label define nuts07_3_fua 65 "65 Fulda", modify
label define nuts07_3_fua 66 "66 Kempten (Allgovia)", modify
label define nuts07_3_fua 67 "67 Landshut", modify
label define nuts07_3_fua 69 "69 Rosenheim", modify
label define nuts07_3_fua 71 "71 Stralsund", modify
label define nuts07_3_fua 72 "72 Friedrichshafen", modify
label define nuts07_3_fua 73 "73 Offenburg", modify
label define nuts07_3_fua 74 "74 Goerlitz", modify
label define nuts07_3_fua 77 "77 Schweinfurt", modify
label define nuts07_3_fua 78 "78 Greifswald", modify
label define nuts07_3_fua 79 "79 Wetzlar", modify
label define nuts07_3_fua 81 "81 Passau", modify
label define nuts07_3_fua 82 "82 Dessau", modify
label define nuts07_3_fua 83 "83 Braunschweig-Wolfsburg", modify
label define nuts07_3_fua 84 "84 Mannheim-Ludwigshafen", modify
label define nuts07_3_fua 504 "504 Muenster", modify
label define nuts07_3_fua 505 "505 Chemnitz", modify
label define nuts07_3_fua 507 "507 Aachen", modify
label define nuts07_3_fua 508 "508 Krefeld", modify
label define nuts07_3_fua 510 "510 Luebeck", modify
label define nuts07_3_fua 513 "513 Kassel", modify
label define nuts07_3_fua 516 "516 Solingen", modify
label define nuts07_3_fua 517 "517 Osnabrueck", modify
label define nuts07_3_fua 520 "520 Oldenburg", modify
label define nuts07_3_fua 522 "522 Heidelberg", modify
label define nuts07_3_fua 523 "523 Paderborn", modify
label define nuts07_3_fua 524 "524 Wuerzburg", modify
label define nuts07_3_fua 527 "527 Bremerhaven", modify
label define nuts07_3_fua 529 "529 Heilbronn", modify
label define nuts07_3_fua 530 "530 Remscheid", modify
label define nuts07_3_fua 532 "532 Ulm", modify
label define nuts07_3_fua 533 "533 Pforzheim", modify
label define nuts07_3_fua 534 "534 Ingolstadt", modify
label define nuts07_3_fua 535 "535 Gera", modify
label define nuts07_3_fua 537 "537 Reutlingen", modify
label define nuts07_3_fua 539 "539 Cottbus", modify
label define nuts07_3_fua 540 "540 Siegen", modify
label define nuts07_3_fua 542 "542 Hildesheim", modify
label define nuts07_3_fua 544 "544 Zwickau", modify
label define nuts07_3_fua 546 "546 Wuppertal", modify
label define nuts07_3_fua 547 "547 Jena", modify
label define nuts07_3_fua 548 "548 Dueren", modify
label define nuts07_3_fua 549 "549 Bocholt", modify


label define nuts07_3_fua 1001 "1001 Flensburg, City", modify
label define nuts07_3_fua 1002 "1002 Kiel, City", modify
label define nuts07_3_fua 1003 "1003 Luebeck, City", modify
label define nuts07_3_fua 1004 "1004 Neumuenster, City", modify
label define nuts07_3_fua 1051 "1051 Dithmarschen, District", modify
label define nuts07_3_fua 1053 "1053 Herzogtum Lauenburg, District", modify
label define nuts07_3_fua 1054 "1054 Nordfriesland, District", modify
label define nuts07_3_fua 1055 "1055 Ostholstein, District", modify
label define nuts07_3_fua 1056 "1056 Pinneberg, District", modify
label define nuts07_3_fua 1057 "1057 Ploen, District", modify
label define nuts07_3_fua 1058 "1058 Rendsburg-Eckernfoerde, District", modify
label define nuts07_3_fua 1059 "1059 Schleswig-Flensburg, District", modify
label define nuts07_3_fua 1060 "1060 Segeberg, District", modify
label define nuts07_3_fua 1061 "1061 Steinburg, District", modify
label define nuts07_3_fua 1062 "1062 Stormarn, District", modify

label define nuts07_3_fua 2000 "2000 Hamburg, City", modify

label define nuts07_3_fua 3101 "3101 Braunschweig, City", modify
label define nuts07_3_fua 3102 "3102 Salzgitter, City", modify
label define nuts07_3_fua 3103 "3103 Wolfsburg, City", modify
label define nuts07_3_fua 3151 "3151 Gifhorn, District", modify
label define nuts07_3_fua 3153 "3153 Goslar, District", modify
label define nuts07_3_fua 3154 "3154 Helmstedt, District", modify
label define nuts07_3_fua 3155 "3155 Northeim, District", modify
label define nuts07_3_fua 3157 "3157 Peine, District", modify
label define nuts07_3_fua 3158 "3158 Wolfenbuettel, District", modify
label define nuts07_3_fua 3159 "3159 Goettingen, District", modify
label define nuts07_3_fua 3241 "3241 Region Hanover", modify
label define nuts07_3_fua 3251 "3251 Diepholz, District", modify
label define nuts07_3_fua 3252 "3252 Hamelin-Pyrmont, District", modify
label define nuts07_3_fua 3254 "3254 Hildesheim, District", modify
label define nuts07_3_fua 3255 "3255 Holzminden, District", modify
label define nuts07_3_fua 3256 "3256 Nienburg (Weser), District", modify
label define nuts07_3_fua 3257 "3257 Schaumburg, District", modify
label define nuts07_3_fua 3351 "3351 Celle, District", modify
label define nuts07_3_fua 3352 "3352 Cuxhaven, District", modify
label define nuts07_3_fua 3353 "3353 Harburg, District", modify
label define nuts07_3_fua 3354 "3354 Luechow-Dannenberg, District", modify
label define nuts07_3_fua 3355 "3355 Lueneburg, District", modify
label define nuts07_3_fua 3356 "3356 Osterholz, District", modify
label define nuts07_3_fua 3357 "3357 Rotenburg (Wuemme), District", modify
label define nuts07_3_fua 3358 "3358 Heidekreis", modify
label define nuts07_3_fua 3359 "3359 Stade, District", modify
label define nuts07_3_fua 3360 "3360 Uelzen, District", modify
label define nuts07_3_fua 3361 "3361 Verden, District", modify
label define nuts07_3_fua 3401 "3401 Delmenhorst, City", modify
label define nuts07_3_fua 3402 "3402 Emden, City", modify
label define nuts07_3_fua 3403 "3403 Oldenburg, City", modify
label define nuts07_3_fua 3404 "3404 Osnabrueck, City", modify
label define nuts07_3_fua 3405 "3405 Wilhelmshaven, City", modify
label define nuts07_3_fua 3451 "3451 Ammerland, District", modify
label define nuts07_3_fua 3452 "3452 Aurich, District", modify
label define nuts07_3_fua 3453 "3453 Cloppenburg, District", modify
label define nuts07_3_fua 3454 "3454 Emsland, District", modify
label define nuts07_3_fua 3455 "3455 Friesland, District", modify
label define nuts07_3_fua 3456 "3456 Grafschaft Bentheim", modify
label define nuts07_3_fua 3457 "3457 Leer, District", modify
label define nuts07_3_fua 3458 "3458 Oldenburg, District", modify
label define nuts07_3_fua 3459 "3459 Osnabrueck, District", modify
label define nuts07_3_fua 3460 "3460 Vechta, District", modify
label define nuts07_3_fua 3461 "3461 Wesermarsch, District", modify
label define nuts07_3_fua 3462 "3462 Wittmund, District", modify

label define nuts07_3_fua 4011 "4011 Bremen, City", modify
label define nuts07_3_fua 4012 "4012 Bremerhaven, City", modify

label define nuts07_3_fua 5111 "5111 Duesseldorf, City", modify
label define nuts07_3_fua 5112 "5112 Duisburg, City", modify
label define nuts07_3_fua 5113 "5113 Essen, City", modify
label define nuts07_3_fua 5114 "5114 Krefeld, City", modify
label define nuts07_3_fua 5116 "5116 Moenchengladbach, City", modify
label define nuts07_3_fua 5117 "5117 Muelheim an der Ruhr, City", modify
label define nuts07_3_fua 5119 "5119 Oberhausen, City", modify
label define nuts07_3_fua 5120 "5120 Remscheid, City", modify
label define nuts07_3_fua 5122 "5122 Solingen, City", modify
label define nuts07_3_fua 5124 "5124 Wuppertal, City", modify
label define nuts07_3_fua 5154 "5154 Cleves, District", modify
label define nuts07_3_fua 5158 "5158 Mettmann, District", modify
label define nuts07_3_fua 5162 "5162 Rhein-Kreis Neuss", modify
label define nuts07_3_fua 5166 "5166 Viersen, District", modify
label define nuts07_3_fua 5170 "5170 Wesel, District", modify
label define nuts07_3_fua 5314 "5314 Bonn, City", modify
label define nuts07_3_fua 5315 "5315 Cologne, City", modify
label define nuts07_3_fua 5316 "5316 Leverkusen, City", modify
label define nuts07_3_fua 5334 "5334 Region Aachen", modify
label define nuts07_3_fua 5358 "5358 Dueren, District", modify
label define nuts07_3_fua 5362 "5362 Rhein-Erft-Kreis", modify
label define nuts07_3_fua 5366 "5366 Euskirchen, District", modify
label define nuts07_3_fua 5370 "5370 Heinsberg, District", modify
label define nuts07_3_fua 5374 "5374 Oberbergischer Kreis", modify
label define nuts07_3_fua 5378 "5378 Rheinisch-Bergischer Kreis", modify
label define nuts07_3_fua 5382 "5382 Rhein-Sieg-Kreis", modify
label define nuts07_3_fua 5512 "5512 Bottrop, City", modify
label define nuts07_3_fua 5513 "5513 Gelsenkirchen, City", modify
label define nuts07_3_fua 5515 "5515 Muenster, City", modify
label define nuts07_3_fua 5554 "5554 Borken, District", modify
label define nuts07_3_fua 5558 "5558 Coesfeld, District", modify
label define nuts07_3_fua 5562 "5562 Recklinghausen, District", modify
label define nuts07_3_fua 5566 "5566 Steinfurt, District", modify
label define nuts07_3_fua 5570 "5570 Warendorf, District", modify
label define nuts07_3_fua 5711 "5711 Bielefeld, City", modify
label define nuts07_3_fua 5754 "5754 Guetersloh, District", modify
label define nuts07_3_fua 5758 "5758 Herford, District", modify
label define nuts07_3_fua 5762 "5762 Hoexter, District", modify
label define nuts07_3_fua 5766 "5766 Lippe, District", modify
label define nuts07_3_fua 5770 "5770 Minden-Luebbecke, District", modify
label define nuts07_3_fua 5774 "5774 Paderborn, District", modify
label define nuts07_3_fua 5911 "5911 Bochum, City", modify
label define nuts07_3_fua 5913 "5913 Dortmund, City", modify
label define nuts07_3_fua 5914 "5914 Hagen, City", modify
label define nuts07_3_fua 5915 "5915 Hamm, City", modify
label define nuts07_3_fua 5916 "5916 Herne, City", modify
label define nuts07_3_fua 5954 "5954 Ennepe-Ruhr-Kreis", modify
label define nuts07_3_fua 5958 "5958 Hochsauerlandkreis", modify
label define nuts07_3_fua 5962 "5962 Maerkischer Kreis", modify
label define nuts07_3_fua 5966 "5966 Olpe, District", modify
label define nuts07_3_fua 5970 "5970 Siegen-Wittgenstein, District", modify
label define nuts07_3_fua 5974 "5974 Soest, District", modify
label define nuts07_3_fua 5978 "5978 Unna, District", modify

label define nuts07_3_fua 6411 "6411 Darmstadt, City", modify
label define nuts07_3_fua 6412 "6412 Frankfurt am Main, City", modify
label define nuts07_3_fua 6413 "6413 Offenbach am Main, City", modify
label define nuts07_3_fua 6414 "6414 Wiesbaden, City", modify
label define nuts07_3_fua 6431 "6431 Bergstrasse, District", modify
label define nuts07_3_fua 6432 "6432 Darmstadt-Dieburg, District", modify
label define nuts07_3_fua 6433 "6433 Gross-Gerau, District", modify
label define nuts07_3_fua 6434 "6434 Hochtaunuskreis", modify
label define nuts07_3_fua 6435 "6435 Main-Kinzig-Kreis", modify
label define nuts07_3_fua 6436 "6436 Main-Taunus-Kreis", modify
label define nuts07_3_fua 6437 "6437 Odenwaldkreis", modify
label define nuts07_3_fua 6438 "6438 Offenbach, District", modify
label define nuts07_3_fua 6439 "6439 Rheingau-Taunus-Kreis", modify
label define nuts07_3_fua 6440 "6440 Wetteraukreis, District", modify
label define nuts07_3_fua 6531 "6531 Giessen, District", modify
label define nuts07_3_fua 6532 "6532 Lahn-Dill-Kreis", modify
label define nuts07_3_fua 6533 "6533 Limburg-Weilburg, District", modify
label define nuts07_3_fua 6534 "6534 Marburg-Biedenkopf, District", modify
label define nuts07_3_fua 6535 "6535 Vogelsbergkreis", modify
label define nuts07_3_fua 6611 "6611 Kassel, City", modify
label define nuts07_3_fua 6631 "6631 Fulda, District", modify
label define nuts07_3_fua 6632 "6632 Hersfeld-Rotenburg, District", modify
label define nuts07_3_fua 6633 "6633 Kassel, District", modify
label define nuts07_3_fua 6634 "6634 Schwalm-Eder-Kreis", modify
label define nuts07_3_fua 6635 "6635 Waldeck-Frankenberg, District", modify
label define nuts07_3_fua 6636 "6636 Werra-Meissner-Kreis", modify

label define nuts07_3_fua 7111 "7111 Koblenz, City", modify
label define nuts07_3_fua 7131 "7131 Ahrweiler, District", modify
label define nuts07_3_fua 7132 "7132 Altenkirchen (Westerwald), District", modify
label define nuts07_3_fua 7133 "7133 Bad Kreuznach, District", modify
label define nuts07_3_fua 7134 "7134 Birkenfeld, District", modify
label define nuts07_3_fua 7135 "7135 Cochem-Zell, District", modify
label define nuts07_3_fua 7137 "7137 Mayen-Koblenz, District", modify
label define nuts07_3_fua 7138 "7138 Neuwied, District", modify
label define nuts07_3_fua 7140 "7140 Rhein-Hunsrueck-Kreis", modify
label define nuts07_3_fua 7141 "7141 Rhein-Lahn-Kreis", modify
label define nuts07_3_fua 7143 "7143 Westerwaldnutskreis", modify
label define nuts07_3_fua 7211 "7211 Trier, City", modify
label define nuts07_3_fua 7231 "7231 Bernkastel-Wittlich, District", modify
label define nuts07_3_fua 7232 "7232 Eifelkreis Bitburg-Pruem, District", modify
label define nuts07_3_fua 7233 "7233 Vulkaneifel, District", modify
label define nuts07_3_fua 7235 "7235 Trier-Saarburg, District", modify
label define nuts07_3_fua 7311 "7311 Frankenthal (Pfalz), City", modify
label define nuts07_3_fua 7312 "7312 Kaiserslautern, City", modify
label define nuts07_3_fua 7313 "7313 Landau in der Pfalz, City", modify
label define nuts07_3_fua 7314 "7314 Ludwigshafen am Rhein, City", modify
label define nuts07_3_fua 7315 "7315 Mainz, City", modify
label define nuts07_3_fua 7316 "7316 Neustadt an der Weinstrasse, City", modify
label define nuts07_3_fua 7317 "7317 Pirmasens, City", modify
label define nuts07_3_fua 7318 "7318 Speyer, City", modify
label define nuts07_3_fua 7319 "7319 Worms, City", modify
label define nuts07_3_fua 7320 "7320 Zweibruecken, City", modify
label define nuts07_3_fua 7331 "7331 Alzey-Worms, District", modify
label define nuts07_3_fua 7332 "7332 Bad Duerkheim, District", modify
label define nuts07_3_fua 7333 "7333 Donnersbergkreis", modify
label define nuts07_3_fua 7334 "7334 Germersheim, District", modify
label define nuts07_3_fua 7335 "7335 Kaiserslautern, District", modify
label define nuts07_3_fua 7336 "7336 Kusel, District", modify
label define nuts07_3_fua 7337 "7337 Suedliche Weinstrasse, District", modify
label define nuts07_3_fua 7338 "7338 Rhein-Pfalz-Kreis", modify
label define nuts07_3_fua 7339 "7339 Mainz-Bingen, District", modify
label define nuts07_3_fua 7340 "7340 Suedwestpfalz, District", modify

label define nuts07_3_fua 8111 "8111 Stuttgart, City", modify
label define nuts07_3_fua 8115 "8115 Boeblingen, District", modify
label define nuts07_3_fua 8116 "8116 Esslingen, District", modify
label define nuts07_3_fua 8117 "8117 Goeppingen, District", modify
label define nuts07_3_fua 8118 "8118 Ludwigsburg, District", modify
label define nuts07_3_fua 8119 "8119 Rems-Murr-Kreis", modify
label define nuts07_3_fua 8121 "8121 Heilbronn, City", modify
label define nuts07_3_fua 8125 "8125 Heilbronn, District", modify
label define nuts07_3_fua 8126 "8126 Hohenlohekreis", modify
label define nuts07_3_fua 8127 "8127 Schwaebisch Hall, District", modify
label define nuts07_3_fua 8128 "8128 Main-Tauber-Kreis", modify
label define nuts07_3_fua 8135 "8135 Heidenheim, District", modify
label define nuts07_3_fua 8136 "8136 Ostalbkreis", modify
label define nuts07_3_fua 8211 "8211 Baden-Baden, City", modify
label define nuts07_3_fua 8212 "8212 Karlsruhe, City", modify
label define nuts07_3_fua 8215 "8215 Karlsruhe, District", modify
label define nuts07_3_fua 8216 "8216 Rastatt, District", modify
label define nuts07_3_fua 8221 "8221 Heidelberg, City", modify
label define nuts07_3_fua 8222 "8222 Mannheim, City", modify
label define nuts07_3_fua 8225 "8225 Neckar-Odenwald-Kreis", modify
label define nuts07_3_fua 8226 "8226 Rhein-Neckar-Kreis", modify
label define nuts07_3_fua 8231 "8231 Pforzheim, City", modify
label define nuts07_3_fua 8235 "8235 Calw, District", modify
label define nuts07_3_fua 8236 "8236 Enzkreis", modify
label define nuts07_3_fua 8237 "8237 Freudenstadt, District", modify
label define nuts07_3_fua 8311 "8311 Freiburg im Breisgau, City", modify
label define nuts07_3_fua 8315 "8315 Breisgau-Hochschwarzwald, District", modify
label define nuts07_3_fua 8316 "8316 Emmendingen, District", modify
label define nuts07_3_fua 8317 "8317 Ortenaukreis", modify
label define nuts07_3_fua 8325 "8325 Rottweil, District", modify
label define nuts07_3_fua 8326 "8326 Schwarzwald-Baar-Kreis", modify
label define nuts07_3_fua 8327 "8327 Tuttlingen, District", modify
label define nuts07_3_fua 8335 "8335 Konstanz, District", modify
label define nuts07_3_fua 8336 "8336 Loerrach, District", modify
label define nuts07_3_fua 8337 "8337 Waldshut, District", modify
label define nuts07_3_fua 8415 "8415 Reutlingen, District", modify
label define nuts07_3_fua 8416 "8416 Tuebingen, District", modify
label define nuts07_3_fua 8417 "8417 Zollernalbkreis", modify
label define nuts07_3_fua 8421 "8421 Ulm, City", modify
label define nuts07_3_fua 8425 "8425 Alb-Donau-Kreis", modify
label define nuts07_3_fua 8426 "8426 Biberach, District", modify
label define nuts07_3_fua 8435 "8435 Bodenseekreis", modify
label define nuts07_3_fua 8436 "8436 Ravensburg, District", modify
label define nuts07_3_fua 8437 "8437 Sigmaringen, District", modify

label define nuts07_3_fua 9161 "9161 Ingolstadt, City", modify
label define nuts07_3_fua 9162 "9162 Munich, City", modify
label define nuts07_3_fua 9163 "9163 Rosenheim, City", modify
label define nuts07_3_fua 9171 "9171 Altoetting, District", modify
label define nuts07_3_fua 9172 "9172 Berchtesgadener Land, District", modify
label define nuts07_3_fua 9173 "9173 Bad Toelz-Wolfratshausen, District", modify
label define nuts07_3_fua 9174 "9174 Dachau, District", modify
label define nuts07_3_fua 9175 "9175 Ebersberg, District", modify
label define nuts07_3_fua 9176 "9176 Eichstaett, District", modify
label define nuts07_3_fua 9177 "9177 Erding, District", modify
label define nuts07_3_fua 9178 "9178 Freising, District", modify
label define nuts07_3_fua 9179 "9179 Fuerstenfeldbruck, District", modify
label define nuts07_3_fua 9180 "9180 Garmisch-Partenkirchen, District", modify
label define nuts07_3_fua 9181 "9181 Landsberg am Lech, District", modify
label define nuts07_3_fua 9182 "9182 Miesbach, District", modify
label define nuts07_3_fua 9183 "9183 Muehldorf am Inn, District", modify
label define nuts07_3_fua 9184 "9184 Munich, District", modify
label define nuts07_3_fua 9185 "9185 Neuburg-Schrobenhausen, District", modify
label define nuts07_3_fua 9186 "9186 Pfaffenhofen an der Ilm, District", modify
label define nuts07_3_fua 9187 "9187 Rosenheim, District", modify
label define nuts07_3_fua 9188 "9188 Starnberg, District", modify
label define nuts07_3_fua 9189 "9189 Traunstein, District", modify
label define nuts07_3_fua 9190 "9190 Weilheim-Schongau, District", modify
label define nuts07_3_fua 9261 "9261 Landshut, City", modify
label define nuts07_3_fua 9262 "9262 Passau, City", modify
label define nuts07_3_fua 9263 "9263 Straubing, City", modify
label define nuts07_3_fua 9271 "9271 Deggendorf, District", modify
label define nuts07_3_fua 9272 "9272 Freyung-Grafenau, District", modify
label define nuts07_3_fua 9273 "9273 Kelheim, District", modify
label define nuts07_3_fua 9274 "9274 Landshut, District", modify
label define nuts07_3_fua 9275 "9275 Passau, District", modify
label define nuts07_3_fua 9276 "9276 Regen, District", modify
label define nuts07_3_fua 9277 "9277 Rottal-Inn, District", modify
label define nuts07_3_fua 9278 "9278 Straubing-Bogen, District", modify
label define nuts07_3_fua 9279 "9279 Dingolfing-Landau, District", modify
label define nuts07_3_fua 9361 "9361 Amberg, City", modify
label define nuts07_3_fua 9362 "9361 Regensburg, City", modify
label define nuts07_3_fua 9363 "9363 Weiden in der Oberpfalz, City", modify
label define nuts07_3_fua 9371 "9371 Amberg-Sulzbach, District", modify
label define nuts07_3_fua 9372 "9372 Cham, District", modify
label define nuts07_3_fua 9373 "9373 Neumarkt in der Oberpfalz, District", modify
label define nuts07_3_fua 9374 "9374 Neustadt an der Waldnaab, District", modify
label define nuts07_3_fua 9375 "9375 Regensburg, District", modify
label define nuts07_3_fua 9376 "9376 Schwandorf, District", modify
label define nuts07_3_fua 9377 "9377 Tirschenreuth, District", modify
label define nuts07_3_fua 9461 "9461 Bamberg, City", modify
label define nuts07_3_fua 9462 "9462 Bayreuth, City", modify
label define nuts07_3_fua 9463 "9463 Coburg, City", modify
label define nuts07_3_fua 9464 "9464 Hof, City", modify
label define nuts07_3_fua 9471 "9471 Bamberg, District", modify
label define nuts07_3_fua 9472 "9472 Bayreuth, District", modify
label define nuts07_3_fua 9473 "9473 Coburg, District", modify
label define nuts07_3_fua 9474 "9474 Forchheim, District", modify
label define nuts07_3_fua 9475 "9475 Hof, District", modify
label define nuts07_3_fua 9476 "9476 Kronach, District", modify
label define nuts07_3_fua 9477 "9477 Kulmbach, District", modify
label define nuts07_3_fua 9478 "9478 Lichtenfels, District", modify
label define nuts07_3_fua 9479 "9479 Wunsiedel im Fichtelgebirge, District", modify
label define nuts07_3_fua 9561 "9561 Ansbach, City", modify
label define nuts07_3_fua 9562 "9562 Erlangen, City", modify
label define nuts07_3_fua 9563 "9563 Fuerth, City", modify
label define nuts07_3_fua 9564 "9564 Nuremberg, City", modify
label define nuts07_3_fua 9565 "9565 Schwabach, City", modify
label define nuts07_3_fua 9571 "9571 Ansbach, District", modify
label define nuts07_3_fua 9572 "9572 Erlangen-Hoechstadt, District", modify
label define nuts07_3_fua 9573 "9573 Fuerth, District", modify
label define nuts07_3_fua 9574 "9574 Nuernberger Land, District", modify
label define nuts07_3_fua 9575 "9575 Neustadt an der Aisch-Bad Windsheim, District", modify
label define nuts07_3_fua 9576 "9576 Roth, District", modify
label define nuts07_3_fua 9577 "9577 Weissenburg-Gunzenhausen, District", modify
label define nuts07_3_fua 9661 "9661 Aschaffenburg, City", modify
label define nuts07_3_fua 9662 "9662 Schweinfurt, City", modify
label define nuts07_3_fua 9663 "9663 Wuerzburg, City", modify
label define nuts07_3_fua 9671 "9671 Aschaffenburg, District", modify
label define nuts07_3_fua 9672 "9672 Bad Kissingen, District", modify
label define nuts07_3_fua 9673 "9673 Rhoen-Grabfeld, District", modify
label define nuts07_3_fua 9674 "9674 Hassberge, District", modify
label define nuts07_3_fua 9675 "9675 Kitzingen, District", modify
label define nuts07_3_fua 9676 "9676 Miltenberg, District", modify
label define nuts07_3_fua 9677 "9677 Main-Spessart, District", modify
label define nuts07_3_fua 9678 "9678 Schweinfurt, District", modify
label define nuts07_3_fua 9679 "9679 Wuerzburg, District", modify
label define nuts07_3_fua 9761 "9761 Augsburg, City", modify
label define nuts07_3_fua 9762 "9762 Kaufbeuren, City", modify
label define nuts07_3_fua 9763 "9763 Kempten (Allgaeu), City", modify
label define nuts07_3_fua 9764 "9764 Memmingen, City", modify
label define nuts07_3_fua 9771 "9771 Aichach-Friedberg, District", modify
label define nuts07_3_fua 9772 "9772 Augsburg, District", modify
label define nuts07_3_fua 9773 "9773 Dillingen an der Donau, District", modify
label define nuts07_3_fua 9774 "9774 Guenzburg, District", modify
label define nuts07_3_fua 9775 "9775 Neu-Ulm, District", modify
label define nuts07_3_fua 9776 "9776 Lindau (Bodensee), District", modify
label define nuts07_3_fua 9777 "9777 Ostallgaeu, District", modify
label define nuts07_3_fua 9778 "9778 Unterallgaeu, District", modify
label define nuts07_3_fua 9779 "9779 Donau-Ries, District", modify
label define nuts07_3_fua 9780 "9780 Oberallgaeu, District", modify

label define nuts07_3_fua 10041 "10041 Region Saarbruecken", modify
label define nuts07_3_fua 10042 "10042 Merzig-Wadern, District", modify
label define nuts07_3_fua 10043 "10043 Neunkirchen, District", modify
label define nuts07_3_fua 10044 "10044 Saarlouis, District", modify
label define nuts07_3_fua 10045 "10045 Saarpfalz-Kreis", modify
label define nuts07_3_fua 10046 "10046 Sankt Wendel, District", modify

label define nuts07_3_fua 11000 "11000 Berlin, City", modify

label define nuts07_3_fua 12051 "12051 Brandenburg an der Havel, City", modify
label define nuts07_3_fua 12052 "12052 Cottbus, City", modify
label define nuts07_3_fua 12053 "12053 Frankfurt (Oder), City", modify
label define nuts07_3_fua 12054 "12054 Potsdam, City", modify
label define nuts07_3_fua 12060 "12060 Barnim, District", modify
label define nuts07_3_fua 12061 "12061 Dahme-Spreewald, District", modify
label define nuts07_3_fua 12062 "12062 Elbe-Elster, District", modify
label define nuts07_3_fua 12063 "12063 Havelland, District", modify
label define nuts07_3_fua 12064 "12064 Maerkisch-Oderland, District", modify
label define nuts07_3_fua 12065 "12065 Oberhavel, District", modify
label define nuts07_3_fua 12066 "12066 Oberspreewald-Lausitz, District", modify
label define nuts07_3_fua 12067 "12067 Oder-Spree, District", modify
label define nuts07_3_fua 12068 "12068 Ostprignitz-Ruppin, District", modify
label define nuts07_3_fua 12069 "12069 Potsdam-Mittelmark, District", modify
label define nuts07_3_fua 12070 "12070 Prignitz, District", modify
label define nuts07_3_fua 12071 "12071 Spree-Neisse, District", modify
label define nuts07_3_fua 12072 "12072 Teltow-Flaeming, District", modify
label define nuts07_3_fua 12073 "12073 Uckermark, District", modify

label define nuts07_3_fua 13003 "13003 Rostock, City", modify
label define nuts07_3_fua 13004 "13004 Schwerin, City", modify
label define nuts07_3_fua 13071 "13071 Mecklenburgische Seenplatte, District", modify
label define nuts07_3_fua 13072 "13072 Rostock, District", modify
label define nuts07_3_fua 13073 "13073 Vorpommern-Ruegen, District", modify
label define nuts07_3_fua 13074 "13074 Nordwestmecklenburg, District", modify
label define nuts07_3_fua 13075 "13075 Vorpommern-Greifswald, District", modify
label define nuts07_3_fua 13076 "13076 Ludwigslust-Parchim, District", modify

label define nuts07_3_fua 14511 "14511 Chemnitz, City", modify
label define nuts07_3_fua 14521 "14521 Erzgebirgskreis", modify
label define nuts07_3_fua 14522 "14522 Mittelsachsen, District", modify
label define nuts07_3_fua 14523 "14523 Vogtlandkreis", modify
label define nuts07_3_fua 14524 "14524 Zwickau, District", modify
label define nuts07_3_fua 14612 "14612 Dresden, City", modify
label define nuts07_3_fua 14625 "14625 Bautzen, District", modify
label define nuts07_3_fua 14626 "14626 Goerlitz, District", modify
label define nuts07_3_fua 14627 "14627 Meissen, District", modify
label define nuts07_3_fua 14628 "14628 Saechsische Schweiz-Osterzgebirge, District", modify
label define nuts07_3_fua 14713 "14713 Leipzig, City", modify
label define nuts07_3_fua 14729 "14729 Leipzig, District", modify
label define nuts07_3_fua 14730 "14730 Nordsachsen, District", modify

label define nuts07_3_fua 15001 "15001 Dessau-Rosslau, City", modify
label define nuts07_3_fua 15002 "15002 Halle (Saale), City", modify
label define nuts07_3_fua 15003 "15003 Magdeburg, City", modify
label define nuts07_3_fua 15081 "15081 Altmarkkreis Salzwedel", modify
label define nuts07_3_fua 15082 "15082 Anhalt-Bitterfeld, District", modify
label define nuts07_3_fua 15083 "15083 Boerde, District", modify
label define nuts07_3_fua 15084 "15084 Burgenlandkreis", modify
label define nuts07_3_fua 15085 "15085 Harz, District", modify
label define nuts07_3_fua 15086 "15086 Jerichower Land, District", modify
label define nuts07_3_fua 15087 "15087 Mansfeld-Suedharz, District", modify
label define nuts07_3_fua 15088 "15088 Saalekreis", modify
label define nuts07_3_fua 15089 "15089 Salzlandkreis", modify
label define nuts07_3_fua 15090 "15090 Stendal, District", modify
label define nuts07_3_fua 15091 "15091 Wittenberg, District", modify

label define nuts07_3_fua 16051 "16051 Erfurt, City", modify
label define nuts07_3_fua 16052 "16052 Gera, City", modify
label define nuts07_3_fua 16053 "16053 Jena, City", modify
label define nuts07_3_fua 16054 "16054 Suhl, City", modify
label define nuts07_3_fua 16055 "16055 Weimar, City", modify
label define nuts07_3_fua 16056 "16056 Eisenach, City", modify
label define nuts07_3_fua 16061 "16061 Eichsfeld, District", modify
label define nuts07_3_fua 16062 "16062 Nordhausen, District", modify
label define nuts07_3_fua 16063 "16063 Wartburgkreis", modify
label define nuts07_3_fua 16064 "16064 Unstrut-Hainich-Kreis", modify
label define nuts07_3_fua 16065 "16065 Kyffhaeuserkreis", modify
label define nuts07_3_fua 16066 "16066 Schmalkalden-Meiningen, District", modify
label define nuts07_3_fua 16067 "16067 Gotha, District", modify
label define nuts07_3_fua 16068 "16068 Soemmerda, District", modify
label define nuts07_3_fua 16069 "16069 Hildburghausen, District", modify
label define nuts07_3_fua 16070 "16070 Ilm-Kreis", modify
label define nuts07_3_fua 16071 "16071 Weimarer Land, District", modify
label define nuts07_3_fua 16072 "16072 Sonneberg, District", modify
label define nuts07_3_fua 16073 "16073 Saalfeld-Rudolstadt, District", modify
label define nuts07_3_fua 16074 "16074 Saale-Holzland-Kreis", modify
label define nuts07_3_fua 16075 "16075 Saale-Orla-Kreis", modify
label define nuts07_3_fua 16076 "16076 Greiz, Kreis", modify
label define nuts07_3_fua 16077 "16077 Altenburger Land, District", modify


label save nuts07_3_fua using "$prog\NUTS07-3-FUA.do", replace



label values nuts07_3_fua nuts07_3_fua

tab nuts07_3_fua, m // 251 regions = 97 FUAs + 154 NUTS-3 regions

label variable nuts07_3_fua "FUA + District (NUTS07-3)"

*drop nuts07_3

save "$data\BeH_FUA_V1.dta", replace





*drop municipality dimension as FUA delineation is entirely based on 3-digit NUTS regions

drop lau17 lau17_name

duplicates drop




*adjust for enclaves: 3-digit NUTS regions


gen nuts07_3_adj = nuts07_3

order nuts07_3 nuts07_3_adj

replace nuts07_3_adj = 1999 if nuts07_3==1001 // Flensburg, City --> Flensburg, City + District
replace nuts07_3_adj = 1999 if nuts07_3==1059 // Schleswig-Flensburg, District --> Flensburg, City + District

replace nuts07_3_adj = 3999 if nuts07_3==3405 // Wilhelmshaven, City --> Wilhelmshaven, City + District
replace nuts07_3_adj = 3999 if nuts07_3==3455 // Friesland, District --> Wilhelmshaven, City + District

replace nuts07_3_adj = 4999 if nuts07_3==4012 // Bremerhaven, City --> Bremerhaven, City + District
replace nuts07_3_adj = 4999 if nuts07_3==3352 // Cuxhaven, District --> Bremerhaven, City + District

replace nuts07_3_adj = 5999 if nuts07_3==5314 // Bonn, City --> Bonn, City + District
replace nuts07_3_adj = 5999 if nuts07_3==5382 // Rhein-Sieg-Kreis --> Bonn, City + District

replace nuts07_3_adj = 6999 if nuts07_3==6611 // Kassel, City --> Kassel, City + District
replace nuts07_3_adj = 6999 if nuts07_3==6633 // Kassel, District --> Kassel, City + District

replace nuts07_3_adj = 7997 if nuts07_3==7211 // Trier, City --> Trier, City + District
replace nuts07_3_adj = 7997 if nuts07_3==7235 // Trier-Saarburg, District --> Trier, City + District

replace nuts07_3_adj = 7998 if nuts07_3==7317 // Pimasens, City --> Pirmasens, City + District
replace nuts07_3_adj = 7998 if nuts07_3==7340 // Suedwestpfalz, District --> Primasens, City + District

replace nuts07_3_adj = 7999 if nuts07_3==7313 // Landau in der Pfalz, City --> Landau in der Pfalz, City + District
replace nuts07_3_adj = 7999 if nuts07_3==7337 // Süedliche Weinstrasse, District --> Landau in der Pfalz, City + District

replace nuts07_3_adj = 8998 if nuts07_3==8211 // Baden-Baden, City --> Baden-Baden, City + District
replace nuts07_3_adj = 8998 if nuts07_3==8216 // Rastatt, District --> Baden-Baden, City + District

replace nuts07_3_adj = 8999 if nuts07_3==8121 // Heilbronn, City --> Heilbronn, City + District
replace nuts07_3_adj = 8999 if nuts07_3==8125 // Heilbronn, District --> Heilbronn, City + District

replace nuts07_3_adj = 9984 if nuts07_3==9763 // Kempten (Allgaeu), City --> Kempten (Allgaeu), City + District
replace nuts07_3_adj = 9984 if nuts07_3==9780 // Oberallgaeu, District --> Kempten (Allgaeu), City + District

replace nuts07_3_adj = 9985 if nuts07_3==9762 // Kaufbeuren, City --> Kaufbeuren, City + District
replace nuts07_3_adj = 9985 if nuts07_3==9777 // Ostallgaeu, District --> Kaufbeuren, City + District

replace nuts07_3_adj = 9986 if nuts07_3==9163 // Rosenheim, City --> Rosenheim, City + District
replace nuts07_3_adj = 9986 if nuts07_3==9187 // Rosenheim, District --> Rosenheim, City + District

replace nuts07_3_adj = 9987 if nuts07_3==9262 // Passau, City --> Passau, City + District
replace nuts07_3_adj = 9987 if nuts07_3==9275 // Passau, District --> Passau, City + District

replace nuts07_3_adj = 9988 if nuts07_3==9261 // Landshut, City --> Landshut, City + District
replace nuts07_3_adj = 9988 if nuts07_3==9274 // Landshut, District --> Landshut, City + District

replace nuts07_3_adj = 9989 if nuts07_3==9263 // Straubing, City --> Straubing, City + District
replace nuts07_3_adj = 9989 if nuts07_3==9278 // Straubing-Bogen, District --> Straubing, City + District

replace nuts07_3_adj = 9990 if nuts07_3==9362 // Regensburg, City --> Regensburg, City + District
replace nuts07_3_adj = 9990 if nuts07_3==9375 // Regensburg, District --> Regensburg, City + District

replace nuts07_3_adj = 9991 if nuts07_3==9361 // Amberg, City --> Amberg, City + District
replace nuts07_3_adj = 9991 if nuts07_3==9371 // Amberg-Sulzbach, District --> Amberg, City + District

replace nuts07_3_adj = 9992 if nuts07_3==9363 // Weiden in der Oberpfalz, City --> Weiden in der Oberpfalz, City + District
replace nuts07_3_adj = 9992 if nuts07_3==9374 // Neustadt an der Waldnaab, District --> Weiden in der Oberpfalz, City + District

replace nuts07_3_adj = 9993 if nuts07_3==9561 // Ansbach, City --> Ansbach, City + District
replace nuts07_3_adj = 9993 if nuts07_3==9571 // Ansbach, District --> Ansbach, City + District

replace nuts07_3_adj = 9994 if nuts07_3==9663 // Wuerzburg, City --> Wuerzburg, City + District
replace nuts07_3_adj = 9994 if nuts07_3==9679 // Wuerzburg, District --> Wuerzburg, City + District

replace nuts07_3_adj = 9995 if nuts07_3==9662 // Schweinfurt, City --> Schweinfurt, City + District
replace nuts07_3_adj = 9995 if nuts07_3==9678 // Schweinfurt, District --> Schweinfurt, City + District

replace nuts07_3_adj = 9996 if nuts07_3==9461 // Bamberg, City --> Bamberg, City + District
replace nuts07_3_adj = 9996 if nuts07_3==9471 // Bamberg, District --> Bamberg, City + District

replace nuts07_3_adj = 9997 if nuts07_3==9463 // Coburg, City --> Coburg, City + District
replace nuts07_3_adj = 9997 if nuts07_3==9473 // Coburg, District --> Coburg, City + District

replace nuts07_3_adj = 9998 if nuts07_3==9464 // Hof, City --> Hof, City + District
replace nuts07_3_adj = 9998 if nuts07_3==9475 // Hof, District --> Hof, City + District

replace nuts07_3_adj = 9999 if nuts07_3==9462 // Bayreuth, City --> Bayreuth, City + District
replace nuts07_3_adj = 9999 if nuts07_3==9472 // Bayreuth, District --> Bayreuth, City + District

replace nuts07_3_adj =12999 if nuts07_3==12052 // Cottbus, City --> Cottbus, City + District
replace nuts07_3_adj =12999 if nuts07_3==12071 // Spree-Neisse, District --> Cottbus, City + District

replace nuts07_3_adj =13999 if nuts07_3==13003 // Rostock, City --> Rostock, City + District
replace nuts07_3_adj =13999 if nuts07_3==13072 // Rostock, District --> Rostock, City + District

replace nuts07_3_adj =15999 if nuts07_3==15002 // Halle (Saale), City --> Halle (Saale), City + District
replace nuts07_3_adj =15999 if nuts07_3==15088 // Saalekreis, District --> Halle (Saale), City + District

replace nuts07_3_adj =16999 if nuts07_3==16055 // Weimar, City --> Weimar, City + District
replace nuts07_3_adj =16999 if nuts07_3==16071 // Weimarer Land, District --> Weimar, City + District

do "$prog\NUTS07-3-adjusted.do"
label values nuts07_3_adj nuts07_3_adj

tab nuts07_3_adj, m

codebook nuts07_3_adj // 371 adjusted 3-digit NUTS regions (instead of 401)

label variable nuts07_3_adj "District (NUTS07-3)"





*adjust for enclaves: FUAs + 3-digit NUTS regions


gen nuts07_3_fua_adj = nuts07_3_fua

replace nuts07_3_fua_adj = 7998 if nuts07_3_fua==7317 // Pirmasens, City --> Pirmasens, City + District
replace nuts07_3_fua_adj = 7998 if nuts07_3_fua==7340 // Suedwestpfalz, District --> Primasens, City + District

replace nuts07_3_fua_adj = 7999 if nuts07_3_fua==7313 // Landau in der Pfalz, City --> Landau in der Pfalz, City + District
replace nuts07_3_fua_adj = 7999 if nuts07_3_fua==7337 // Süedliche Weinstrasse, District --> Landau in der Pfalz, City + District

replace nuts07_3_fua_adj = 8998 if nuts07_3_fua==8211 // Baden-Baden, City --> Baden-Baden, City + District
replace nuts07_3_fua_adj = 8998 if nuts07_3_fua==8216 // Rastatt, District --> Baden-Baden, City + District

replace nuts07_3_fua_adj = 9985 if nuts07_3_fua==9762 // Kaufbeuren, City --> Kaufbeuren, City + District
replace nuts07_3_fua_adj = 9985 if nuts07_3_fua==9777 // Ostallgaeu, District --> Kaufbeuren, City + District

replace nuts07_3_fua_adj = 9989 if nuts07_3_fua==9263 // Straubing, City --> Straubing, City + District
replace nuts07_3_fua_adj = 9989 if nuts07_3_fua==9278 // Straubing-Bogen, District --> Straubing, City + District

replace nuts07_3_fua_adj = 9991 if nuts07_3_fua==9361 // Amberg, City --> Amberg, City + District
replace nuts07_3_fua_adj = 9991 if nuts07_3_fua==9371 // Amberg-Sulzbach, District --> Amberg, City + District

replace nuts07_3_fua_adj = 9992 if nuts07_3_fua==9363 // Weiden in der Oberpfalz, City --> Weiden in der Oberpfalz, City + District
replace nuts07_3_fua_adj = 9992 if nuts07_3_fua==9374 // Neustadt an der Waldnaab, District --> Weiden in der Oberpfalz, City + District

replace nuts07_3_fua_adj = 9993 if nuts07_3_fua==9561 // Ansbach, City --> Ansbach, City + District
replace nuts07_3_fua_adj = 9993 if nuts07_3_fua==9571 // Ansbach, District --> Ansbach, City + District

replace nuts07_3_fua_adj = 9997 if nuts07_3_fua==9463 // Coburg, City --> Coburg, City + District
replace nuts07_3_fua_adj = 9997 if nuts07_3_fua==9473 // Coburg, District --> Coburg, City + District

replace nuts07_3_fua_adj = 9998 if nuts07_3_fua==9464 // Hof, City --> Hof, City + District
replace nuts07_3_fua_adj = 9998 if nuts07_3_fua==9475 // Hof, District --> Hof, City + District



label define nuts07_3_fua_adj 1 "1 Berlin", modify
label define nuts07_3_fua_adj 2 "2 Hamburg", modify
label define nuts07_3_fua_adj 3 "3 Munich", modify
label define nuts07_3_fua_adj 4 "4 Cologne", modify
label define nuts07_3_fua_adj 5 "5 Frankfurt am Main", modify
label define nuts07_3_fua_adj 7 "7 Stuttgart", modify
label define nuts07_3_fua_adj 8 "8 Leipzig", modify
label define nuts07_3_fua_adj 9 "9 Dresden", modify
label define nuts07_3_fua_adj 11 "11 Duesseldorf", modify
label define nuts07_3_fua_adj 12 "12 Bremen", modify
label define nuts07_3_fua_adj 13 "13 Hanover", modify
label define nuts07_3_fua_adj 14 "14 Nuremberg", modify
label define nuts07_3_fua_adj 17 "17 Bielefeld", modify
label define nuts07_3_fua_adj 18 "18 Halle an der Saale", modify
label define nuts07_3_fua_adj 19 "19 Magdeburg", modify
label define nuts07_3_fua_adj 20 "20 Wiesbaden", modify
label define nuts07_3_fua_adj 21 "21 Gottingen", modify
label define nuts07_3_fua_adj 25 "25 Darmstadt", modify
label define nuts07_3_fua_adj 26 "26 Trier", modify
label define nuts07_3_fua_adj 27 "27 Freiburg im Breisgau", modify
label define nuts07_3_fua_adj 28 "28 Regensburg", modify
label define nuts07_3_fua_adj 29 "29 Frankfurt/Oder", modify
label define nuts07_3_fua_adj 30 "30 Weimar", modify
label define nuts07_3_fua_adj 31 "31 Schwerin", modify
label define nuts07_3_fua_adj 32 "32 Erfurt", modify
label define nuts07_3_fua_adj 33 "33 Augsburg", modify
label define nuts07_3_fua_adj 34 "34 Bonn", modify
label define nuts07_3_fua_adj 35 "35 Karlsruhe", modify
label define nuts07_3_fua_adj 36 "36 Moenchengladbach", modify
label define nuts07_3_fua_adj 37 "37 Mainz", modify
label define nuts07_3_fua_adj 38 "38 Ruhr", modify
label define nuts07_3_fua_adj 39 "39 Kiel", modify
label define nuts07_3_fua_adj 40 "40 Saarbrucken", modify
label define nuts07_3_fua_adj 42 "42 Koblenz", modify
label define nuts07_3_fua_adj 43 "43 Rostock", modify
label define nuts07_3_fua_adj 44 "44 Kaiserslautern", modify
label define nuts07_3_fua_adj 45 "45 Iserlohn", modify
label define nuts07_3_fua_adj 48 "48 Wilhelmshaven", modify
label define nuts07_3_fua_adj 50 "50 Tuebingen", modify
label define nuts07_3_fua_adj 51 "51 Villingen-Schwenningen", modify
label define nuts07_3_fua_adj 52 "52 Flensburg", modify
label define nuts07_3_fua_adj 53 "53 Marburg", modify
label define nuts07_3_fua_adj 54 "54 Constance", modify
label define nuts07_3_fua_adj 55 "55 Neumunster", modify
label define nuts07_3_fua_adj 56 "56 Brandenburg an der Havel", modify
label define nuts07_3_fua_adj 57 "57 Giessen", modify
label define nuts07_3_fua_adj 58 "58 Lueneburg", modify
label define nuts07_3_fua_adj 59 "59 Bayreuth", modify
label define nuts07_3_fua_adj 60 "60 Celle", modify
label define nuts07_3_fua_adj 61 "61 Aschaffenburg", modify
label define nuts07_3_fua_adj 62 "62 Bamberg", modify
label define nuts07_3_fua_adj 63 "63 Plauen", modify
label define nuts07_3_fua_adj 64 "64 Neubrandenburg", modify
label define nuts07_3_fua_adj 65 "65 Fulda", modify
label define nuts07_3_fua_adj 66 "66 Kempten (Allgovia)", modify
label define nuts07_3_fua_adj 67 "67 Landshut", modify
label define nuts07_3_fua_adj 69 "69 Rosenheim", modify
label define nuts07_3_fua_adj 71 "71 Stralsund", modify
label define nuts07_3_fua_adj 72 "72 Friedrichshafen", modify
label define nuts07_3_fua_adj 73 "73 Offenburg", modify
label define nuts07_3_fua_adj 74 "74 Goerlitz", modify
label define nuts07_3_fua_adj 77 "77 Schweinfurt", modify
label define nuts07_3_fua_adj 78 "78 Greifswald", modify
label define nuts07_3_fua_adj 79 "79 Wetzlar", modify
label define nuts07_3_fua_adj 81 "81 Passau", modify
label define nuts07_3_fua_adj 82 "82 Dessau", modify
label define nuts07_3_fua_adj 83 "83 Braunschweig-Wolfsburg", modify
label define nuts07_3_fua_adj 84 "84 Mannheim-Ludwigshafen", modify
label define nuts07_3_fua_adj 504 "504 Muenster", modify
label define nuts07_3_fua_adj 505 "505 Chemnitz", modify
label define nuts07_3_fua_adj 507 "507 Aachen", modify
label define nuts07_3_fua_adj 508 "508 Krefeld", modify
label define nuts07_3_fua_adj 510 "510 Luebeck", modify
label define nuts07_3_fua_adj 513 "513 Kassel", modify
label define nuts07_3_fua_adj 516 "516 Solingen", modify
label define nuts07_3_fua_adj 517 "517 Osnabrueck", modify
label define nuts07_3_fua_adj 520 "520 Oldenburg", modify
label define nuts07_3_fua_adj 522 "522 Heidelberg", modify
label define nuts07_3_fua_adj 523 "523 Paderborn", modify
label define nuts07_3_fua_adj 524 "524 Wuerzburg", modify
label define nuts07_3_fua_adj 527 "527 Bremerhaven", modify
label define nuts07_3_fua_adj 529 "529 Heilbronn", modify
label define nuts07_3_fua_adj 530 "530 Remscheid", modify
label define nuts07_3_fua_adj 532 "532 Ulm", modify
label define nuts07_3_fua_adj 533 "533 Pforzheim", modify
label define nuts07_3_fua_adj 534 "534 Ingolstadt", modify
label define nuts07_3_fua_adj 535 "535 Gera", modify
label define nuts07_3_fua_adj 537 "537 Reutlingen", modify
label define nuts07_3_fua_adj 539 "539 Cottbus", modify
label define nuts07_3_fua_adj 540 "540 Siegen", modify
label define nuts07_3_fua_adj 542 "542 Hildesheim", modify
label define nuts07_3_fua_adj 544 "544 Zwickau", modify
label define nuts07_3_fua_adj 546 "546 Wuppertal", modify
label define nuts07_3_fua_adj 547 "547 Jena", modify
label define nuts07_3_fua_adj 548 "548 Dueren", modify
label define nuts07_3_fua_adj 549 "549 Bocholt", modify


label define nuts07_3_fua_adj 1002 "1002 Kiel, City", modify
label define nuts07_3_fua_adj 1003 "1003 Luebeck, City", modify
label define nuts07_3_fua_adj 1004 "1004 Neumuenster, City", modify
label define nuts07_3_fua_adj 1051 "1051 Dithmarschen, District", modify
label define nuts07_3_fua_adj 1053 "1053 Herzogtum Lauenburg, District", modify
label define nuts07_3_fua_adj 1054 "1054 Nordfriesland, District", modify
label define nuts07_3_fua_adj 1055 "1055 Ostholstein, District", modify
label define nuts07_3_fua_adj 1056 "1056 Pinneberg, District", modify
label define nuts07_3_fua_adj 1057 "1057 Ploen, District", modify
label define nuts07_3_fua_adj 1058 "1058 Rendsburg-Eckernfoerde, District", modify
label define nuts07_3_fua_adj 1060 "1060 Segeberg, District", modify
label define nuts07_3_fua_adj 1061 "1061 Steinburg, District", modify
label define nuts07_3_fua_adj 1062 "1062 Stormarn, District", modify
label define nuts07_3_fua_adj 1999 "1999 Flensburg, City + District", modify

label define nuts07_3_fua_adj 2000 "2000 Hamburg, City", modify

label define nuts07_3_fua_adj 3101 "3101 Braunschweig, City", modify
label define nuts07_3_fua_adj 3102 "3102 Salzgitter, City", modify
label define nuts07_3_fua_adj 3103 "3103 Wolfsburg, City", modify
label define nuts07_3_fua_adj 3151 "3151 Gifhorn, District", modify
label define nuts07_3_fua_adj 3153 "3153 Goslar, District", modify
label define nuts07_3_fua_adj 3154 "3154 Helmstedt, District", modify
label define nuts07_3_fua_adj 3155 "3155 Northeim, District", modify
label define nuts07_3_fua_adj 3157 "3157 Peine, District", modify
label define nuts07_3_fua_adj 3158 "3158 Wolfenbuettel, District", modify
label define nuts07_3_fua_adj 3159 "3159 Goettingen, District", modify
label define nuts07_3_fua_adj 3241 "3241 Region Hanover", modify
label define nuts07_3_fua_adj 3251 "3251 Diepholz, District", modify
label define nuts07_3_fua_adj 3252 "3252 Hamelin-Pyrmont, District", modify
label define nuts07_3_fua_adj 3254 "3254 Hildesheim, District", modify
label define nuts07_3_fua_adj 3255 "3255 Holzminden, District", modify
label define nuts07_3_fua_adj 3256 "3256 Nienburg (Weser), District", modify
label define nuts07_3_fua_adj 3257 "3257 Schaumburg, District", modify
label define nuts07_3_fua_adj 3351 "3351 Celle, District", modify
label define nuts07_3_fua_adj 3353 "3353 Harburg, District", modify
label define nuts07_3_fua_adj 3354 "3354 Luechow-Dannenberg, District", modify
label define nuts07_3_fua_adj 3355 "3355 Lueneburg, District", modify
label define nuts07_3_fua_adj 3356 "3356 Osterholz, District", modify
label define nuts07_3_fua_adj 3357 "3357 Rotenburg (Wuemme), District", modify
label define nuts07_3_fua_adj 3358 "3358 Heidekreis", modify
label define nuts07_3_fua_adj 3359 "3359 Stade, District", modify
label define nuts07_3_fua_adj 3360 "3360 Uelzen, District", modify
label define nuts07_3_fua_adj 3361 "3361 Verden, District", modify
label define nuts07_3_fua_adj 3401 "3401 Delmenhorst, City", modify
label define nuts07_3_fua_adj 3402 "3402 Emden, City", modify
label define nuts07_3_fua_adj 3403 "3403 Oldenburg, City", modify
label define nuts07_3_fua_adj 3404 "3404 Osnabrueck, City", modify
label define nuts07_3_fua_adj 3451 "3451 Ammerland, District", modify
label define nuts07_3_fua_adj 3452 "3452 Aurich, District", modify
label define nuts07_3_fua_adj 3453 "3453 Cloppenburg, District", modify
label define nuts07_3_fua_adj 3454 "3454 Emsland, District", modify
label define nuts07_3_fua_adj 3455 "3455 Friesland, District", modify
label define nuts07_3_fua_adj 3456 "3456 Grafschaft Bentheim", modify
label define nuts07_3_fua_adj 3457 "3457 Leer, District", modify
label define nuts07_3_fua_adj 3458 "3458 Oldenburg, District", modify
label define nuts07_3_fua_adj 3459 "3459 Osnabrueck, District", modify
label define nuts07_3_fua_adj 3460 "3460 Vechta, District", modify
label define nuts07_3_fua_adj 3461 "3461 Wesermarsch, District", modify
label define nuts07_3_fua_adj 3462 "3462 Wittmund, District", modify
label define nuts07_3_fua_adj 3999 "3999 Wilhelmshaven, City + District", modify


label define nuts07_3_fua_adj 4011 "4011 Bremen, City", modify
label define nuts07_3_fua_adj 4999 "4999 Bremerhaven, City + District", modify

label define nuts07_3_fua_adj 5111 "5111 Duesseldorf, City", modify
label define nuts07_3_fua_adj 5112 "5112 Duisburg, City", modify
label define nuts07_3_fua_adj 5113 "5113 Essen, City", modify
label define nuts07_3_fua_adj 5114 "5114 Krefeld, City", modify
label define nuts07_3_fua_adj 5116 "5116 Moenchengladbach, City", modify
label define nuts07_3_fua_adj 5117 "5117 Muelheim an der Ruhr, City", modify
label define nuts07_3_fua_adj 5119 "5119 Oberhausen, City", modify
label define nuts07_3_fua_adj 5120 "5120 Remscheid, City", modify
label define nuts07_3_fua_adj 5122 "5122 Solingen, City", modify
label define nuts07_3_fua_adj 5124 "5124 Wuppertal, City", modify
label define nuts07_3_fua_adj 5154 "5154 Cleves, District", modify
label define nuts07_3_fua_adj 5158 "5158 Mettmann, District", modify
label define nuts07_3_fua_adj 5162 "5162 Rhein-Kreis Neuss", modify
label define nuts07_3_fua_adj 5166 "5166 Viersen, District", modify
label define nuts07_3_fua_adj 5170 "5170 Wesel, District", modify
label define nuts07_3_fua_adj 5315 "5315 Cologne, City", modify
label define nuts07_3_fua_adj 5316 "5316 Leverkusen, City", modify
label define nuts07_3_fua_adj 5334 "5334 Region Aachen", modify
label define nuts07_3_fua_adj 5358 "5358 Dueren, District", modify
label define nuts07_3_fua_adj 5362 "5362 Rhein-Erft-Kreis", modify
label define nuts07_3_fua_adj 5366 "5366 Euskirchen, District", modify
label define nuts07_3_fua_adj 5370 "5370 Heinsberg, District", modify
label define nuts07_3_fua_adj 5374 "5374 Oberbergischer Kreis", modify
label define nuts07_3_fua_adj 5378 "5378 Rheinisch-Bergischer Kreis", modify
label define nuts07_3_fua_adj 5512 "5512 Bottrop, City", modify
label define nuts07_3_fua_adj 5513 "5513 Gelsenkirchen, City", modify
label define nuts07_3_fua_adj 5515 "5515 Muenster, City", modify
label define nuts07_3_fua_adj 5554 "5554 Borken, District", modify
label define nuts07_3_fua_adj 5558 "5558 Coesfeld, District", modify
label define nuts07_3_fua_adj 5562 "5562 Recklinghausen, District", modify
label define nuts07_3_fua_adj 5566 "5566 Steinfurt, District", modify
label define nuts07_3_fua_adj 5570 "5570 Warendorf, District", modify
label define nuts07_3_fua_adj 5711 "5711 Bielefeld, City", modify
label define nuts07_3_fua_adj 5754 "5754 Guetersloh, District", modify
label define nuts07_3_fua_adj 5758 "5758 Herford, District", modify
label define nuts07_3_fua_adj 5762 "5762 Hoexter, District", modify
label define nuts07_3_fua_adj 5766 "5766 Lippe, District", modify
label define nuts07_3_fua_adj 5770 "5770 Minden-Luebbecke, District", modify
label define nuts07_3_fua_adj 5774 "5774 Paderborn, District", modify
label define nuts07_3_fua_adj 5911 "5911 Bochum, City", modify
label define nuts07_3_fua_adj 5913 "5913 Dortmund, City", modify
label define nuts07_3_fua_adj 5914 "5914 Hagen, City", modify
label define nuts07_3_fua_adj 5915 "5915 Hamm, City", modify
label define nuts07_3_fua_adj 5916 "5916 Herne, City", modify
label define nuts07_3_fua_adj 5954 "5954 Ennepe-Ruhr-Kreis", modify
label define nuts07_3_fua_adj 5958 "5958 Hochsauerlandkreis", modify
label define nuts07_3_fua_adj 5962 "5962 Maerkischer Kreis", modify
label define nuts07_3_fua_adj 5966 "5966 Olpe, District", modify
label define nuts07_3_fua_adj 5970 "5970 Siegen-Wittgenstein, District", modify
label define nuts07_3_fua_adj 5974 "5974 Soest, District", modify
label define nuts07_3_fua_adj 5978 "5978 Unna, District", modify
label define nuts07_3_fua_adj 5999 "5999 Bonn, City + District", modify


label define nuts07_3_fua_adj 6411 "6411 Darmstadt, City", modify
label define nuts07_3_fua_adj 6412 "6412 Frankfurt am Main, City", modify
label define nuts07_3_fua_adj 6413 "6413 Offenbach am Main, City", modify
label define nuts07_3_fua_adj 6414 "6414 Wiesbaden, City", modify
label define nuts07_3_fua_adj 6431 "6431 Bergstrasse, District", modify
label define nuts07_3_fua_adj 6432 "6432 Darmstadt-Dieburg, District", modify
label define nuts07_3_fua_adj 6433 "6433 Gross-Gerau, District", modify
label define nuts07_3_fua_adj 6434 "6434 Hochtaunuskreis", modify
label define nuts07_3_fua_adj 6435 "6435 Main-Kinzig-Kreis", modify
label define nuts07_3_fua_adj 6436 "6436 Main-Taunus-Kreis", modify
label define nuts07_3_fua_adj 6437 "6437 Odenwaldkreis", modify
label define nuts07_3_fua_adj 6438 "6438 Offenbach, District", modify
label define nuts07_3_fua_adj 6439 "6439 Rheingau-Taunus-Kreis", modify
label define nuts07_3_fua_adj 6440 "6440 Wetteraukreis, District", modify
label define nuts07_3_fua_adj 6531 "6531 Giessen, District", modify
label define nuts07_3_fua_adj 6532 "6532 Lahn-Dill-Kreis", modify
label define nuts07_3_fua_adj 6533 "6533 Limburg-Weilburg, District", modify
label define nuts07_3_fua_adj 6534 "6534 Marburg-Biedenkopf, District", modify
label define nuts07_3_fua_adj 6535 "6535 Vogelsbergkreis", modify
label define nuts07_3_fua_adj 6631 "6631 Fulda, District", modify
label define nuts07_3_fua_adj 6632 "6632 Hersfeld-Rotenburg, District", modify
label define nuts07_3_fua_adj 6634 "6634 Schwalm-Eder-Kreis", modify
label define nuts07_3_fua_adj 6635 "6635 Waldeck-Frankenberg, District", modify
label define nuts07_3_fua_adj 6636 "6636 Werra-Meissner-Kreis", modify
label define nuts07_3_fua_adj 6999 "6999 Kassel, City + District", modify

label define nuts07_3_fua_adj 7111 "7111 Koblenz, City", modify
label define nuts07_3_fua_adj 7131 "7131 Ahrweiler, District", modify
label define nuts07_3_fua_adj 7132 "7132 Altenkirchen (Westerwald), District", modify
label define nuts07_3_fua_adj 7133 "7133 Bad Kreuznach, District", modify
label define nuts07_3_fua_adj 7134 "7134 Birkenfeld, District", modify
label define nuts07_3_fua_adj 7135 "7135 Cochem-Zell, District", modify
label define nuts07_3_fua_adj 7137 "7137 Mayen-Koblenz, District", modify
label define nuts07_3_fua_adj 7138 "7138 Neuwied, District", modify
label define nuts07_3_fua_adj 7140 "7140 Rhein-Hunsrueck-Kreis", modify
label define nuts07_3_fua_adj 7141 "7141 Rhein-Lahn-Kreis", modify
label define nuts07_3_fua_adj 7143 "7143 Westerwaldnutskreis", modify
label define nuts07_3_fua_adj 7231 "7231 Bernkastel-Wittlich, District", modify
label define nuts07_3_fua_adj 7232 "7232 Eifelkreis Bitburg-Pruem, District", modify
label define nuts07_3_fua_adj 7233 "7233 Vulkaneifel, District", modify
label define nuts07_3_fua_adj 7311 "7311 Frankenthal (Pfalz), City", modify
label define nuts07_3_fua_adj 7312 "7312 Kaiserslautern, City", modify
label define nuts07_3_fua_adj 7314 "7314 Ludwigshafen am Rhein, City", modify
label define nuts07_3_fua_adj 7315 "7315 Mainz, City", modify
label define nuts07_3_fua_adj 7316 "7316 Neustadt an der Weinstrasse, City", modify
label define nuts07_3_fua_adj 7318 "7318 Speyer, City", modify
label define nuts07_3_fua_adj 7319 "7319 Worms, City", modify
label define nuts07_3_fua_adj 7320 "7320 Zweibruecken, City", modify
label define nuts07_3_fua_adj 7331 "7331 Alzey-Worms, District", modify
label define nuts07_3_fua_adj 7332 "7332 Bad Duerkheim, District", modify
label define nuts07_3_fua_adj 7333 "7333 Donnersbergkreis", modify
label define nuts07_3_fua_adj 7334 "7334 Germersheim, District", modify
label define nuts07_3_fua_adj 7335 "7335 Kaiserslautern, District", modify
label define nuts07_3_fua_adj 7336 "7336 Kusel, District", modify
label define nuts07_3_fua_adj 7338 "7338 Rhein-Pfalz-Kreis", modify
label define nuts07_3_fua_adj 7339 "7339 Mainz-Bingen, District", modify
label define nuts07_3_fua_adj 7997 "7997 Trier, City + District", modify
label define nuts07_3_fua_adj 7998 "7998 Pirmasens + District, City", modify
label define nuts07_3_fua_adj 7999 "7999 Landau in der Pfalz, City + District", modify


label define nuts07_3_fua_adj 8111 "8111 Stuttgart, City", modify
label define nuts07_3_fua_adj 8115 "8115 Boeblingen, District", modify
label define nuts07_3_fua_adj 8116 "8116 Esslingen, District", modify
label define nuts07_3_fua_adj 8117 "8117 Goeppingen, District", modify
label define nuts07_3_fua_adj 8118 "8118 Ludwigsburg, District", modify
label define nuts07_3_fua_adj 8119 "8119 Rems-Murr-Kreis", modify
label define nuts07_3_fua_adj 8126 "8126 Hohenlohekreis", modify
label define nuts07_3_fua_adj 8127 "8127 Schwaebisch Hall, District", modify
label define nuts07_3_fua_adj 8128 "8128 Main-Tauber-Kreis", modify
label define nuts07_3_fua_adj 8135 "8135 Heidenheim, District", modify
label define nuts07_3_fua_adj 8136 "8136 Ostalbkreis", modify
label define nuts07_3_fua_adj 8212 "8212 Karlsruhe, City", modify
label define nuts07_3_fua_adj 8215 "8215 Karlsruhe, District", modify
label define nuts07_3_fua_adj 8221 "8221 Heidelberg, City", modify
label define nuts07_3_fua_adj 8222 "8222 Mannheim, City", modify
label define nuts07_3_fua_adj 8225 "8225 Neckar-Odenwald-Kreis", modify
label define nuts07_3_fua_adj 8226 "8226 Rhein-Neckar-Kreis", modify
label define nuts07_3_fua_adj 8231 "8231 Pforzheim, City", modify
label define nuts07_3_fua_adj 8235 "8235 Calw, District", modify
label define nuts07_3_fua_adj 8236 "8236 Enzkreis", modify
label define nuts07_3_fua_adj 8237 "8237 Freudenstadt, District", modify
label define nuts07_3_fua_adj 8311 "8311 Freiburg im Breisgau, City", modify
label define nuts07_3_fua_adj 8315 "8315 Breisgau-Hochschwarzwald, District", modify
label define nuts07_3_fua_adj 8316 "8316 Emmendingen, District", modify
label define nuts07_3_fua_adj 8317 "8317 Ortenaukreis", modify
label define nuts07_3_fua_adj 8325 "8325 Rottweil, District", modify
label define nuts07_3_fua_adj 8326 "8326 Schwarzwald-Baar-Kreis", modify
label define nuts07_3_fua_adj 8327 "8327 Tuttlingen, District", modify
label define nuts07_3_fua_adj 8335 "8335 Konstanz, District", modify
label define nuts07_3_fua_adj 8336 "8336 Loerrach, District", modify
label define nuts07_3_fua_adj 8337 "8337 Waldshut, District", modify
label define nuts07_3_fua_adj 8415 "8415 Reutlingen, District", modify
label define nuts07_3_fua_adj 8416 "8416 Tuebingen, District", modify
label define nuts07_3_fua_adj 8417 "8417 Zollernalbkreis", modify
label define nuts07_3_fua_adj 8421 "8421 Ulm, City", modify
label define nuts07_3_fua_adj 8425 "8425 Alb-Donau-Kreis", modify
label define nuts07_3_fua_adj 8426 "8426 Biberach, District", modify
label define nuts07_3_fua_adj 8435 "8435 Bodenseekreis", modify
label define nuts07_3_fua_adj 8436 "8436 Ravensburg, District", modify
label define nuts07_3_fua_adj 8437 "8437 Sigmaringen, District", modify
label define nuts07_3_fua_adj 8998 "8998 Baden-Baden, City + District", modify
label define nuts07_3_fua_adj 8999 "8999 Heilbronn, City + District", modify


label define nuts07_3_fua_adj 9161 "9161 Ingolstadt, City", modify
label define nuts07_3_fua_adj 9162 "9162 Munich, City", modify
label define nuts07_3_fua_adj 9171 "9171 Altoetting, District", modify
label define nuts07_3_fua_adj 9172 "9172 Berchtesgadener Land, District", modify
label define nuts07_3_fua_adj 9173 "9173 Bad Toelz-Wolfratshausen, District", modify
label define nuts07_3_fua_adj 9174 "9174 Dachau, District", modify
label define nuts07_3_fua_adj 9175 "9175 Ebersberg, District", modify
label define nuts07_3_fua_adj 9176 "9176 Eichstaett, District", modify
label define nuts07_3_fua_adj 9177 "9177 Erding, District", modify
label define nuts07_3_fua_adj 9178 "9178 Freising, District", modify
label define nuts07_3_fua_adj 9179 "9179 Fuerstenfeldbruck, District", modify
label define nuts07_3_fua_adj 9180 "9180 Garmisch-Partenkirchen, District", modify
label define nuts07_3_fua_adj 9181 "9181 Landsberg am Lech, District", modify
label define nuts07_3_fua_adj 9182 "9182 Miesbach, District", modify
label define nuts07_3_fua_adj 9183 "9183 Muehldorf am Inn, District", modify
label define nuts07_3_fua_adj 9184 "9184 Munich, District", modify
label define nuts07_3_fua_adj 9185 "9185 Neuburg-Schrobenhausen, District", modify
label define nuts07_3_fua_adj 9186 "9186 Pfaffenhofen an der Ilm, District", modify
label define nuts07_3_fua_adj 9188 "9188 Starnberg, District", modify
label define nuts07_3_fua_adj 9189 "9189 Traunstein, District", modify
label define nuts07_3_fua_adj 9190 "9190 Weilheim-Schongau, District", modify
label define nuts07_3_fua_adj 9271 "9271 Deggendorf, District", modify
label define nuts07_3_fua_adj 9272 "9272 Freyung-Grafenau, District", modify
label define nuts07_3_fua_adj 9273 "9273 Kelheim, District", modify
label define nuts07_3_fua_adj 9276 "9276 Regen, District", modify
label define nuts07_3_fua_adj 9277 "9277 Rottal-Inn, District", modify
label define nuts07_3_fua_adj 9279 "9279 Dingolfing-Landau, District", modify
label define nuts07_3_fua_adj 9372 "9372 Cham, District", modify
label define nuts07_3_fua_adj 9373 "9373 Neumarkt in der Oberpfalz, District", modify
label define nuts07_3_fua_adj 9376 "9376 Schwandorf, District", modify
label define nuts07_3_fua_adj 9377 "9377 Tirschenreuth, District", modify


label define nuts07_3_fua_adj 9474 "9474 Forchheim, District", modify
label define nuts07_3_fua_adj 9476 "9476 Kronach, District", modify
label define nuts07_3_fua_adj 9477 "9477 Kulmbach, District", modify
label define nuts07_3_fua_adj 9478 "9478 Lichtenfels, District", modify
label define nuts07_3_fua_adj 9479 "9479 Wunsiedel im Fichtelgebirge, District", modify
label define nuts07_3_fua_adj 9562 "9562 Erlangen, City", modify
label define nuts07_3_fua_adj 9563 "9563 Fuerth, City", modify
label define nuts07_3_fua_adj 9564 "9564 Nuremberg, City", modify
label define nuts07_3_fua_adj 9565 "9565 Schwabach, City", modify
label define nuts07_3_fua_adj 9572 "9572 Erlangen-Hoechstadt, District", modify
label define nuts07_3_fua_adj 9573 "9573 Fuerth, District", modify
label define nuts07_3_fua_adj 9574 "9574 Nuernberger Land, District", modify
label define nuts07_3_fua_adj 9575 "9575 Neustadt an der Aisch-Bad Windsheim, District", modify
label define nuts07_3_fua_adj 9576 "9576 Roth, District", modify
label define nuts07_3_fua_adj 9577 "9577 Weissenburg-Gunzenhausen, District", modify
label define nuts07_3_fua_adj 9661 "9661 Aschaffenburg, City", modify
label define nuts07_3_fua_adj 9671 "9671 Aschaffenburg, District", modify
label define nuts07_3_fua_adj 9672 "9672 Bad Kissingen, District", modify
label define nuts07_3_fua_adj 9673 "9673 Rhoen-Grabfeld, District", modify
label define nuts07_3_fua_adj 9674 "9674 Hassberge, District", modify
label define nuts07_3_fua_adj 9675 "9675 Kitzingen, District", modify
label define nuts07_3_fua_adj 9676 "9676 Miltenberg, District", modify
label define nuts07_3_fua_adj 9677 "9677 Main-Spessart, District", modify
label define nuts07_3_fua_adj 9761 "9761 Augsburg, City", modify
label define nuts07_3_fua_adj 9764 "9764 Memmingen, City", modify
label define nuts07_3_fua_adj 9771 "9771 Aichach-Friedberg, District", modify
label define nuts07_3_fua_adj 9772 "9772 Augsburg, District", modify
label define nuts07_3_fua_adj 9773 "9773 Dillingen an der Donau, District", modify
label define nuts07_3_fua_adj 9774 "9774 Guenzburg, District", modify
label define nuts07_3_fua_adj 9775 "9775 Neu-Ulm, District", modify
label define nuts07_3_fua_adj 9776 "9776 Lindau (Bodensee), District", modify
label define nuts07_3_fua_adj 9778 "9778 Unterallgaeu, District", modify
label define nuts07_3_fua_adj 9779 "9779 Donau-Ries, District", modify
label define nuts07_3_fua_adj 9984 "9984 Kempten (Allgaeu), City + District", modify
label define nuts07_3_fua_adj 9985 "9985 Kaufbeuren, City + District", modify
label define nuts07_3_fua_adj 9986 "9986 Rosenheim, City + District", modify
label define nuts07_3_fua_adj 9987 "9987 Passau, City + District", modify
label define nuts07_3_fua_adj 9988 "9988 Landshut, City + District", modify
label define nuts07_3_fua_adj 9989 "9989 Straubing, City + District", modify
label define nuts07_3_fua_adj 9990 "9990 Regensburg, City + District", modify
label define nuts07_3_fua_adj 9991 "9991 Amberg, City + District", modify
label define nuts07_3_fua_adj 9992 "9992 Weiden in der Oberpfalz, City + District", modify
label define nuts07_3_fua_adj 9993 "9993 Ansbach, City + District", modify
label define nuts07_3_fua_adj 9994 "9994 Wuerzburg, City + District", modify
label define nuts07_3_fua_adj 9995 "9995 Schweinfurt, City + District", modify
label define nuts07_3_fua_adj 9996 "9996 Bamberg, City + District", modify
label define nuts07_3_fua_adj 9997 "9997 Coburg, City + District", modify
label define nuts07_3_fua_adj 9998 "9998 Hof, City + District", modify
label define nuts07_3_fua_adj 9999 "9999 Bayreuth, City + District", modify

label define nuts07_3_fua_adj 10041 "10041 Region Saarbruecken", modify
label define nuts07_3_fua_adj 10042 "10042 Merzig-Wadern, District", modify
label define nuts07_3_fua_adj 10043 "10043 Neunkirchen, District", modify
label define nuts07_3_fua_adj 10044 "10044 Saarlouis, District", modify
label define nuts07_3_fua_adj 10045 "10045 Saarpfalz-Kreis", modify
label define nuts07_3_fua_adj 10046 "10046 Sankt Wendel, District", modify

label define nuts07_3_fua_adj 11000 "11000 Berlin, City", modify

label define nuts07_3_fua_adj 12051 "12051 Brandenburg an der Havel, City", modify
label define nuts07_3_fua_adj 12053 "12053 Frankfurt (Oder), City", modify
label define nuts07_3_fua_adj 12054 "12054 Potsdam, City", modify
label define nuts07_3_fua_adj 12060 "12060 Barnim, District", modify
label define nuts07_3_fua_adj 12061 "12061 Dahme-Spreewald, District", modify
label define nuts07_3_fua_adj 12062 "12062 Elbe-Elster, District", modify
label define nuts07_3_fua_adj 12063 "12063 Havelland, District", modify
label define nuts07_3_fua_adj 12064 "12064 Maerkisch-Oderland, District", modify
label define nuts07_3_fua_adj 12065 "12065 Oberhavel, District", modify
label define nuts07_3_fua_adj 12066 "12066 Oberspreewald-Lausitz, District", modify
label define nuts07_3_fua_adj 12067 "12067 Oder-Spree, District", modify
label define nuts07_3_fua_adj 12068 "12068 Ostprignitz-Ruppin, District", modify
label define nuts07_3_fua_adj 12069 "12069 Potsdam-Mittelmark, District", modify
label define nuts07_3_fua_adj 12070 "12070 Prignitz, District", modify
label define nuts07_3_fua_adj 12072 "12072 Teltow-Flaeming, District", modify
label define nuts07_3_fua_adj 12073 "12073 Uckermark, District", modify
label define nuts07_3_fua_adj 12999 "12999 Cottbus, City + District", modify

label define nuts07_3_fua_adj 13004 "13004 Schwerin, City", modify
label define nuts07_3_fua_adj 13071 "13071 Mecklenburgische Seenplatte, District", modify
label define nuts07_3_fua_adj 13073 "13073 Vorpommern-Ruegen, District", modify
label define nuts07_3_fua_adj 13074 "13074 Nordwestmecklenburg, District", modify
label define nuts07_3_fua_adj 13075 "13075 Vorpommern-Greifswald, District", modify
label define nuts07_3_fua_adj 13076 "13076 Ludwigslust-Parchim, District", modify
label define nuts07_3_fua_adj 13999 "13999 Rostock, City + District", modify

label define nuts07_3_fua_adj 14511 "14511 Chemnitz, City", modify
label define nuts07_3_fua_adj 14521 "14521 Erzgebirgskreis", modify
label define nuts07_3_fua_adj 14522 "14522 Mittelsachsen, District", modify
label define nuts07_3_fua_adj 14523 "14523 Vogtlandkreis", modify
label define nuts07_3_fua_adj 14524 "14524 Zwickau, District", modify
label define nuts07_3_fua_adj 14612 "14612 Dresden, City", modify
label define nuts07_3_fua_adj 14625 "14625 Bautzen, District", modify
label define nuts07_3_fua_adj 14626 "14626 Goerlitz, District", modify
label define nuts07_3_fua_adj 14627 "14627 Meissen, District", modify
label define nuts07_3_fua_adj 14628 "14628 Saechsische Schweiz-Osterzgebirge, District", modify
label define nuts07_3_fua_adj 14713 "14713 Leipzig, City", modify
label define nuts07_3_fua_adj 14729 "14729 Leipzig, District", modify
label define nuts07_3_fua_adj 14730 "14730 Nordsachsen, District", modify

label define nuts07_3_fua_adj 15001 "15001 Dessau-Rosslau, City", modify
label define nuts07_3_fua_adj 15003 "15003 Magdeburg, City", modify
label define nuts07_3_fua_adj 15081 "15081 Altmarkkreis Salzwedel", modify
label define nuts07_3_fua_adj 15082 "15082 Anhalt-Bitterfeld, District", modify
label define nuts07_3_fua_adj 15083 "15083 Boerde, District", modify
label define nuts07_3_fua_adj 15084 "15084 Burgenlandkreis", modify
label define nuts07_3_fua_adj 15085 "15085 Harz, District", modify
label define nuts07_3_fua_adj 15086 "15086 Jerichower Land, District", modify
label define nuts07_3_fua_adj 15087 "15087 Mansfeld-Suedharz, District", modify
label define nuts07_3_fua_adj 15089 "15089 Salzlandkreis", modify
label define nuts07_3_fua_adj 15090 "15090 Stendal, District", modify
label define nuts07_3_fua_adj 15091 "15091 Wittenberg, District", modify
label define nuts07_3_fua_adj 15999 "15999 Halle (Saale), City + District", modify

label define nuts07_3_fua_adj 16051 "16051 Erfurt, City", modify
label define nuts07_3_fua_adj 16052 "16052 Gera, City", modify
label define nuts07_3_fua_adj 16053 "16053 Jena, City", modify
label define nuts07_3_fua_adj 16054 "16054 Suhl, City", modify
label define nuts07_3_fua_adj 16056 "16056 Eisenach, City", modify
label define nuts07_3_fua_adj 16061 "16061 Eichsfeld, District", modify
label define nuts07_3_fua_adj 16062 "16062 Nordhausen, District", modify
label define nuts07_3_fua_adj 16063 "16063 Wartburgkreis", modify
label define nuts07_3_fua_adj 16064 "16064 Unstrut-Hainich-Kreis", modify
label define nuts07_3_fua_adj 16065 "16065 Kyffhaeuserkreis", modify
label define nuts07_3_fua_adj 16066 "16066 Schmalkalden-Meiningen, District", modify
label define nuts07_3_fua_adj 16067 "16067 Gotha, District", modify
label define nuts07_3_fua_adj 16068 "16068 Soemmerda, District", modify
label define nuts07_3_fua_adj 16069 "16069 Hildburghausen, District", modify
label define nuts07_3_fua_adj 16070 "16070 Ilm-Kreis", modify
label define nuts07_3_fua_adj 16072 "16072 Sonneberg, District", modify
label define nuts07_3_fua_adj 16073 "16073 Saalfeld-Rudolstadt, District", modify
label define nuts07_3_fua_adj 16074 "16074 Saale-Holzland-Kreis", modify
label define nuts07_3_fua_adj 16075 "16075 Saale-Orla-Kreis", modify
label define nuts07_3_fua_adj 16076 "16076 Greiz, Kreis", modify
label define nuts07_3_fua_adj 16077 "16077 Altenburger Land, District", modify
label define nuts07_3_fua_adj 16999 "16999 Weimar, City + District", modify

label save nuts07_3_fua_adj using "$prog\NUTS07-3-FUA.do", replace



label values nuts07_3_fua_adj nuts07_3_fua_adj

tab nuts07_3_fua_adj, m

codebook nuts07_3_fua_adj // 241 regions = 96 FUAs + 145 NUTS-3 regions

label variable nuts07_3_fua_adj "FUA + District (NUTS07-3)"



save "$data\BeH_FUA.dta", replace



use "$data\BeH_FUA.dta", replace

keep if fua!=.
keep nuts07_3_adj


duplicates drop
save "$data\FUA_nuts_adj.dta", replace







/*		
*========================= STATA SELF-SERVICE: BEGIN ==========================*

*disable "save" commands, except last one
*capture code for stata self-service by log file

log using "$log\\${AMSNr}_STATA_Self-Service_`c(current_date)'.log", name(stataselfservice) replace

*==============================================================================*



*** 1.2 PREPARATION OF BEH DATA: LABOR MARKET CONCENTRATION ***


*** 1.2.1 DEFINE BEH EXTRACT FOR DIM DEPARTMENT ***


*not necessary 

*reason: STATA self-service from DIM is used


*** 1.2.2 LOAD DATASET ***



*description of underlying BeH dataset:
*- 100% universe of observations from BeH v10.05.01 ...
*- ... between 1 Jan 2010 and 31 Dec 2019
*- ... without episode splitting
*- ... with additional variables: imputed education (Thomsen et al., 2018), imputed part-time (Ludsteck/Thomsen, 2016), imputed industries, hours 2010-2014


*describe using "$orig\BeH\... .dta" 


*load standard BeH variables

use $beh\\$beh_bez, clear 

merge 1:1 ieb_fall_id using "$beh\\$imp_az"
drop if _merge==2
drop _merge		

*add additional BeH variables (upon request from DIM department)


merge 1:1 ieb_fall_id using "$beh\\$wz08_kons"	
drop if _merge==2
drop _merge

merge 1:1 ieb_fall_id using "$beh\\$ip1"	
drop if _merge==2		
drop _merge

merge 1:1 ieb_fall_id using "$beh\$arbstd"
drop if _merge==2		
drop _merge





*create year variable from spell information

gen year = year(beh_beg_dat)

tab year, m

*note:
*1975-2016: 36-month data material (100%)
*2017-2018: 18-month data material (99%)
*2019: 6-month data material (97%) --> drop to avoid statistical artefact of higher concentration (reason: spells are notified establishment-wise --> less establishments --> less concentration)


keep if year>=2010 & year<=2019 


label data ""


save $data\\${AMSNr}_BeH_1019_V0.dta, replace
*use $data\\${AMSNr}_BeH_1019_V0.dta, clear





*** 1.2.3 CLEAN DATASET ***


*label ID variables


label variable prs_id "Person"
label variable year "Year"
label variable betnr "Establishment"
label variable ieb_fall_id "Observation ID"





*keep only necessary variables and observations



keep prs_id year betnr ieb_fall_id /// krk_betnr vrs_id
	 beh_beg_dat beh_end_dat beh_dauer /// beh_erst_dat
	 beh_entgelt beh_tag_entg whrng_knz ///
	 /// beitr_av beitr_kv beitr_pv beitr_rv beh_vs_tr 
	 beh_arbstd ///
	 beh_pers_gr berufstellg berufstellg_imp beh_abg /// bzp_id beh_status_kz
	 geb_dat sex_id beh_staat ///
	 beh_an_ueberlass beh_befristung /// gleitzone
	 beh_ausbildung beh_ausbildung_imp /// beh_schul_abschl beh_ausb_abschl
	 wz08_kons_num /// wz73_num wz93_num wz03_num wz08_num
	 beh_beruf_num beh_beruf_kldb10_num ///
	 e_krs_schl_ao_akt_num e_gem_schl_ao_akt_num /// e_gst_schl_ao_akt_num e_aa_schl_ao_akt_num    				
	 /// b_krs_schl_ao_akt_num b_gem_schl_ao_akt_num b_gst_schl_ao_akt_num b_aa_schl_ao_akt_num     	
	 e_krs_schl_wo_akt_num e_gem_schl_wo_akt_num /// e_gst_schl_wo_akt_num e_aa_schl_wo_akt_num	
	 /// b_krs_schl_wo_akt_num b_gem_schl_wo_akt_num b_gst_schl_wo_akt_num b_aa_schl_wo_akt_num		
	 ow_knz
	    
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 

*sort and order data

sort prs_id year betnr ieb_fall_id

order prs_id year betnr ieb_fall_id /// krk_betnr vrs_id
	  beh_beg_dat beh_end_dat beh_dauer /// beh_erst_dat
	  beh_entgelt beh_tag_entg whrng_knz ///
	  /// beitr_av beitr_kv beitr_pv beitr_rv beh_vs_tr 
	  beh_arbstd ///
	  beh_pers_gr berufstellg berufstellg_imp beh_abg /// bzp_id beh_status_kz
	  geb_dat sex_id beh_staat ///
	  beh_an_ueberlass beh_befristung /// gleitzone
	  beh_ausbildung beh_ausbildung_imp /// beh_schul_abschl beh_ausb_abschl
	  wz08_kons_num /// wz73_num wz93_num wz03_num wz08_num
	  beh_beruf_num beh_beruf_kldb10_num ///
	  e_krs_schl_ao_akt_num e_gem_schl_ao_akt_num /// e_gst_schl_ao_akt_num e_aa_schl_ao_akt_num    				
	  /// b_krs_schl_ao_akt_num b_gem_schl_ao_akt_num b_gst_schl_ao_akt_num b_aa_schl_ao_akt_num     	
	  e_krs_schl_wo_akt_num e_gem_schl_wo_akt_num /// e_gst_schl_wo_akt_num e_aa_schl_wo_akt_num	
	  /// b_krs_schl_wo_akt_num b_gem_schl_wo_akt_num b_gst_schl_wo_akt_num b_aa_schl_wo_akt_num		
	  ow_knz
	 
	 
format %17.0g ieb_fall_id


*drop if establishment is unknown

drop if betnr==.


compress


save $data\\${AMSNr}_BeH_1019_V1.dta, replace
*use $data\\${AMSNr}_BeH_1019_V1.dta, clear


*==============================================================================*


*delete data sets from intermediate steps

cap erase $data\\${AMSNr}_BeH_1019_V0.dta


*evaluate size of dataset 

*note: maximum sample from DIM = 10% of entire IEB ~ 50 GB

checksum $data\\${AMSNr}_BeH_1019_V1.dta


display r(filelen)

*display round( 50 * r(filelen) / 1000000000, 0.01) " GB" // test data

display round( 1 * r(filelen) / 1000000000, 0.01) " GB" // final data


log close stataselfservice


*========================== STATA SELF-SERVICE: END ===========================*
*/








use "$orig\BeH\015163_BeH_1019_V1.dta", clear



*** 1.2.4 ANALOGOUS DATA ADJUSTMENTS TO ESTABLISHMENT HISTORY PANEL (EXCEPT: WAGE IMPUTATION, REFERENCE DATE, AND DELETION OF MULTIPLE PERSON-ESTABLISHMENT RELATIONSHIPS WITHIN ONE YEAR ) ***



*** (A) IMPUTATION OF EDUCATION VARIABLE ***


*source: Ganzer et al. (2020, p.15)

*note: must be done before episode splitting is undone and irrelevant employment spells are deleted

*imputation of education variable by means of Thomsen et al. (2018)
*has already been implemented in variable "beh_ausbildung_imp"


tab beh_ausbildung, m // there are missing values
count if ( beh_ausbildung==-5 | beh_ausbildung== 7 | beh_ausbildung==9 ) // ... observations are missing

tab beh_ausbildung_imp, m // imputation from Thomsen et al. (2018)
count if beh_ausbildung_imp==-7 // ... observations are only missing anymore

drop beh_ausbildung



*** (B) UNDO EPISODE SPLITTING ***

*source: Antoni et al. (2016, p.27)

*irrelevant as data do not feature episode splitting




*** (C) CONSIDERATION OF RELEVANT EMPLOYMENT SPELLS ***

*only consider the following employment relationships:
*101,102,103,105,106,109,112,113,114,118,119,120,121,122,140,141,142,143,144,149,201,202,203,205,209,999,YYY
*source: Ganzer et al. (2020, p.13 & 111f)

tab beh_pers_gr, m

keep if beh_pers_gr == 101 |  beh_pers_gr == 102 | beh_pers_gr == 103 | beh_pers_gr == 105 | /// 
        beh_pers_gr == 106 |  beh_pers_gr == 109 | beh_pers_gr == 112 | beh_pers_gr == 113 | /// 
        beh_pers_gr == 114 |  beh_pers_gr == 118 | beh_pers_gr == 119 | beh_pers_gr == 120 | /// 
        beh_pers_gr == 121 |  beh_pers_gr == 122 | beh_pers_gr == 140 | beh_pers_gr == 141 | ///
		beh_pers_gr == 142 |  beh_pers_gr == 143 | beh_pers_gr == 144 | beh_pers_gr == 149 | ///
		beh_pers_gr == 201 |  beh_pers_gr == 203 | beh_pers_gr == 205 | beh_pers_gr == 209 | /// 
		beh_pers_gr == 299 |  beh_pers_gr == 999 | beh_pers_gr == -8  // drop all notifications with irrelevant employment status

		
		


gen contract = .
replace contract = 1 if (beh_pers_gr==101 | beh_pers_gr==113 | beh_pers_gr==114 | beh_pers_gr==140 | beh_pers_gr==143) // regular employment
replace contract = 2 if (beh_pers_gr==109 | beh_pers_gr==209) // marginal employment
replace contract = 3 if (beh_pers_gr==102 | beh_pers_gr==121 | beh_pers_gr==122 | beh_pers_gr==141 | beh_pers_gr==144) // apprenticeship
replace contract = 4 if (beh_pers_gr==103 | beh_pers_gr==142) // partial retirement
replace contract = 5 if (beh_pers_gr==105 | beh_pers_gr==106 | beh_pers_gr==112 | beh_pers_gr==118 | beh_pers_gr==119 | beh_pers_gr==120 | beh_pers_gr==149 | beh_pers_gr==201 | beh_pers_gr==203 | beh_pers_gr==205 | beh_pers_gr==999 | beh_pers_gr==-8) // other employment

label define contract 1 "1 Regular Employment" 2 "2 Marginal Employment" 3 "3 Apprenticeship" 4 "4 Partial Retirement" 5 "5 Other Employment" 
label values contract


drop beh_pers_gr


*** (D) IMPUTATION FOR PART-TIME VARIABLE ***


*source: Ganzer et al. (2020, p.16)

*imputation of part-time variable by means of Thomsen/Ludsteck (2016)
*has already been implemented in variable "berufstellg_imp_num"


tab berufstellg, m	
count if ( berufstellg==-9 | berufstellg==-7 | berufstellg==-5 | berufstellg==5 | berufstellg==6 ) // ... observations are missing

tab berufstellg_imp_num, m // imputation from Ludsteck/Thomsen (2016) --> this variable includes only imputed values

replace berufstellg=20 if berufstellg_imp_num==20
replace berufstellg=21 if berufstellg_imp_num==21

drop berufstellg_imp_num
rename berufstellg berufstellg_imp_num

tab berufstellg_imp_num, m
count if ( berufstellg_imp_num==-9 | berufstellg_imp_num==-5 | berufstellg_imp_num==-5 | berufstellg_imp_num==5 | berufstellg_imp_num==6) // ... observations are only missing anymore


gen parttime_imp = .
replace parttime_imp = 0 if ( berufstellg_imp_num==0  | berufstellg_imp_num==1  | berufstellg_imp_num==2  | berufstellg_imp_num==3  | berufstellg_imp_num==4 |  berufstellg_imp_num==7 | berufstellg_imp_num==20 )
replace parttime_imp = 1 if ( berufstellg_imp_num==8  | berufstellg_imp_num==9  | berufstellg_imp_num==21 )
replace parttime_imp = . if ( berufstellg_imp_num==-9 | berufstellg_imp_num==-8 | berufstellg_imp_num==-7 | berufstellg_imp_num==-6 | berufstellg_imp_num==-5 | berufstellg_imp_num==5 | berufstellg_imp_num==6 )

label variable parttime_imp "Part-Time Employment (0=No, 1=Yes)"

tab parttime_imp, m		
tab year parttime_imp, m

drop berufstellg_imp_num





*** (E) DELETION OF OBSERVATIONS WITH ZERO WAGES ***


*delete observations with zero wages
*source: Ganzer et al. (2020, p.13)

count if beh_tag_entg==0 // ...
drop if beh_tag_entg==0


*additional adjustment (not in BHP):

count if beh_tag_entg==. // ...
drop if beh_tag_entg==.



*** (F) CONVERSION TO EURO ***


*note: variable "beh_tag_entg" is already expressed in Euro for all years
*source: Grießemer (2019, p. 35 & 78)
*no need for conversion

*note: variable "beh_entg" is expressed in DM for years before 1999
*source: Grießemer (2019, p. 35 & 69)
*must be converted

tab year whrng_knz, m

replace beh_entgelt = beh_entgelt / 1.95583 if year<1999

drop whrng_knz






*** (G) ADDITION OF SPECIAL PAYMENTS ***


*add special payments (holiday pay, christmas bonus) to spell for regular employment
*source: Ganzer et al. (2020, p.14)

*problem: unclear which spell the special payments should be attributed to (as we do not restrict globally on one person-establishment-year triple)


drop if beh_abg==54



/*

*** (H) EXTRACT REFERENCE DATE INFORMATION FROM SPELL DATA ***


*does not make sense here --> keep all spells for application of different hiring concepts later on



*** (I) DELETE MULTIPLE PERSON-ESTABLISHMENT RELATIONSHIPS WITHIN ONE YEAR ***

*does not make sense here --> keep all spells and delete multiple person-establishment relationship separately for each inflow concept



*/



*delete unneeded variables


keep prs_id year betnr ieb_fall_id /// 
	 beh_beg_dat beh_end_dat beh_dauer ///
	 beh_tag_entg /// 
	 /// beh_arbstd ///
	 contract parttime_imp /// 
	 /// geb_dat sex_id beh_staat
	 /// beh_an_ueberlass beh_befristung 
	 /// beh_ausbildung_imp 
	 wz08_kons_num /// 
	 beh_beruf_kldb10_num /// beh_beruf_num 
	 e_krs_schl_ao_akt_num e_gem_schl_ao_akt_num /// 
	 e_krs_schl_wo_akt_num e_gem_schl_wo_akt_num ///
	 ow_knz
	    		
			


save "$data\LMC_1019_V2.dta", replace
use "$data\LMC_1019_V2.dta", clear





*** 1.2.5 PREPARATION OF BEH VARIABLES ***






*** (B) START DATE

rename beh_beg_dat start

*tab start, m	

label variable start "Start Date of Spell"

format start %tdDD_Mon_CCYY



*** (C) END DATE


rename beh_end_dat end

*tab end, m	

label variable end "End Date of Spell"

format end %tdDD_Mon_CCYY






			
*** (D) SPELL DURATION

rename beh_dauer duration

tab duration, m

label variable duration "Spell Duration (in Days)"





*** (E) WORKING TIME INDICATOR

tab parttime_imp, m	

label variable parttime_imp "Part-Time Employment (0=No, 1=Yes)"

label define parttime 0 "0 No" 1 "1 Yes"
label values parttime parttime


*** (F) EMPLOYMENT TYPE


gen type = .
replace type = 1 if contract==1 & parttime_imp==0 // regular employment: full-time
replace type = 2 if contract==1 & parttime_imp==1 // regular employment: part-time
replace type = 3 if contract==2 // marginal employment
replace type = 4 if contract==3 // apprenticeship
replace type = 5 if contract==4 // partial retirement
replace type = 6 if contract==5 & parttime_imp==0 // other employment: full-time
replace type = 7 if contract==5 & parttime_imp==1 // other employment: part-time


label variable type "Type of Employment"

label define type 1 "1 Regular Employment: FT" 2 "2 Regular Employment: PT" 3 "3 Marginal Employment" 4 "4 Apprenticeship" 5 "5 Partial Retirement"  6 "6 Other Employment: FT"  7 "7 Other Employment: PT"
label values type type


tab type, m

tab type parttime_imp, m

drop contract			
			
		


*** (K) INDUSTRY ***



*WZ08-5 industries (839 subclasses)

rename wz08_kons_num wz08_5_imp

*tab wz08_5_imp, m 
recode wz08_5_imp (-9=.) (-8=.) (-7=.) (-6=.) (-5=.)

gen wz08_5_imp_miss = (wz08_5_imp==.)
tab year wz08_5_imp_miss
drop wz08_5_imp_miss

quietly do "$prog\WZ08-5.do"
label values wz08_5_imp wz08_5
format %50.0f wz08_5_imp

*tab wz08_5_imp, m


*WZ08-4 industries (615 classes)

gen wz08_4_imp = floor(wz08_5_imp/10)

*tab wz08_4_imp, m


quietly do "$prog\WZ08-4.do"
label values wz08_4_imp wz08_4
format %50.0f wz08_4_imp

*tab wz08_4_imp, m



*WZ08-3 industries (272 groups)

gen wz08_3_imp = floor(wz08_4_imp/10) 

*tab wz08_3_imp, m 


quietly do "$prog\WZ08-3.do"
label values wz08_3_imp wz08_3
format %50.0f wz08_3_imp

*tab wz08_3, m



*WZ08-2 industries (88 divisions)

gen wz08_2_imp = floor(wz08_3_imp/10) 

*tab wz08_2_imp, m 

quietly do "$prog\WZ08-2.do"
label values wz08_2_imp wz08_2
format %50.0f wz08_2_imp

*tab wz08_2_imp, m


*WZ08-1C industries (38 small sections)

gen wz08_1c_imp = . 
replace wz08_1c_imp =  1 if wz08_2_imp>= 1 & wz08_2_imp<= 3 // A
replace wz08_1c_imp =  2 if wz08_2_imp>= 5 & wz08_2_imp<= 9 // B
replace wz08_1c_imp =  3 if wz08_2_imp>=10 & wz08_2_imp<=12 // CA
replace wz08_1c_imp =  4 if wz08_2_imp>=13 & wz08_2_imp<=15 // CB
replace wz08_1c_imp =  5 if wz08_2_imp>=16 & wz08_2_imp<=18 // CC
replace wz08_1c_imp =  6 if wz08_2_imp==19 // CD
replace wz08_1c_imp =  7 if wz08_2_imp==20 // CE
replace wz08_1c_imp =  8 if wz08_2_imp==21 // CF
replace wz08_1c_imp =  9 if wz08_2_imp>=22 & wz08_2_imp<=23 // CG
replace wz08_1c_imp = 10 if wz08_2_imp>=24 & wz08_2_imp<=25 // CH
replace wz08_1c_imp = 11 if wz08_2_imp==26 // CI
replace wz08_1c_imp = 12 if wz08_2_imp==27 // CJ
replace wz08_1c_imp = 13 if wz08_2_imp==28 // CK
replace wz08_1c_imp = 14 if wz08_2_imp>=29 & wz08_2_imp<=30 // CL
replace wz08_1c_imp = 15 if wz08_2_imp>=31 & wz08_2_imp<=33 // CM
replace wz08_1c_imp = 16 if wz08_2_imp==35  // D
replace wz08_1c_imp = 17 if wz08_2_imp>=36 & wz08_2_imp<=39 // E
replace wz08_1c_imp = 18 if wz08_2_imp>=41 & wz08_2_imp<=43 // F
replace wz08_1c_imp = 19 if wz08_2_imp>=45 & wz08_2_imp<=47 // G
replace wz08_1c_imp = 20 if wz08_2_imp>=49 & wz08_2_imp<=53 // H
replace wz08_1c_imp = 21 if wz08_2_imp>=55 & wz08_2_imp<=56 // I
replace wz08_1c_imp = 22 if wz08_2_imp>=58 & wz08_2_imp<=60 // JA
replace wz08_1c_imp = 23 if wz08_2_imp==61 // JB
replace wz08_1c_imp = 24 if wz08_2_imp>=62 & wz08_2_imp<=63 // JC
replace wz08_1c_imp = 25 if wz08_2_imp>=64 & wz08_2_imp<=66 // K
replace wz08_1c_imp = 26 if wz08_2_imp==68 // L
replace wz08_1c_imp = 27 if wz08_2_imp>=69 & wz08_2_imp<=71 // MA
replace wz08_1c_imp = 28 if wz08_2_imp==72 // MB
replace wz08_1c_imp = 29 if wz08_2_imp>=73 & wz08_2_imp<=75 // MC
replace wz08_1c_imp = 30 if wz08_2_imp>=77 & wz08_2_imp<=82 // N
replace wz08_1c_imp = 31 if wz08_2_imp==84 // O
replace wz08_1c_imp = 32 if wz08_2_imp==85 // P
replace wz08_1c_imp = 33 if wz08_2_imp==86 // QA
replace wz08_1c_imp = 34 if wz08_2_imp>=87 & wz08_2_imp<=88 // QB
replace wz08_1c_imp = 35 if wz08_2_imp>=90 & wz08_2_imp<=93 // R
replace wz08_1c_imp = 36 if wz08_2_imp>=94 & wz08_2_imp<=96 // S
replace wz08_1c_imp = 37 if wz08_2_imp>=97 & wz08_2_imp<=98 // T
replace wz08_1c_imp = 38 if wz08_2_imp==99 // U

quietly do "$prog\WZ08-1C.do"
label values wz08_1c_imp wz08_1c
format %50.0f wz08_1c_imp

*tab wz08_1c_imp, m


*WZ08-1B industries (21 sections)

gen wz08_1b_imp = . 
replace wz08_1b_imp =  1 if wz08_2_imp>= 1 & wz08_2_imp<= 3 // A
replace wz08_1b_imp =  2 if wz08_2_imp>= 5 & wz08_2_imp<= 9 // B
replace wz08_1b_imp =  3 if wz08_2_imp>=10 & wz08_2_imp<=33 // C
replace wz08_1b_imp =  4 if wz08_2_imp==35 // D
replace wz08_1b_imp =  5 if wz08_2_imp>=36 & wz08_2_imp<=39 // E
replace wz08_1b_imp =  6 if wz08_2_imp>=41 & wz08_2_imp<=43 // F
replace wz08_1b_imp =  7 if wz08_2_imp>=45 & wz08_2_imp<=47 // G
replace wz08_1b_imp =  8 if wz08_2_imp>=49 & wz08_2_imp<=53 // H
replace wz08_1b_imp =  9 if wz08_2_imp>=55 & wz08_2_imp<=56 // I
replace wz08_1b_imp = 10 if wz08_2_imp>=58 & wz08_2_imp<=63 // J
replace wz08_1b_imp = 11 if wz08_2_imp>=64 & wz08_2_imp<=66 // K
replace wz08_1b_imp = 12 if wz08_2_imp==68 // L
replace wz08_1b_imp = 13 if wz08_2_imp>=69 & wz08_2_imp<=75 // M
replace wz08_1b_imp = 14 if wz08_2_imp>=77 & wz08_2_imp<=82 // N
replace wz08_1b_imp = 15 if wz08_2_imp==84 // O
replace wz08_1b_imp = 16 if wz08_2_imp==85 // P
replace wz08_1b_imp = 17 if wz08_2_imp>=86 & wz08_2_imp<=88 // Q
replace wz08_1b_imp = 18 if wz08_2_imp>=90 & wz08_2_imp<=93 // R
replace wz08_1b_imp = 19 if wz08_2_imp>=94 & wz08_2_imp<=96 // S
replace wz08_1b_imp = 20 if wz08_2_imp>=97 & wz08_2_imp<=98 // T
replace wz08_1b_imp = 21 if wz08_2_imp==99 // U

quietly do "$prog\WZ08-1B.do"
label values wz08_1b_imp wz08_1b
format %50.0f wz08_1b_imp

*tab wz08_1b_imp, m


*WZ08-1A industries (10 large sections)

gen wz08_1a_imp = . 
replace wz08_1a_imp =  1 if wz08_2_imp>= 1 & wz08_2_imp<= 3 // A
replace wz08_1a_imp =  2 if wz08_2_imp>= 5 & wz08_2_imp<=39 // B, C, D & E
replace wz08_1a_imp =  3 if wz08_2_imp>=41 & wz08_2_imp<=43 // F
replace wz08_1a_imp =  4 if wz08_2_imp>=45 & wz08_2_imp<=56 // G, H & I
replace wz08_1a_imp =  5 if wz08_2_imp>=58 & wz08_2_imp<=63 // J
replace wz08_1a_imp =  6 if wz08_2_imp>=64 & wz08_2_imp<=66 // K
replace wz08_1a_imp =  7 if wz08_2_imp==68 // L
replace wz08_1a_imp =  8 if wz08_2_imp>=69 & wz08_2_imp<=82 // M & N
replace wz08_1a_imp =  9 if wz08_2_imp>=84 & wz08_2_imp<=88 // O, P & Q
replace wz08_1a_imp = 10 if wz08_2_imp>=90 & wz08_2_imp<=99 // R, S, T & U

quietly do "$prog\WZ08-1A.do"
label values wz08_1a_imp wz08_1a
format %50.0f wz08_1a_imp

*tab wz08_1a_imp, m



label variable wz08_5_imp "Industrial Subclass (WZ08-5)"
label variable wz08_4_imp "Industrial Class (WZ08-4)"
label variable wz08_3_imp "Industrial Group (WZ08-3)"
label variable wz08_2_imp "Industrial Division (WZ08-2)"
label variable wz08_1c_imp "Small Industrial Section (WZ08-1C)"
label variable wz08_1b_imp "Industrial Section (WZ08-1B)"
label variable wz08_1a_imp "Large Industrial Section (WZ08-1A)"

drop wz08_5_imp wz08_4_imp wz08_3_imp wz08_1c_imp wz08_1b_imp wz08_1a_imp

compress wz08_*





*** (M) OCCUPATION (KLDB 2010) ***


*KldB10-5 occupations (1,286 occupational types)


rename beh_beruf_kldb10_num kldb10_5_imp

*tab kldb10_5_imp, m
recode kldb10_5_imp (-9=.) (-8=.) (-7=.) (-6=.) (-5=.)

quietly do "$prog\KldB10-5.do"
label values kldb10_5_imp kldb10_5
format %50.0f kldb10_5_imp

*tab kldb10_5_imp, m



*KldB10-4 occupations (700 occupational sub-groups)

gen kldb10_4_imp = floor(kldb10_5_imp/10) 

quietly do "$prog\KldB10-4.do"
label values kldb10_4_imp kldb10_4
format %50.0f kldb10_4_imp

*tab kldb10_4_imp, m



*KldB10-3 occupations (144 occupational groups)

gen kldb10_3_imp = floor(kldb10_4_imp/10) 

quietly do "$prog\KldB10-3.do"
label values kldb10_3_imp kldb10_3
format %50.0f kldb10_3_imp

*tab kldb10_3_imp, m





*KldB10-2 occupations (37 occupational main groups)


gen kldb10_2_imp = floor(kldb10_3_imp/10) 

quietly do "$prog\KldB10-2.do"
label values kldb10_2_imp kldb10_2
format %50.0f kldb10_2_imp

*tab kldb10_2_imp, m



*KldB10-1C occupations (10 occupational areas)


gen kldb10_1c_imp = floor(kldb10_2_imp/10) 

quietly do "$prog\KldB10-1C.do"
label values kldb10_1c_imp kldb10_1c
format %50.0f kldb10_1c_imp

tab kldb10_1c_imp, m




*KldB10-1B occupations (14 occupational segments)


gen kldb10_1b_imp = .
replace kldb10_1b_imp = 11 if ( kldb10_2_imp==11 | kldb10_2_imp==12  ) // agriculture, forestry and horticulture
replace kldb10_1b_imp = 12 if ( kldb10_2_imp==21 | kldb10_2_imp==22 | kldb10_2_imp==23 | kldb10_2_imp==24 | kldb10_2_imp==28 | kldb10_2_imp==93 ) // manufacturing
replace kldb10_1b_imp = 13 if ( kldb10_2_imp==25 | kldb10_2_imp==26 | kldb10_2_imp==27  ) // production technology
replace kldb10_1b_imp = 14 if ( kldb10_2_imp==31 | kldb10_2_imp==32 | kldb10_2_imp==33 | kldb10_2_imp==34 ) // building and interior construction
replace kldb10_1b_imp = 21 if ( kldb10_2_imp==29 | kldb10_2_imp==63  ) // food, gastronomy and tourism
replace kldb10_1b_imp = 22 if ( kldb10_2_imp==81 | kldb10_2_imp==82  ) // health care
replace kldb10_1b_imp = 23 if ( kldb10_2_imp==83 | kldb10_2_imp==84 | kldb10_2_imp==91 | kldb10_2_imp==94 ) // social sector and cultural work 
replace kldb10_1b_imp = 31 if ( kldb10_2_imp==61 | kldb10_2_imp==62  ) // commerce and trade
replace kldb10_1b_imp = 32 if ( kldb10_2_imp==71 ) // business management and organisation
replace kldb10_1b_imp = 33 if ( kldb10_2_imp==72 | kldb10_2_imp==73 | kldb10_2_imp==92 ) // business-related services 
replace kldb10_1b_imp = 41 if ( kldb10_2_imp==41 | kldb10_2_imp==42 | kldb10_2_imp==43 ) // IT and natural sciences
replace kldb10_1b_imp = 51 if ( kldb10_2_imp==53 | kldb10_2_imp== 1 ) // safety and security
replace kldb10_1b_imp = 52 if ( kldb10_2_imp==51 | kldb10_2_imp==52 ) // traffic and logistics
replace kldb10_1b_imp = 53 if ( kldb10_2_imp==54 ) // cleaning

quietly do "$prog\KldB10-1B.do"
label values kldb10_1b_imp kldb10_1b
format %50.0f kldb10_1b_imp

*tab kldb10_1b_imp, m



*KldB10-1A occupations (5 occupational sectors)

gen kldb10_1a_imp = floor(kldb10_1b_imp/10) 

quietly do "$prog\KldB10-1A.do"
label values kldb10_1a_imp kldb10_1a
format %50.0f kldb10_1a_imp

*tab kldb10_1a_imp, m


label variable kldb10_5_imp "Occupational Type (KldB10-5)"
label variable kldb10_4_imp "Occupational Sub-Group (KldB10-4)"
label variable kldb10_3_imp "Occupational Group (KldB10-3)"
label variable kldb10_2_imp "Occupational Main Group (KldB10-2)"
label variable kldb10_1c_imp "Occupational Area (KldB10-1C)"
label variable kldb10_1b_imp "Occupational Segment (KldB10-1B)"
label variable kldb10_1a_imp "Occupational Sector (KldB10-1A)"

drop kldb10_4_imp kldb10_3_imp kldb10_2_imp kldb10_1c_imp kldb10_1b_imp kldb10_1a_imp

compress kldb10_*




*** (N) OCCUPATION (ISCO 08)




*ISCO08-4 occupations (436 occupational unit groups)


preserve // use switching codes to translate KldB10 into ISCO08

	clear 

	import excel using "$orig\BeH\Umsteigeschluessel-KldB2010-ISCO-08.xls", cellrange(A5:F1508) sheet("Umsteiger KldB 2010 auf ISCO")

	rename A kldb10_5_imp 
	drop B
	rename C isco08_4_imp
	drop D
	rename E unambiguous
	rename F priority
	
	drop if _n==1
	
	label variable kldb10_5_imp "Occupational Subclass (KldB10-5)"
	label variable isco08_4_imp "Occupational Class (ISCO08-4)"
	label variable unambiguous "Unambiguous Switch (0=No, 1=Yes)"
	label variable priority "Priority of Switch"
	
	destring kldb10_5_imp isco08_4_imp unambiguous priority, replace
	
	tab priority if unambiguous==0, m // several possibilitites if switch is ambiguous
	tab priority if unambiguous==1, m // exactly one possibility if switch is unambiguous
	
	codebook isco08_4_imp // 420 from 436 ISCO08-4 categories are captured by translation --> 16 categories lost --> reason: rare occupations that are not available in Germany
	
	
	*concept: if switch is ambiguous, use possibility with highest priority
	
	keep if priority==1 // now: unambiguous switch from KldB10 to ISCO08
	
	tab priority, m
	
	drop unambiguous priority
	
	sort kldb10_5_imp
	
	codebook isco08_4_imp // 393 from 436 ISCO08-4 categories are captured by translation --> another 27 categories lost --> reason: occupation lost due to using switching codes with highest priority

	
	save "$data\KldB10_ISCO08.dta", replace 

	
restore


merge m:1 kldb10_5_imp using "$data\KldB10_ISCO08.dta", keepusing(isco08_4_imp)
drop if _merge==2 // not all 393 available ISCO08-4 occupations are identified in BeH
drop _merge

quietly do "$prog\ISCO08-4.do"
label values isco08_4_imp isco08_4
format %50.0f isco08_4_imp

*tab isco08_4_imp, m




*ISCO08-3 occupations (130 occupational minor groups)

gen isco08_3_imp = floor(isco08_4_imp/10) 

quietly do "$prog\ISCO08-3.do"
label values isco08_3_imp isco08_3
format %50.0f isco08_3_imp

*tab isco08_3_imp, m





*ISCO08-2 occupations (43 occupational sub-major groups)


gen isco08_2_imp = floor(isco08_3_imp/10) 

quietly do "$prog\ISCO08-2.do"
label values isco08_2_imp isco08_2
format %50.0f isco08_2_imp

*tab isco08_2_imp, m







*ISCO08-1 occupations (10 occupational major groups)


gen isco08_1_imp = floor(isco08_2_imp/10) 

quietly do "$prog\ISCO08-1.do"
label values isco08_1_imp isco08_1
format %50.0f isco08_1_imp

*tab isco08_1_imp, m




label variable isco08_4_imp "Occupational Unit Group (ISCO08-4)"
label variable isco08_3_imp "Occupational Minor Group (ISCO08-3)"
label variable isco08_2_imp "Occupational Sub-Major Group (ISCO08-2)"
label variable isco08_1_imp "Occupational Major Group (ISCO08-1)"


drop kldb10_5_imp isco08_1_imp

*drop if isco08_4_imp==. // do not drop to not bias hirings (when spell is dropped, next year's spell is artificially recognized as hire --> especially relevant for hires in 2012 as occupation is often missing in 2011 due to structural break in occupation variable)

compress isco08_*






*** (O) REGION ***



*NUTS07-3 regions (401 districts)


rename e_krs_schl_ao_akt_num nuts07_3_work // place of work 
rename e_krs_schl_wo_akt_num nuts07_3_home // place of residence

*tab nuts07_3, m
recode nuts07_3_work (-9=.) (-8=.) (-7=.) (-6=.) (-5=.) (20000=.)
recode nuts07_3_home (-9=.) (-8=.) (-7=.) (-6=.) (-5=.) (20000=.)



quietly do "$prog\NUTS07-3.do"
label values nuts07_3_work nuts07_3
format %50.0f nuts07_3_work

quietly do "$prog\NUTS07-3.do"
label values nuts07_3_home nuts07_3
format %50.0f nuts07_3_home

*tab nuts07_3_work, m
*tab nuts07_3_home, m



*functional urban areas (96 FUAs) as well as FUAs + independent NUTS-3 regions (241 regions)

tab e_gem_schl_ao_akt_num if e_gem_schl_ao_akt_num<0, m
tab e_gem_schl_wo_akt_num if e_gem_schl_wo_akt_num<0, m


rename e_gem_schl_ao_akt_num lau17_work
rename e_gem_schl_wo_akt_num lau17_home

recode lau17_work (-9=.) (-8=.) (-7=.) (-6=.) (-5=.) (20000000=.)
recode lau17_home (-9=.) (-8=.) (-7=.) (-6=.) (-5=.) (20000000=.)

drop if lau17_work==.
drop if lau17_home==.

drop lau17_* // not needed as assignment of FUAs in Germany is based on NUTS-3 regions

rename nuts07_3_work nuts07_3
merge m:1 nuts07_3 using "$data\BeH_FUA.dta", keepusing(nuts07_3_adj fua nuts07_3_fua nuts07_3_fua_adj)
drop _merge
rename nuts07_3 nuts07_3_work 

rename nuts07_3_adj nuts07_3_adj_work
rename fua fua_work
rename nuts07_3_fua nuts07_3_fua_work
rename nuts07_3_fua_adj nuts07_3_fua_adj_work

*tab fua_work, m
*tab nuts07_3_fua_work, m
*tab nuts07_3_fua_adj_work, m


rename nuts07_3_home nuts07_3
merge m:1 nuts07_3 using "$data\BeH_FUA.dta", keepusing(nuts07_3_adj fua nuts07_3_fua nuts07_3_fua_adj)
drop _merge
rename nuts07_3 nuts07_3_home 

rename nuts07_3_adj nuts07_3_adj_home
rename fua fua_home
rename nuts07_3_fua nuts07_3_fua_home
rename nuts07_3_fua_adj nuts07_3_fua_adj_home

*tab nuts07_3_adj_home, m
*tab fua_home, m
*tab nuts07_3_fua_home, m
*tab nuts07_3_fua_adj_home, m



*adjusted NUTS07-3 regions (371 districts)

*tab nuts07_3_adj_work, m
*tab nuts07_3_adj_home, m



*NUTS07-2 regions (38 government regions)

gen nuts07_2_work = floor(nuts07_3_work/100) 
gen nuts07_2_home = floor(nuts07_3_home/100) 


*tab nuts07_2_work, m
*tab nuts07_2_home, m

quietly do "$prog\NUTS07-2.do"
label values nuts07_2_work nuts07_2
format %50.0f nuts07_2_work

quietly do "$prog\NUTS07-2.do"
label values nuts07_2_home nuts07_2
format %50.0f nuts07_2_home

*tab nuts07_2_work, m
*tab nuts07_2_home, m



*NUTS07-1 regions (16 federal states)

gen nuts07_1_work = floor(nuts07_2_work/10) 
gen nuts07_1_home = floor(nuts07_2_home/10) 


*tab nuts07_1_work, m
*tab nuts07_1_home, m

quietly do "$prog\NUTS07-1.do"
label values nuts07_1_work nuts07_1

quietly do "$prog\NUTS07-1.do"
label values nuts07_1_home nuts07_1

*tab nuts07_1_work, m
*tab nuts07_1_home, m



*West/East Germany  (2 territories)


tab ow_knz, m

rename ow_knz east
recode east (1=0) (2=1) (-9=.) (-8=.) (-7=.) (-6=.) (-5=.) (3=.)

tab east, m
label variable east "Workplace in East Germany (incl. East Berlin) (0=No, 1=Yes)"

label define east 0 "0 No" 1 "1 Yes" 
label values east east

*tab east, m




label variable fua_work "Functional Urban Area"
label variable nuts07_3_fua_work "FUA + District (NUTS07-3)"
label variable nuts07_3_fua_adj_work "FUA + District (NUTS07-3)"
label variable nuts07_3_work "District (NUTS07-3)"
label variable nuts07_3_adj_work "District (NUTS07-3)"
label variable nuts07_2_work "Government Region (NUTS07-2)"
label variable nuts07_1_work "Federal State (NUTS07-1)"

label variable fua_home "Functional Urban Area"
label variable nuts07_3_fua_home "FUA + District (NUTS07-3)"
label variable nuts07_3_fua_adj_home "FUA + District (NUTS07-3)"
label variable nuts07_3_home "District (NUTS07-3)"
label variable nuts07_3_adj_home "District (NUTS07-3)"
label variable nuts07_2_home "Government Region (NUTS07-2)"
label variable nuts07_1_home "Federal State (NUTS07-1)"

drop nuts07_1_* nuts07_2_* east



compress fua_* nuts07_* // east

*drop if nuts07_3_work==. // do not drop to not bias hirings (when spell is dropped, next year's spell is artificially recognized as hire)

sort prs_id year betnr ieb_fall_id
order prs_id year betnr ieb_fall_id start end type parttime_imp wz08_2_imp isco08_2_imp isco08_3_imp isco08_4_imp nuts07_3_work nuts07_3_adj_work fua_work nuts07_3_fua_work nuts07_3_fua_adj_work nuts07_3_home nuts07_3_adj_home fua_home nuts07_3_fua_home nuts07_3_fua_adj_home




*** (P) INFLOW/HIRE ***




*week-year concept

gen week_13_start = mdy( 3, 25, year) // 25 March of each year
gen week_13_end = mdy( 3, 31, year) // 31 March of each year

gen week_13 = ( start<=week_13_end & end>=week_13_start )
drop week_13_start 

gen week_26_start = mdy( 6, 24, year) // 24 June of each year
gen week_26_end = mdy( 6, 30, year) // 30 June of each year

gen week_26 = ( start<=week_26_end & end>=week_26_start )
drop week_26_start 

gen week_39_start = mdy( 9, 24, year) // 24 September of each year
gen week_39_end = mdy( 9, 30, year) // 30 September of each year

gen week_39 = ( start<=week_39_end & end>=week_39_start )
drop week_39_start 

gen week_52_start = mdy( 12, 25, year) // 25 December of each year
gen week_52_end = mdy( 12, 31, year) // 31 December of each year

gen week_52 = ( start<=week_52_end & end>=week_52_start )
drop week_52_start 



tab week_13, m	
tab week_26, m
tab week_39, m
tab week_52, m


label variable week_13 "Active Spell in 13th Calendar Week (0=No, 1=Yes)"
label variable week_26 "Active Spell in 26th Calendar Week (0=No, 1=Yes)"
label variable week_39 "Active Spell in 39th Calendar Week (0=No, 1=Yes)"
label variable week_52 "Active Spell in 52th Calendar Week (0=No, 1=Yes)"


label define week 0 "0 No" 1 "1 Yes"
label values week_13 week_26 week_39 week_52 week




*month-year concept

gen month_03_start = mdy( 3, 01, year) // 01 March of each year
gen month_03_end = mdy( 3, 31, year) // 31 March of each year

gen month_03 = ( start<=month_03_end & end>=month_03_start )
drop month_03_start 

gen month_06_start = mdy( 6, 01, year) // 01 June of each year
gen month_06_end = mdy( 6, 30, year) // 30 June of each year

gen month_06 = ( start<=month_06_end & end>=month_06_start )
drop month_06_start 

gen month_09_start = mdy( 9, 01, year) // 01 September of each year
gen month_09_end = mdy( 9, 30, year) // 30 September of each year

gen month_09 = ( start<=month_09_end & end>=month_09_start )
drop month_09_start 

gen month_12_start = mdy( 12, 01, year) // 01 December of each year
gen month_12_end = mdy( 12, 31, year) // 31 December of each year

gen month_12 = ( start<=month_12_end & end>=month_12_start )
drop month_12_start 


tab month_03, m	
tab month_06, m
tab month_09, m
tab month_12, m


label variable month_03 "Active Spell in March (0=No, 1=Yes)"
label variable month_06 "Active Spell in June (0=No, 1=Yes)"
label variable month_09 "Active Spell in September (0=No, 1=Yes)"
label variable month_12 "Active Spell in December (0=No, 1=Yes)"


label define month 0 "0 No" 1 "1 Yes"
label values month_03 month_06 month_09 month_12 month



*year concept

gen year_01_start = mdy( 01, 01, year) // 01 January of each year
gen year_01_end = mdy( 12, 31, year) // 31 December of each year

gen year_01 = ( start<=year_01_end & end>=year_01_start )
drop year_01_start 

tab year_01, m

label variable year_01 "Active Spell (0=No, 1=Yes)"

label define year 0 "0 No" 1 "1 Yes"
label values year_01 year



*drop start end

compress week_* month_* year_* *_end



sort betnr prs_id year ieb_fall_id  // ensure stable sorting with "ieb_fall_id" for reproducability

save "$data\LMC_1019_V3.dta", replace







*inflow measurement

local flow week_13 week_26 week_39 week_52 month_03 month_06 month_09 month_12 year_01 

foreach x of local flow { // loop over hiring concepts


	display "Inflow Concept: `x'"

	
	*extract relevant spells
	
	use "$data\LMC_1019_V3.dta", clear
	
	


	
	keep if `x'==1
	
	keep betnr prs_id year ieb_fall_id type start end beh_tag_entg duration `x'_end
	
	sort betnr prs_id year ieb_fall_id // ensure stable sorting with "ieb_fall_id" for reproducability
	order betnr prs_id year ieb_fall_id start end type beh_tag_entg duration *_end 
	
	
	*keep only most important spell for person-establishment-period triple
	
	*note: spells with same occupation, region and type --> it does not matter for HHI computation which duplicate is dropped (0.08% of spells)

	*duplicates report betnr year prs_id contract nuts07_3 fua nuts07_3_fua isco08_4_imp, force // without "ieb_fall_id"



	*delete multiple employment relationships between person and a certain establishment within one year
	*source: Ganzer et al. (2020, p.17)	


	*delete multiple person-firm combinations within one year

	by betnr prs_id year: gen multi = _N 
	tab multi, m 

	gen filter = 0
	
	
	*1st step: delete spells shorter than 30 days at the end of reference period
	
	gen duration_end = `x'_end - start + 1
	tab duration_end, m
	
	replace filter = 1 if duration_end<30
	
	preserve
	
		keep if filter==1
		
		keep betnr prs_id year ieb_fall_id filter
		
		save "$data\inflow_`x'_V1.dta", replace
		
	restore
	
	drop if filter==1
	tab filter, m
	
	drop multi 
	by betnr prs_id year: gen multi = _N 
	tab multi, m 
	

	*2nd step: delete marginal employment, if there is simultaneous non-marginal employment and marginal employment

	by betnr prs_id year: egen nonmarginal = sum(type!=3)
	tab nonmarginal, m

	replace filter = 1 if type==3 & multi>=2 & nonmarginal>=1

	
	preserve
	
		keep if filter==1
		
		keep betnr prs_id year ieb_fall_id filter
		
		save "$data\inflow_`x'_V2.dta", replace
		
	restore
	
	drop if filter==1
	tab filter, m
	
	drop multi 
	by betnr prs_id year: gen multi = _N 
	tab multi, m 


	*3rd step: select observation with highest value for "beh_tag_entgelt" (when there is a tie: select observation with higher duration)

	sort betnr prs_id year ieb_fall_id // ensure stable sorting with "ieb_fall_id" for reproducability 
	
	by betnr prs_id year: egen rank_w = rank(-beh_tag_entg) // no missing rank values because of missing values
	by betnr prs_id year: egen rank_d = rank(-duration) // no missing rank values because of missing values

	order betnr prs_id year multi rank_w beh_tag_entg rank_d duration
	sort betnr prs_id year rank_w rank_d ieb_fall_id // ensure stable sorting with "ieb_fall_id" for reproducability 

	by betnr prs_id year: gen rank = _n
	order betnr prs_id year rank
	sort betnr prs_id year rank ieb_fall_id // ensure stable sorting with "ieb_fall_id" for reproducability 

	replace filter = 1 if rank!=1 

	preserve
	
		keep if filter==1
		
		keep betnr prs_id year ieb_fall_id filter
		
		save "$data\inflow_`x'_V3.dta", replace
		
	restore
	
	drop if filter==1
	tab filter, m
	
	drop multi 
	by betnr prs_id year: gen multi = _N 
	tab multi, m // each person-establishment-year triple enters the data only once

	drop rank* multi nonmarginal beh_tag_entg duration start end type `x'_end 

		
	*define inflows

	bysort betnr prs_id year: gen N = _N // note: this routine requires that there is only one spell per establishment-person-year triple
	tab N, m
	drop N

	bysort betnr prs_id (year): gen n = _n // number observations per person within establishment
	tab n, m
	
	gen inflow_`x' = 0 

	bysort betnr prs_id (year): replace inflow_`x' = 1 if n==1 // first employment for certain establishment (from 2010 onwards)
	bysort betnr prs_id (year): replace inflow_`x' = 1 if n!=1 & !missing(n) & year[_n-1]+1!=year[_n] // another recruitment by the same establishment in later years
	replace inflow_`x' = . if year==2010 // reason: observations in 2010 are always "hired" by construction as this is the first year in the data extract --> this year must be removed later on

	drop n

	label variable inflow_`x' "Inflow (0=No, 1=Yes)"

	label define inflow 0 "0 No" 1 "1 Yes" 
	label values inflow_`x' inflow

	tab inflow_`x', m
	
	tab filter, m
	
	
	if `"`x'"'=="year_01" { // only for year concept
	
		preserve
	
			keep ieb_fall_id
			sort ieb_fall_id
			save "$data\LMC_1019_V3_Arnold.dta", replace // save this dataset to identify only one spell for establishment-person-year triple (necessary for calculation of mobility patterns for Arnold-type HHI)
	
		restore
	
	}
	
	
	append using "$data\inflow_`x'_V1.dta"
	append using "$data\inflow_`x'_V2.dta"
	append using "$data\inflow_`x'_V3.dta"

	keep betnr prs_id year ieb_fall_id duration_end filter inflow_`x'
	
	tab filter, m
	

	
	

	
	*note: differentiate between two variables
	*- hire: use as a left-/right-hand side variable in regressions --> for duration<30, assign value of .; for multiple spells, assign inflow=0/1 depending on the inflow status of the main employment spell for the same establishment-person-year triple 
	*- inflow: use for construction of HHI values --> do not count duration<30 or multiple employment spells for establishment-person-year triples --> set inflow==0
	
	
	clonevar hire_`x' = inflow_`x'
	
	sort betnr prs_id year inflow_`x' // main employment spell (inflow=0/1) always prior to other employment spells (inflow=.) after sorting
	by betnr prs_id year: replace hire_`x' = inflow_`x'[1]
	
	replace hire_`x' = . if filter==1 & duration_end<30 	
	replace hire_`x' = . if filter==1 & year==2010 	

	
	replace inflow_`x' = 0 if filter==1 & year!=2010
	replace inflow_`x' = . if filter==1 & year==2010
	
	

	
	
	tab filter inflow_`x', m
	
	tab filter hire_`x', m


	keep ieb_fall_id inflow_`x' hire_`x'

	sort ieb_fall_id
	
	compress inflow_`x' hire_`x'

	save "$data\inflow_`x'.dta", replace
	
	erase "$data\inflow_`x'_V1.dta"
	erase "$data\inflow_`x'_V2.dta"
	erase "$data\inflow_`x'_V3.dta"

}












*** (Q) EMPLOYMENT ***




*employment measurement

local flow week_13 week_26 week_39 week_52 month_03 month_06 month_09 month_12 year_01 
foreach x of local flow { // loop over hiring concepts


	display "Employment Concept: `x'"

	
	*extract relevant spells
	
	use "$data\LMC_1019_V3.dta", clear
	
	
	
	keep if `x'==1
	
	keep betnr prs_id year ieb_fall_id type start end beh_tag_entg duration `x'_end
	
	sort betnr prs_id year ieb_fall_id // ensure stable sorting with "ieb_fall_id" for reproducability
	order betnr prs_id year ieb_fall_id start end type beh_tag_entg duration *_end
	
	
	*keep only most important spell for person-establishment-period triple
	
	*note: spells with same occupation, region and type --> it does not matter for HHI computation which duplicate is dropped (0.08% of spells)

	*duplicates report betnr year prs_id contract nuts07_3 fua nuts07_3_fua isco08_4_imp, force // without "ieb_fall_id"



	*delete multiple employment relationships between person and a certain establishment within one year
	*source: Ganzer et al. (2020, p.17)	


	*delete multiple person-firm combinations within one year

	by betnr prs_id year: gen multi = _N 
	tab multi, m 

	gen filter = 0
	
	
	*1st step: delete spells shorter than 30 days at the end of reference period
	
	gen duration_end = `x'_end - start + 1
	tab duration_end, m
	
	replace filter = 1 if duration_end<30
	
	preserve
	
		keep if filter==1
		
		keep betnr prs_id year ieb_fall_id filter
		
		save "$data\employment_`x'_V1.dta", replace
		
	restore
	
	drop if filter==1
	tab filter, m
	
	drop multi 
	by betnr prs_id year: gen multi = _N 
	tab multi, m 
	

	*2nd step: delete marginal employment, if there is simultaneous non-marginal employment and marginal employment

	by betnr prs_id year: egen nonmarginal = sum(type!=3)
	tab nonmarginal, m

	replace filter = 1 if type==3 & multi>=2 & nonmarginal>=1

	
	preserve
	
		keep if filter==1
		
		keep betnr prs_id year ieb_fall_id filter
		
		save "$data\employment_`x'_V2.dta", replace
		
	restore
	
	drop if filter==1
	tab filter, m
	
	drop multi 
	by betnr prs_id year: gen multi = _N 
	tab multi, m 


	*3rd step: select observation with highest value for "beh_tag_entgelt" (when there is a tie: select observation with higher duration)

	sort betnr prs_id year ieb_fall_id // ensure stable sorting with "ieb_fall_id" for reproducability 
	
	by betnr prs_id year: egen rank_w = rank(-beh_tag_entg) // no missing rank values because of missing values
	by betnr prs_id year: egen rank_d = rank(-duration) // no missing rank values because of missing values

	order betnr prs_id year multi rank_w beh_tag_entg rank_d duration
	sort betnr prs_id year rank_w rank_d ieb_fall_id // ensure stable sorting with "ieb_fall_id" for reproducability 

	by betnr prs_id year: gen rank = _n
	order betnr prs_id year rank
	sort betnr prs_id year rank ieb_fall_id // ensure stable sorting with "ieb_fall_id" for reproducability 

	replace filter = 1 if rank!=1 

	preserve
	
		keep if filter==1
		
		keep betnr prs_id year ieb_fall_id filter
		
		save "$data\employment_`x'_V3.dta", replace
		
	restore
	
	drop if filter==1
	tab filter, m
	
	drop multi 
	by betnr prs_id year: gen multi = _N 
	tab multi, m // each person-establishment-year triple enters the data only once

	drop rank* multi nonmarginal beh_tag_entg duration start end type `x'_end 

		
	*define employment
	
	tab filter, m
	
	gen employment_`x' = 1

	label variable employment_`x' "Employment (0=No, 1=Yes)"

	label define employment 0 "0 No" 1 "1 Yes" 
	label values employment_`x' inflow

	tab employment_`x', m
	
	tab filter, m
	
	append using "$data\employment_`x'_V1.dta"
	append using "$data\employment_`x'_V2.dta"
	append using "$data\employment_`x'_V3.dta"

	keep betnr prs_id year ieb_fall_id duration_end filter employment_`x'
	
	tab filter, m
	
	replace employment_`x' = 0 if filter==1 
	
	tab filter employment_`x', m


	keep ieb_fall_id employment_`x' 

	sort ieb_fall_id
	
	compress employment_`x'

	save "$data\employment_`x'.dta", replace
	
	erase "$data\employment_`x'_V1.dta"
	erase "$data\employment_`x'_V2.dta"
	erase "$data\employment_`x'_V3.dta"

}



























































use "$data\LMC_1019_V3.dta", clear


sort ieb_fall_id

drop *_end


merge 1:1 ieb_fall_id using "$data\inflow_week_13.dta", keepusing(inflow_week_13)
replace inflow_week_13 = . if _merge==1 // spells that do not include reference period
drop _merge

merge 1:1 ieb_fall_id using "$data\inflow_week_26.dta", keepusing(inflow_week_26)
replace inflow_week_26 = . if _merge==1 // spells that do not include reference period
drop _merge

merge 1:1 ieb_fall_id using "$data\inflow_week_39.dta", keepusing(inflow_week_39)
replace inflow_week_39 = . if _merge==1 // spells that do not include reference period
drop _merge

merge 1:1 ieb_fall_id using "$data\inflow_week_52.dta", keepusing(inflow_week_52)
replace inflow_week_52 = . if _merge==1 // spells that do not include reference period
drop _merge



merge 1:1 ieb_fall_id using "$data\inflow_month_03.dta", keepusing(inflow_month_03)
replace inflow_month_03 = . if _merge==1 // spells that do not include reference period
drop _merge

merge 1:1 ieb_fall_id using "$data\inflow_month_06.dta", keepusing(inflow_month_06)
replace inflow_month_06 = . if _merge==1 // spells that do not include reference period
drop _merge

merge 1:1 ieb_fall_id using "$data\inflow_month_09.dta", keepusing(inflow_month_09)
replace inflow_month_09 = . if _merge==1 // spells that do not include reference period
drop _merge

merge 1:1 ieb_fall_id using "$data\inflow_month_12.dta", keepusing(inflow_month_12)
replace inflow_month_12 = . if _merge==1 // spells that do not include reference period
drop _merge



merge 1:1 ieb_fall_id using "$data\inflow_year_01.dta", keepusing(inflow_year_01)
replace inflow_year_01 = . if _merge==1  // spells that do not include reference period, here==0 as no spells are dropped in year concept
drop _merge








merge 1:1 ieb_fall_id using "$data\employment_week_13.dta", keepusing(employment_week_13)
replace employment_week_13 = . if _merge==1 // spells that do not include reference period
drop _merge

merge 1:1 ieb_fall_id using "$data\employment_week_26.dta", keepusing(employment_week_26)
replace employment_week_26 = . if _merge==1 // spells that do not include reference period
drop _merge

merge 1:1 ieb_fall_id using "$data\employment_week_39.dta", keepusing(employment_week_39)
replace employment_week_39 = . if _merge==1 // spells that do not include reference period
drop _merge

merge 1:1 ieb_fall_id using "$data\employment_week_52.dta", keepusing(employment_week_52)
replace employment_week_52 = . if _merge==1 // spells that do not include reference period
drop _merge



merge 1:1 ieb_fall_id using "$data\employment_month_03.dta", keepusing(employment_month_03)
replace employment_month_03 = . if _merge==1 // spells that do not include reference period
drop _merge

merge 1:1 ieb_fall_id using "$data\employment_month_06.dta", keepusing(employment_month_06)
replace employment_month_06 = . if _merge==1 // spells that do not include reference period
drop _merge

merge 1:1 ieb_fall_id using "$data\employment_month_09.dta", keepusing(employment_month_09)
replace employment_month_09 = . if _merge==1 // spells that do not include reference period
drop _merge

merge 1:1 ieb_fall_id using "$data\employment_month_12.dta", keepusing(employment_month_12)
replace employment_month_12 = . if _merge==1 // spells that do not include reference period
drop _merge



merge 1:1 ieb_fall_id using "$data\employment_year_01.dta", keepusing(employment_year_01)
replace employment_year_01 = . if _merge==1  // spells that do not include reference period, here==0 as no spells are dropped in year concept
drop _merge


compress












*** 1.2.6 RELEVANT EMPLOYMENT SPELLS ***



*when using hourly gross wages (after 1999):
*not relevant here

*when using hourly gross wages (before 1999):
*restrict to workers (FT & PT) in regular/other employment, apprentices and in partial retirement
*not relevant here

*when using daily gross wages: 
*further restrict to full-time workers in regular/other employment
*not relevant here

tab type, m
tab type parttime, m

*keep if (type==1 | type==2 | type==3 | type==4 | type==5 | type==6 | type==7 | type==. )

*keep if regoth==1
*keep if regothft==1


drop if type == .

*drop if duration==.

*drop if parttime_imp==.



tab wz08_2_imp, m
keep if (wz08_2_imp>=5 & wz08_2_imp<=82) | wz08_2_imp==90 | (wz08_2_imp>=92 & wz08_2_imp<=96)  // keep only non-agricultural business sector


tab wz08_2_imp, m


*drop if isco08_2_imp==.
*drop if isco08_3_imp==.
gen isco08_4_imp_miss = (isco08_4_imp==.)
tab year isco08_4_imp_miss, m // many missings in 2010 and especially 2011, about 500,000 missings in 2012
drop isco08_4_imp_miss

drop if isco08_4_imp==.


drop if nuts07_3_work==.
*drop if fua_work==. // do not delete --> many municipalities without FUA
*drop if nuts07_3_fua_work==.  


*drop if nuts07_3_home==.
*drop if fua_home==. // do not delete --> many municipalities without FUA
*drop if nuts07_3_fua_home==.  


drop duration beh_tag_entg

sort prs_id year betnr ieb_fall_id
order prs_id year betnr ieb_fall_id type parttime_imp wz08_* isco08_* nuts07_3_* nuts07_3_adj_* fua_* nuts07_3_fua_* nuts07_3_fua_adj_* week_* month_* year_* inflow_week_* inflow_month_* inflow_year_* employment_week_* employment_month_* employment_year_*


compress

 
save "$data\LMC_1019.dta", replace 






		


*** 1.3 LABOR MARKET CONCENTRATION: INFLOWS ***


*note: different X-digit ISCO occupations add up to each other, i.e. each 4-digit ISCO occupations belongs to exactly one 3-digit ISCO occupation --> 1:1 relationship, i.e. collapse command can be simultaneously executed for different digits of ISCO occupations
*however: this feature does not hold for regions, i.e. not all NUTS-3 regions belong to a FUA (some also belong to two different FUAs) --> not a perfect 1:1 relationship, i.e. separate collapse commands necessary



*create dataset with number of workers per occupation-region-establishment-year combination




foreach z of numlist 1/5 {  


	display "NUTS07-`z'"


	use "$data\LMC_1019.dta", replace 

	rename fua_work nuts07_1
	rename nuts07_3_fua_work nuts07_2
    rename nuts07_3_work nuts07_3
   	rename nuts07_3_fua_adj_work nuts07_4
	rename nuts07_3_adj_work nuts07_5
	

		

	keep if year>=2012 // note: KldB10 (necessary for ISCO08) only available since 2012, inflows in 2010 cannot be measured (first year)

	keep if year<=2018 // note: not yet all BeH spells collected in 2019 --> HHI would be overestimated

	*drop if isco08_4_imp==. // already deleted above
	drop if nuts07_`z'==. // some municipalities without FUA --> do not calculate concentration measures for these spells		   
			
	

	collapse (sum) L_week_13_jt=employment_week_13 L_week_26_jt=employment_week_26 L_week_39_jt=employment_week_39 L_week_52_jt=employment_week_52 L_month_03_jt=employment_month_03 L_month_06_jt=employment_month_06 L_month_09_jt=employment_month_09 L_month_12_jt=employment_month_12 L_year_01_jt=employment_year_01 ///
	               H_week_13_jt=inflow_week_13 H_week_26_jt=inflow_week_26 H_week_39_jt=inflow_week_39 H_week_52_jt=inflow_week_52 H_month_03_jt=inflow_month_03 H_month_06_jt=inflow_month_06 H_month_09_jt=inflow_month_09 H_month_12_jt=inflow_month_12 H_year_01_jt=inflow_year_01 ///
				   , by(betnr year isco08_2_imp isco08_3_imp isco08_4_imp nuts07_`z')

	   
	*duplicates report betnr year // there are duplicates --> reason: each establishment-year observation can employ several different occupations

		
	if `"`z'"'=="1" {
	
		rename nuts07_1 fua_work
		
	}
	
	
	
	else if `"`z'"'=="2" {
	
		rename nuts07_2 nuts07_3_fua_work
	}
	
	
	
	else if `"`z'"'=="3" {
	
		rename nuts07_3 nuts07_3_work
	}
	
	
	
	else if `"`z'"'=="4" {
	
		rename nuts07_4 nuts07_3_fua_adj_work
	}
		
		
		
	else if `"`z'"'=="5" {
	
		rename nuts07_5 nuts07_3_adj_work
	}	
	
	
	
	
	save "$data\LMC_`z'_1218.dta", replace 

}



*calculate labor market concentration

local flow week_13 week_26 week_39 week_52 month_03 month_06 month_09 month_12 year_01 

local isco 4 3 2



foreach y of local isco {


	if `"`y'"'=="4" { // for 4-digit occupations: calculate HHI for all types of regions
			
				local nuts 1 2 3 4 5 
			}
			

	if `"`y'"'=="3" | `"`y'"'=="2" { // for 2 or 3-digit occupations: calculate HHI for baseline type of region (#4)
			
				local nuts 4 // 1 2 3 5 
			}
			


	foreach z of local nuts {

		display "Labor Market Concentration: ISCO08-`y' x NUTS07-`z'"
	
		quietly {

			use "$data\LMC_`z'_1218.dta", clear
			
				

			if `"`z'"'=="1" {
			
				rename fua_work nuts07_1
			}
			
			
			
			else if `"`z'"'=="2" {
			
				rename nuts07_3_fua_work nuts07_2
			}
			
			
			else if `"`z'"'=="3" {
			
				rename nuts07_3_work nuts07_3
			}
				
			
			
			else if `"`z'"'=="4" {
			
				rename nuts07_3_fua_adj_work nuts07_4
			}
				
				
			
			else if `"`z'"'=="5" {
			
				rename nuts07_3_adj_work nuts07_5
			}	
			
	
			
			keep betnr year isco08_`y'_imp nuts07_`z' L_week_13_jt L_week_26_jt L_week_39_jt L_week_52_jt L_month_03_jt L_month_06_jt L_month_09_jt L_month_12_jt L_year_01_jt H_week_13_jt H_week_26_jt H_week_39_jt H_week_52_jt H_month_03_jt H_month_06_jt H_month_09_jt H_month_12_jt H_year_01_jt 

			sort isco08_`y'_imp nuts07_`z' year betnr
			order isco08_`y'_imp nuts07_`z' year betnr L_week_13_jt L_week_26_jt L_week_39_jt L_week_52_jt L_month_03_jt L_month_06_jt L_month_09_jt L_month_12_jt L_year_01_jt H_week_13_jt H_week_26_jt H_week_39_jt H_week_52_jt H_month_03_jt H_month_06_jt H_month_09_jt H_month_12_jt H_year_01_jt 
			
			
			
			foreach x of local flow { // loop over all hiring concepts
			
	
			bysort isco08_`y'_imp nuts07_`z' year: egen L_`x'_`y'_`z' = total(L_`x'_jt) // number of workers per labor market --> frequency weight
			bysort isco08_`y'_imp nuts07_`z' year: egen H_`x'_`y'_`z' = total(H_`x'_jt) // number of hires per labor market --> necessary for computation of HHI + frequency weight
			bysort isco08_`y'_imp nuts07_`z' year: egen N_H_`x'_`y'_`z' = sum(H_`x'_jt>=1) // number of hiring establishments per labor market --> necessary for computation of INS

			
			gen s_H_`x'_`y'_`z'_jt = H_`x'_jt / H_`x'_`y'_`z'


			count if s_H_`x'_`y'_`z'_jt==0

			drop L_`x'_jt H_`x'_jt
			
			}

			


			foreach x of local flow {

				
				*** HERFINDAHL-HIRSCHMAN INDEX


				gen s_j_2 = (s_H_`x'_`y'_`z'_jt)^2

				bysort isco08_`y'_imp nuts07_`z' year: egen HHI_`x'_`y'_`z' = total(s_j_2)
				replace HHI_`x'_`y'_`z' = . if HHI_`x'_`y'_`z'==0 & s_H_`x'_`y'_`z'_jt==. // sum of missings = 0 --> only relevant for markets and hiring concepts with zero hires

				drop s_j_2 s_H_`x'_`y'_`z'_jt


				*** INVERSE NUMBER OF SUBJECTS

				gen INS_`x'_`y'_`z' = 1 / N_H_`x'_`y'_`z'
				
				drop N_H_`x'_`y'_`z'
				
					
			}
			
			*collapse information on concentration measures
			
			sort isco08_`y'_imp nuts07_`z' year
			collapse (first) HHI_week_13_`y'_`z' HHI_week_26_`y'_`z' HHI_week_39_`y'_`z' HHI_week_52_`y'_`z' HHI_month_03_`y'_`z' HHI_month_06_`y'_`z' HHI_month_09_`y'_`z' HHI_month_12_`y'_`z' HHI_year_01_`y'_`z'  ///
							 INS_week_13_`y'_`z' INS_week_26_`y'_`z' INS_week_39_`y'_`z' INS_week_52_`y'_`z' INS_month_03_`y'_`z' INS_month_06_`y'_`z' INS_month_09_`y'_`z' INS_month_12_`y'_`z' INS_year_01_`y'_`z'  ///
							 H_week_13_`y'_`z' H_week_26_`y'_`z' H_week_39_`y'_`z' H_week_52_`y'_`z' H_month_03_`y'_`z' H_month_06_`y'_`z' H_month_09_`y'_`z' H_month_12_`y'_`z' H_year_01_`y'_`z'  ///
							 L_week_13_`y'_`z' L_week_26_`y'_`z' L_week_39_`y'_`z' L_week_52_`y'_`z' L_month_03_`y'_`z' L_month_06_`y'_`z' L_month_09_`y'_`z' L_month_12_`y'_`z' L_year_01_`y'_`z'  ///
							 , by(isco08_`y'_imp nuts07_`z' year)
			
			order isco08_`y'_imp nuts07_`z' year
			sort isco08_`y'_imp nuts07_`z' year
			


			save "$data\LMC_`y'_`z'_1218_V1.dta", replace
				
			
			
			*create table with all X-digit occupation classifications

			keep isco08_`y'_imp 
			duplicates drop

			sort isco08_`y'_imp 

			save "$data\ISCO08_`y'.dta", replace 


			*create dataset with an observation for each region-year combination and fill with information from dataset

			use "$data\LMC_`y'_`z'_1218_V1.dta", clear
					

			keep isco08_`y'_imp nuts07_`z' 
			duplicates drop

			xtset nuts07_`z' isco08_`y'_imp   // order matters

			xtdescribe
			tsfill, full // fill missing isco08_`y'_imp observations

			xtset, clear


			*delete non-existent occupation classifications (that were mistakenly created by "tsfill" command)

			merge m:1 isco08_`y'_imp using "$data\ISCO08_`y'.dta"

			sort isco08_`y'_imp nuts07_`z' 
			drop if _merge==1  // Y regions * Z industries  = YZ labor markets
			drop _merge


			*add year variable

			expand 7 // 7 years (2012-2018)

			sort isco08_`y'_imp nuts07_`z' 

			by isco08_`y'_imp nuts07_`z' : gen year = _n + 2011  // Y regions * Z industries * T years = YZT observations


			*merge initial information 


			merge 1:1 isco08_`y'_imp nuts07_`z' year using "$data\LMC_`y'_`z'_1218_V1.dta"
					

			sort isco08_`y'_imp nuts07_`z' year


			foreach x of local flow {

				replace HHI_`x'_`y'_`z' = . if _merge==1
				replace INS_`x'_`y'_`z' = . if _merge==1
				replace H_`x'_`y'_`z' = 0 if _merge==1
				replace L_`x'_`y'_`z' = 0 if _merge==1

			}


			drop _merge



			save "$data\LMC_`y'_`z'_1218_V2.dta", replace
					
					

			*** IV: LEAVE-ONE-OUT-MEAN FOR INVERSE NUMBER OF ESTABLISHMENTS IN SAME INDUSTRY-YEAR (AND HHI)


			use "$data\LMC_`y'_`z'_1218_V2.dta", clear
					
			keep isco08_`y'_imp year nuts07_`z' INS_week_13_`y'_`z' INS_week_26_`y'_`z' INS_week_39_`y'_`z' INS_week_52_`y'_`z' INS_month_03_`y'_`z' INS_month_06_`y'_`z' INS_month_09_`y'_`z' INS_month_12_`y'_`z' INS_year_01_`y'_`z' HHI_week_13_`y'_`z' HHI_week_26_`y'_`z' HHI_week_39_`y'_`z' HHI_week_52_`y'_`z' HHI_month_03_`y'_`z' HHI_month_06_`y'_`z' HHI_month_09_`y'_`z' HHI_month_12_`y'_`z' HHI_year_01_`y'_`z' 
			order isco08_`y'_imp year nuts07_`z' INS_week_13_`y'_`z' INS_week_26_`y'_`z' INS_week_39_`y'_`z' INS_week_52_`y'_`z' INS_month_03_`y'_`z' INS_month_06_`y'_`z' INS_month_09_`y'_`z' INS_month_12_`y'_`z' INS_year_01_`y'_`z' HHI_week_13_`y'_`z' HHI_week_26_`y'_`z' HHI_week_39_`y'_`z' HHI_week_52_`y'_`z' HHI_month_03_`y'_`z' HHI_month_06_`y'_`z' HHI_month_09_`y'_`z' HHI_month_12_`y'_`z' HHI_year_01_`y'_`z' 
			sort isco08_`y'_imp year nuts07_`z' INS_week_13_`y'_`z' INS_week_26_`y'_`z' INS_week_39_`y'_`z' INS_week_52_`y'_`z' INS_month_03_`y'_`z' INS_month_06_`y'_`z' INS_month_09_`y'_`z' INS_month_12_`y'_`z' INS_year_01_`y'_`z' HHI_week_13_`y'_`z' HHI_week_26_`y'_`z' HHI_week_39_`y'_`z' HHI_week_52_`y'_`z' HHI_month_03_`y'_`z' HHI_month_06_`y'_`z' HHI_month_09_`y'_`z' HHI_month_12_`y'_`z' HHI_year_01_`y'_`z' 
			

			foreach x of local flow {
				
				gen ln_INS_`x'_`y'_`z' = ln(INS_`x'_`y'_`z')
				gen ln_HHI_`x'_`y'_`z' = ln(HHI_`x'_`y'_`z')

				drop INS_`x'_`y'_`z' HHI_`x'_`y'_`z'

				bysort isco08_`y'_imp year: egen ln_INS_mean_`x'_`y'_`z' = mean(ln_INS_`x'_`y'_`z')
				bysort isco08_`y'_imp year: egen ln_HHI_mean_`x'_`y'_`z' = mean(ln_HHI_`x'_`y'_`z')


				by isco08_`y'_imp year: egen n_`x'_`y'_`z' = sum(!missing(ln_INS_`x'_`y'_`z'))

				tab n_`x'_`y'_`z', m

				gen ln_INS_loom_`x'_`y'_`z' = [ ( ln_INS_mean_`x'_`y'_`z' * n_`x'_`y'_`z' ) - ln_INS_`x'_`y'_`z' ] / (n_`x'_`y'_`z'-1)
				gen ln_HHI_loom_`x'_`y'_`z' = [ ( ln_HHI_mean_`x'_`y'_`z' * n_`x'_`y'_`z' ) - ln_HHI_`x'_`y'_`z' ] / (n_`x'_`y'_`z'-1)

				replace ln_INS_loom_`x'_`y'_`z' = . if ln_INS_`x'_`y'_`z'==. 
				replace ln_HHI_loom_`x'_`y'_`z' = . if ln_HHI_`x'_`y'_`z'==. 

			}

			

			keep isco08_`y'_imp year nuts07_`z' ln_INS_loom_week_13_`y'_`z' ln_INS_loom_week_26_`y'_`z' ln_INS_loom_week_39_`y'_`z' ln_INS_loom_week_52_`y'_`z' ln_INS_loom_month_03_`y'_`z' ln_INS_loom_month_06_`y'_`z' ln_INS_loom_month_09_`y'_`z' ln_INS_loom_month_12_`y'_`z' ln_INS_loom_year_01_`y'_`z' ln_HHI_loom_week_13_`y'_`z' ln_HHI_loom_week_26_`y'_`z' ln_HHI_loom_week_39_`y'_`z' ln_HHI_loom_week_52_`y'_`z' ln_HHI_loom_month_03_`y'_`z' ln_HHI_loom_month_06_`y'_`z' ln_HHI_loom_month_09_`y'_`z' ln_HHI_loom_month_12_`y'_`z' ln_HHI_loom_year_01_`y'_`z' 

			
			

			merge 1:1 isco08_`y'_imp year nuts07_`z' using "$data\LMC_`y'_`z'_1218_V2.dta"
			drop _merge

			
			
			save "$data\LMC_`y'_`z'_1218_V3.dta", replace


			
			 

			*rename variables
			
			foreach x of local flow {
			
				label variable HHI_`x'_`y'_`z' "Herfindahl-Hirschman Index"
				label variable INS_`x'_`y'_`z' "Inverse Number of Subjects"
				label variable ln_INS_loom_`x'_`y'_`z' "LOOM for Inverse Number of Subjects"
				label variable ln_HHI_loom_`x'_`y'_`z' "LOOM for HHI"

				label variable H_`x'_`y'_`z' "Number of Hires"
				label variable L_`x'_`y'_`z' "Number of Workers"
			}


			label variable year "Year"


			
			sort isco08_`y'_imp nuts07_`z' year
			order isco08_`y'_imp nuts07_`z' year HHI_* INS_* ln_HHI_loom_* ln_INS_loom_*  H_* L_*

			
			
			
			if `"`y'"'=="2" {
			
				label variable isco08_2_imp "Occupational Main Group (ISCO08-2)" // 43x
			}
			
			
			else if `"`y'"'=="3" {
			
				label variable isco08_3_imp "Occupational Group (ISCO08-3)" // 130x
			}
			
			
			else if `"`y'"'=="4" {
			
				label variable isco08_4_imp "Occupational Sub-Group (ISCO08-4)" // 436x
			}
			

			
			

			
			
			if `"`z'"'=="1" {
			
				rename nuts07_1 fua_work
				label variable fua_work "Functional Urban Area" // 96x
			}
			
			
			
			else if `"`z'"'=="2" {
			
				rename nuts07_2 nuts07_3_fua_work
				label variable nuts07_3_fua_work "FUA + District (NUTS07-3 Region)" // 251x
			}
			
			

			
			else if `"`z'"'=="3" {
			
				rename nuts07_3 nuts07_3_work
				label variable nuts07_3_work "District (NUTS07-3)" // 401x
			}
			
			
			
			else if `"`z'"'=="4" {
		
				rename nuts07_4 nuts07_3_fua_adj_work
				label variable nuts07_3_fua_adj_work "FUA + District (NUTS07-3 Region)" // 240x

			
			}
			
			
			
			else if `"`z'"'=="5" {
			
				rename nuts07_5 nuts07_3_adj_work
				label variable nuts07_3_adj_work "District (NUTS07-3)" // 371x

			}	
			
			
		
				

			save "$data\LMC_`y'_`z'_1218.dta", replace 

			
			erase "$data\LMC_`y'_`z'_1218_V1.dta"
			erase "$data\LMC_`y'_`z'_1218_V2.dta"
			erase "$data\LMC_`y'_`z'_1218_V3.dta"
			
		}
	
	}

}


















*** 1.4 LABOR MARKET CONCENTRATION: EMPLOYMENT ***


*note: different X-digit ISCO occupations add up to each other, i.e. each 4-digit ISCO occupations belongs to exactly one 3-digit ISCO occupation --> 1:1 relationship, i.e. collapse command can be simultaneously executed for different digits of ISCO occupations
*however: this feature does not hold for regions, i.e. not all NUTS-3 regions belong to a FUA (some also belong to two different FUAs) --> not a perfect 1:1 relationship, i.e. separate collapse commands necessary



*create dataset with number of workers per occupation-region-establishment-year combination







foreach z of numlist 1/5 {  


	display "NUTS07-`z'"


	use "$data\LMC_1019.dta", replace 

	rename fua_work nuts07_1
	rename nuts07_3_fua_work nuts07_2
    rename nuts07_3_work nuts07_3
   	rename nuts07_3_fua_adj_work nuts07_4
	rename nuts07_3_adj_work nuts07_5
		

	keep if year>=2012 // note: KldB10 (necessary for ISCO08) only available since 2012, inflows in 2010 cannot be measured (first year)

	keep if year<=2018 // note: not yet all BeH spells collected in 2019 --> HHI would be overestimated

	*drop if isco08_4_imp==. // already deleted above
	drop if nuts07_`z'==. // some municipalities without FUA --> do not calculate concentration measures for these spells		   
			
	

	collapse (sum) L_week_13_jt=employment_week_13 L_week_26_jt=employment_week_26 L_week_39_jt=employment_week_39 L_week_52_jt=employment_week_52 L_month_03_jt=employment_month_03 L_month_06_jt=employment_month_06 L_month_09_jt=employment_month_09 L_month_12_jt=employment_month_12 L_year_01_jt=employment_year_01 ///
	               H_week_13_jt=inflow_week_13 H_week_26_jt=inflow_week_26 H_week_39_jt=inflow_week_39 H_week_52_jt=inflow_week_52 H_month_03_jt=inflow_month_03 H_month_06_jt=inflow_month_06 H_month_09_jt=inflow_month_09 H_month_12_jt=inflow_month_12 H_year_01_jt=inflow_year_01 ///
				   , by(betnr year isco08_2_imp isco08_3_imp isco08_4_imp nuts07_`z')

	   
	*duplicates report betnr year // there are duplicates --> reason: each establishment-year observation can employ several different occupations

		
	if `"`z'"'=="1" {
	
		rename nuts07_1 fua_work
		
	}
	
	
	
	else if `"`z'"'=="2" {
	
		rename nuts07_2 nuts07_3_fua_work
	}
	
	
	
	else if `"`z'"'=="3" {
	
		rename nuts07_3 nuts07_3_work
	}
	
	
	
	else if `"`z'"'=="4" {
	
		rename nuts07_4 nuts07_3_fua_adj_work
	}
		
		
		
	else if `"`z'"'=="5" {
	
		rename nuts07_5 nuts07_3_adj_work
	}	
	
	
	
	save "$data\LMC_`z'_1218.dta", replace 

}



*calculate labor market concentration

local flow week_13 week_26 week_39 week_52 month_03 month_06 month_09 month_12 year_01 // 

local isco 4 3 2



foreach y of local isco {


	if `"`y'"'=="4" { // for 4-digit occupations: calculate HHI for all types of regions
			
				local nuts 4 1 2 3 5 
			}
			

	if `"`y'"'=="3" | `"`y'"'=="2" { // for 2 or 3-digit occupations: calculate HHI for baseline type of region (#4)
			
				local nuts 4 // 1 2 3 5 
			}
			


	foreach z of local nuts {

		display "Labor Market Concentration: ISCO08-`y' x NUTS07-`z'"
	
		quietly {

			use "$data\LMC_`z'_1218.dta", clear
			
				

			if `"`z'"'=="1" {
			
				rename fua_work nuts07_1
			}
			
			
			
			else if `"`z'"'=="2" {
			
				rename nuts07_3_fua_work nuts07_2
			}
			
			
			else if `"`z'"'=="3" {
			
				rename nuts07_3_work nuts07_3
			}
				
			
			
			else if `"`z'"'=="4" {
			
				rename nuts07_3_fua_adj_work nuts07_4
			}
				
				
			
			else if `"`z'"'=="5" {
			
				rename nuts07_3_adj_work nuts07_5
			}	
			
				
			keep betnr year isco08_`y'_imp nuts07_`z' L_week_13_jt L_week_26_jt L_week_39_jt L_week_52_jt L_month_03_jt L_month_06_jt L_month_09_jt L_month_12_jt L_year_01_jt H_week_13_jt H_week_26_jt H_week_39_jt H_week_52_jt H_month_03_jt H_month_06_jt H_month_09_jt H_month_12_jt H_year_01_jt 

			sort isco08_`y'_imp nuts07_`z' year betnr
			order isco08_`y'_imp nuts07_`z' year betnr L_week_13_jt L_week_26_jt L_week_39_jt L_week_52_jt L_month_03_jt L_month_06_jt L_month_09_jt L_month_12_jt L_year_01_jt H_week_13_jt H_week_26_jt H_week_39_jt H_week_52_jt H_month_03_jt H_month_06_jt H_month_09_jt H_month_12_jt H_year_01_jt 
			
			
			
			foreach x of local flow { // loop over all hiring concepts
			
	
			bysort isco08_`y'_imp nuts07_`z' year: egen H_`x'_`y'_`z' = total(H_`x'_jt) // number of hires per labor market --> frequency weight
			bysort isco08_`y'_imp nuts07_`z' year: egen L_`x'_`y'_`z' = total(L_`x'_jt) // number of workers per labor market --> necessary for computation of HHI + frequency weight
			bysort isco08_`y'_imp nuts07_`z' year: egen N_L_`x'_`y'_`z' = sum(L_`x'_jt>=1) // number of employing establishments per labor market --> necessary for computation of INS

			
			gen s_L_`x'_`y'_`z'_jt = L_`x'_jt / L_`x'_`y'_`z'


			count if s_L_`x'_`y'_`z'_jt==0

			drop H_`x'_jt L_`x'_jt
			
			}

			


			foreach x of local flow {

				
				*** HERFINDAHL-HIRSCHMAN INDEX


				gen s_j_2 = (s_L_`x'_`y'_`z'_jt)^2

				bysort isco08_`y'_imp nuts07_`z' year: egen HHI_L_`x'_`y'_`z' = total(s_j_2)
				replace HHI_L_`x'_`y'_`z' = . if HHI_L_`x'_`y'_`z'==0 & s_L_`x'_`y'_`z'_jt==. // sum of missings = 0 --> only relevant for markets and employment concepts with zero employment

				drop s_j_2 s_L_`x'_`y'_`z'_jt


				*** INVERSE NUMBER OF SUBJECTS

				gen INS_L_`x'_`y'_`z' = 1 / N_L_`x'_`y'_`z'
				
				drop N_L_`x'_`y'_`z'
				
					
			}
			
			*collapse information on concentration measures
			
			sort isco08_`y'_imp nuts07_`z' year
			collapse (first) HHI_L_week_13_`y'_`z' HHI_L_week_26_`y'_`z' HHI_L_week_39_`y'_`z' HHI_L_week_52_`y'_`z' HHI_L_month_03_`y'_`z' HHI_L_month_06_`y'_`z' HHI_L_month_09_`y'_`z' HHI_L_month_12_`y'_`z' HHI_L_year_01_`y'_`z'  ///
							 INS_L_week_13_`y'_`z' INS_L_week_26_`y'_`z' INS_L_week_39_`y'_`z' INS_L_week_52_`y'_`z' INS_L_month_03_`y'_`z' INS_L_month_06_`y'_`z' INS_L_month_09_`y'_`z' INS_L_month_12_`y'_`z' INS_L_year_01_`y'_`z'  ///
							 L_week_13_`y'_`z' L_week_26_`y'_`z' L_week_39_`y'_`z' L_week_52_`y'_`z' L_month_03_`y'_`z' L_month_06_`y'_`z' L_month_09_`y'_`z' L_month_12_`y'_`z' L_year_01_`y'_`z'  ///
							 H_week_13_`y'_`z' H_week_26_`y'_`z' H_week_39_`y'_`z' H_week_52_`y'_`z' H_month_03_`y'_`z' H_month_06_`y'_`z' H_month_09_`y'_`z' H_month_12_`y'_`z' H_year_01_`y'_`z'  ///
							 , by(isco08_`y'_imp nuts07_`z' year)
			
			order isco08_`y'_imp nuts07_`z' year
			sort isco08_`y'_imp nuts07_`z' year
			


			save "$data\LMC_L_`y'_`z'_1218_V1.dta", replace
				
			
			
			*create table with all X-digit occupation classifications

			keep isco08_`y'_imp 
			duplicates drop

			sort isco08_`y'_imp 

			save "$data\ISCO08_`y'.dta", replace 


			*create dataset with an observation for each region-year combination and fill with information from dataset

			use "$data\LMC_L_`y'_`z'_1218_V1.dta", clear
					

			keep isco08_`y'_imp nuts07_`z' 
			duplicates drop

			xtset nuts07_`z' isco08_`y'_imp   // order matters

			xtdescribe
			tsfill, full // fill missing isco08_`y'_imp observations

			xtset, clear


			*delete non-existent industry classifications (that were mistakenly created by "tsfill" command)

			merge m:1 isco08_`y'_imp using "$data\ISCO08_`y'.dta"

			sort isco08_`y'_imp nuts07_`z' 
			drop if _merge==1  // Y regions * Z industries  = YZ labor markets
			drop _merge


			*add year variable

			expand 7 // 7 years (2012-2018)

			sort isco08_`y'_imp nuts07_`z' 

			by isco08_`y'_imp nuts07_`z' : gen year = _n + 2011  // Y regions * Z industries * T years = YZT observations


			*merge initial information 


			merge 1:1 isco08_`y'_imp nuts07_`z' year using "$data\LMC_L_`y'_`z'_1218_V1.dta"
					

			sort isco08_`y'_imp nuts07_`z' year


			foreach x of local flow {

				replace HHI_L_`x'_`y'_`z' = . if _merge==1
				replace INS_L_`x'_`y'_`z' = . if _merge==1
				replace H_`x'_`y'_`z' = 0 if _merge==1
				replace L_`x'_`y'_`z' = 0 if _merge==1

			}


			drop _merge



			save "$data\LMC_L_`y'_`z'_1218_V2.dta", replace
					
					

			*** IV: LEAVE-ONE-OUT-MEAN FOR INVERSE NUMBER OF ESTABLISHMENTS IN SAME INDUSTRY-YEAR (AND HHI)


			use "$data\LMC_L_`y'_`z'_1218_V2.dta", clear
					
			keep isco08_`y'_imp year nuts07_`z' INS_L_week_13_`y'_`z' INS_L_week_26_`y'_`z' INS_L_week_39_`y'_`z' INS_L_week_52_`y'_`z' INS_L_month_03_`y'_`z' INS_L_month_06_`y'_`z' INS_L_month_09_`y'_`z' INS_L_month_12_`y'_`z' INS_L_year_01_`y'_`z' HHI_L_week_13_`y'_`z' HHI_L_week_26_`y'_`z' HHI_L_week_39_`y'_`z' HHI_L_week_52_`y'_`z' HHI_L_month_03_`y'_`z' HHI_L_month_06_`y'_`z' HHI_L_month_09_`y'_`z' HHI_L_month_12_`y'_`z' HHI_L_year_01_`y'_`z' 
			order isco08_`y'_imp year nuts07_`z' INS_L_week_13_`y'_`z' INS_L_week_26_`y'_`z' INS_L_week_39_`y'_`z' INS_L_week_52_`y'_`z' INS_L_month_03_`y'_`z' INS_L_month_06_`y'_`z' INS_L_month_09_`y'_`z' INS_L_month_12_`y'_`z' INS_L_year_01_`y'_`z' HHI_L_week_13_`y'_`z' HHI_L_week_26_`y'_`z' HHI_L_week_39_`y'_`z' HHI_L_week_52_`y'_`z' HHI_L_month_03_`y'_`z' HHI_L_month_06_`y'_`z' HHI_L_month_09_`y'_`z' HHI_L_month_12_`y'_`z' HHI_L_year_01_`y'_`z' 
			sort isco08_`y'_imp year nuts07_`z' INS_L_week_13_`y'_`z' INS_L_week_26_`y'_`z' INS_L_week_39_`y'_`z' INS_L_week_52_`y'_`z' INS_L_month_03_`y'_`z' INS_L_month_06_`y'_`z' INS_L_month_09_`y'_`z' INS_L_month_12_`y'_`z' INS_L_year_01_`y'_`z' HHI_L_week_13_`y'_`z' HHI_L_week_26_`y'_`z' HHI_L_week_39_`y'_`z' HHI_L_week_52_`y'_`z' HHI_L_month_03_`y'_`z' HHI_L_month_06_`y'_`z' HHI_L_month_09_`y'_`z' HHI_L_month_12_`y'_`z' HHI_L_year_01_`y'_`z' 
			

			foreach x of local flow {
				
				gen ln_INS_L_`x'_`y'_`z' = ln(INS_L_`x'_`y'_`z')
				gen ln_HHI_L_`x'_`y'_`z' = ln(HHI_L_`x'_`y'_`z')

				drop INS_L_`x'_`y'_`z' HHI_L_`x'_`y'_`z'

				bysort isco08_`y'_imp year: egen ln_INS_L_mean_`x'_`y'_`z' = mean(ln_INS_L_`x'_`y'_`z')
				bysort isco08_`y'_imp year: egen ln_HHI_L_mean_`x'_`y'_`z' = mean(ln_HHI_L_`x'_`y'_`z')


				by isco08_`y'_imp year: egen n_`x'_`y'_`z' = sum(!missing(ln_INS_L_`x'_`y'_`z'))

				tab n_`x'_`y'_`z', m

				gen ln_INS_L_loom_`x'_`y'_`z' = [ ( ln_INS_L_mean_`x'_`y'_`z' * n_`x'_`y'_`z' ) - ln_INS_L_`x'_`y'_`z' ] / (n_`x'_`y'_`z'-1)
				gen ln_HHI_L_loom_`x'_`y'_`z' = [ ( ln_HHI_L_mean_`x'_`y'_`z' * n_`x'_`y'_`z' ) - ln_HHI_L_`x'_`y'_`z' ] / (n_`x'_`y'_`z'-1)

				replace ln_INS_L_loom_`x'_`y'_`z' = . if ln_INS_L_`x'_`y'_`z'==. 
				replace ln_HHI_L_loom_`x'_`y'_`z' = . if ln_HHI_L_`x'_`y'_`z'==. 

			}

			

			keep isco08_`y'_imp year nuts07_`z' ln_INS_L_loom_week_13_`y'_`z' ln_INS_L_loom_week_26_`y'_`z' ln_INS_L_loom_week_39_`y'_`z' ln_INS_L_loom_week_52_`y'_`z' ln_INS_L_loom_month_03_`y'_`z' ln_INS_L_loom_month_06_`y'_`z' ln_INS_L_loom_month_09_`y'_`z' ln_INS_L_loom_month_12_`y'_`z' ln_INS_L_loom_year_01_`y'_`z' ln_HHI_L_loom_week_13_`y'_`z' ln_HHI_L_loom_week_26_`y'_`z' ln_HHI_L_loom_week_39_`y'_`z' ln_HHI_L_loom_week_52_`y'_`z' ln_HHI_L_loom_month_03_`y'_`z' ln_HHI_L_loom_month_06_`y'_`z' ln_HHI_L_loom_month_09_`y'_`z' ln_HHI_L_loom_month_12_`y'_`z' ln_HHI_L_loom_year_01_`y'_`z' 

			
			

			merge 1:1 isco08_`y'_imp year nuts07_`z' using "$data\LMC_L_`y'_`z'_1218_V2.dta"
			drop _merge

			
			
			save "$data\LMC_L_`y'_`z'_1218_V3.dta", replace


			
			

			*rename variables
			
			foreach x of local flow {
								
				label variable HHI_L_`x'_`y'_`z' "Herfindahl-Hirschman Index"
				label variable INS_L_`x'_`y'_`z' "Inverse Number of Subjects"
				label variable ln_INS_L_loom_`x'_`y'_`z' "LOOM for Inverse Number of Subjects"

				label variable H_`x'_`y'_`z' "Number of Hires"
				label variable L_`x'_`y'_`z' "Number of Workers"
			}


			label variable year "Year"


			
			sort isco08_`y'_imp nuts07_`z' year
			order isco08_`y'_imp nuts07_`z' year HHI_L_* INS_L_* ln_HHI_L_loom_* ln_INS_L_loom_*  H_* L_*

			
			
			
			if `"`y'"'=="2" {
			
				label variable isco08_2_imp "Occupational Main Group (ISCO08-2)" // 43x
			}
			
			
			else if `"`y'"'=="3" {
			
				label variable isco08_3_imp "Occupational Group (ISCO08-3)" // 130x
			}
			
			
			else if `"`y'"'=="4" {
			
				label variable isco08_4_imp "Occupational Sub-Group (ISCO08-4)" // 436x
			}
			

			
			

			
			
			if `"`z'"'=="1" {
			
				rename nuts07_1 fua_work
				label variable fua_work "Functional Urban Area" // 96x
			}
			
			
			
			else if `"`z'"'=="2" {
			
				rename nuts07_2 nuts07_3_fua_work
				label variable nuts07_3_fua_work "FUA + District (NUTS07-3 Region)" // 251x
			}
			
			

			
			else if `"`z'"'=="3" {
			
				rename nuts07_3 nuts07_3_work
				label variable nuts07_3_work "District (NUTS07-3)" // 401x
			}
			
			
			
			else if `"`z'"'=="4" {
		
				rename nuts07_4 nuts07_3_fua_adj_work
				label variable nuts07_3_fua_adj_work "FUA + District (NUTS07-3 Region)" // 240x

			
			}
			
			
			
			else if `"`z'"'=="5" {
			
				rename nuts07_5 nuts07_3_adj_work
				label variable nuts07_3_adj_work "District (NUTS07-3)" // 371x

			}	
						

			save "$data\LMC_L_`y'_`z'_1218.dta", replace 

			
			erase "$data\LMC_L_`y'_`z'_1218_V1.dta"
			erase "$data\LMC_L_`y'_`z'_1218_V2.dta"
			erase "$data\LMC_L_`y'_`z'_1218_V3.dta"
			
		}
	
	}

}


